 
#!/bin/bash
#! 
#!   Standard GNU General Public License Software:
#! 
#!
#! Development "CTB"    (B)asic version   (5)version
#! CTB is the product of a "Case and Hack" process on a FOSS project by 2byte, et al.
#! CTB is written for Linux Puppy OS, frugal install (saveDirectory or saveFile.4fs).
#!
#! CTB tested only on "official" Puppy distributions
#!   not on the many personal distros, which may have dependency problems.  
#! CTB tested on 32bit, 64bit, saveDIRECTORY, and saveFILE.4FS systems. 
#! CTB tested on 10 running frugal installs regularly, on 2010 XP class computers.  
#! CTB v.5 has no CTB_ScanList ( have removed ScanList, ScanOne , extra note dumps ) 
#!
#! CTB maintains some code (gcCTBmode) which controls ScanList options 
#!    available in the CTB-SL (ScanList) version.  
#! CTB :  ScanList and extra note dumps are culled.
#!
 
#!(######################################################################
#!
#!  System Developer Initial DOB is "gcSysDevDob'
export gcSysDevDobPrev="220623-0045" 
export gcSysDevDobPrev="221127-0630" 
export gcSysDevDob="221209-1407"     
export gcSysDevDob="230101-1925-(09)"    ###
#!(######################################################################
#!( System Developer ID name of this Linux BASH script is "CTB"
export gcSysDevId="CTB"	    #   'B' 'A' 'U'   
export gcSysDevVer="5.1"
#!(######################################################################
#
PATH=$PATH:/usr/lib/gtkdialog/
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_SetVerDts() {     # ACTIVE
export gcCTBparam1="$1"	## "B"  , "U"  , "A"  ## options for "local" control .
export gcCTBparam2="$2" ## "RS" , "RB" , "RQ" ## options to match manager "MGN.sh" .
export gcCTBparam3="$3"
. /etc/DISTRO_SPECS
. /etc/rc.d/PUPSTATE
case "${gcCTBparam1}" in	
	"B") gcCTBmode="B"  && gcCTBmodeName="Basic"   && gcCTBmodeId="CTB" ;;	
	"U") gcCTBmode="U"  && gcCTBmodeName="Utility" && gcCTBmodeId="CTU" ;;	
	"A") gcCTBmode="A"  && gcCTBmodeName="Auto"    && gcCTBmodeId="CTA" ;;	
	### *) 	gcCTBmode="U"	&& gcCTBmodeName="Utility" && gcCTBmodeId="CTU" ;;	
	*) 	 gcCTBmode="B"	&& gcCTBmodeName="Basic" && gcCTBmodeId="CTB" ;;	
	### *)  	gcCTBmode="A"	&& gcCTBmodeName="Auto" && gcCTBmodeId="CTA" ;;	
esac
export gcCTBmode="${gcCTBmode}"	
export gcCTBmodeName="${gcCTBmodeName}"	
export gcCtbZeroRun="$0"
#
#(!=== begin: Config Reader ===============================================
gcCtbConfigFN="/root/my-applications/bin/CTB_config"	
gcCtbConfigTrgPrefix=""			
#!
if [ ${gcCTBmode} = "B" ] ; then	
	if [ -f ${gcCtbConfigFN} ]  ; then  
		n=0
		gcCtbConfigTrgPrefix=`cat ${gcCtbConfigFN}`
	else	
		lnDummy=1
        touch ${gcCtbConfigFN} 	
	fi
fi # end: fi [ ${gcCTBmode} = "B" ] 
export gcCtbConfigTrgPrefix="${gcCtbConfigTrgPrefix}"	
#!=== end: Config Reader ==============================================
#	
} #( end: fx(Sys_SetVerDts) 
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_Str2DevTrm() {  # ACTIVE   "String to Display/Terminal" 
lcS2TStr=${1}   
lcS2TClr=${2}   
lcS2TMrg=${3}  	
lcS2Topt=${4}   
lcDevConsole=""  
lcS2Topt=${4}	## "C"onsole  or  "T"erminal
case "${lcS2Topt}" in
   "C") lcDevConsole=" > /dev/console" ;;   # : not used by CTB 
   "T") lcDevConsole="" ;;                  # : "T"erminal display for Geany Execute Terminal 
    *)  lcDevConsole="" ;;                  # : default to Std Out is "T"erminal display
esac 
case "${lcS2TMrg}" in
   0|"0") /bin/echo -n -e "\\033[0G"    >/dev/console ;; 
    *) /bin/echo -n -e "\\033[${lcS2TMrg}G"    >/dev/console ;;
esac
case "${lcS2TClr}" in
		""|"0")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;;
		 *)  /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; 
esac
	/bin/echo -n "$lcS2TStr"  ${lcDevConsole} # string ending 
	/bin/echo -e "\\033[0;m"  ${lcDevConsole} 
	return  0
} # end: Sys_Str2DevTrm 
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function CTB_ClearFlgSys() {    # ACTIVE
	n=0
    rm -f "${CTB_FlgLockFile}"          # release GUI 'Running'.
    rm -f "${CTB_FlgBackupStatus}"      # release GUI display var
    rm -f "/tmp/box_help"               # used by fx HELP and fx FAQ  
	rm -f /tmp/flagnextpassthru			# special from SMP or TarOpt
	rm -f /tmp/snapmergepuppy-error		# special from SMP
	rm -f /tmp/delayedrun_finished_flag	# special during CTB, via call from MGN. 
	#
} # end: fx(CTB_ClearFlgSys)
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sbr_Box_Message() {  # ACTIVE
n=0
if [ "$1" ] ; then
	Box_Msg_Heading="${1}"	
else	
	Box_Msg_Heading="$(gettext '---Sbr_Box_Message---')"
fi
#
#! # CTB "Box_MessageXML" process loads the "/tmp/box_help" with options. 
export Box_MessageXML='
<window title="'$Box_Msg_Heading'" default-height="570" default-width="750">
<vbox space-expand="true" space-fill="true">
  <vbox space-expand="true" space-fill="true">
    <vbox scrollable="true" shadow-type="3" space-expand="true" space-fill="true">
      <vbox space-expand="false" space-fill="false">
        <text xpad="10" ypad="15" use-markup="true"><input file>'/tmp/box_help'</input></text>
      </vbox>
    </vbox>
  </vbox>
  <hbox space-expand="false" space-fill="false">
    <button>
      '"`/usr/lib/gtkdialog/xml_button-icon ok`"'
      <label>'$(gettext 'Ok')'</label>
    </button>
  </hbox>
</vbox>
</window>'
#
gtkdialog --center  -p Box_MessageXML	# assumes /tmp/box_help
} #( end: fx(Box_MessageXML)
#
function Sys_Box_HLP() {    #  CTB Active
    n=0
	lcFileHelpTxt="/tmp/box_help"	#(:  required by gtkdialog original source code. 
	#
    echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "====="</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"  CTB HLP "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "=====" </span></span>
<span foreground='"'green'"'>"  "  v: ${gcSysDevDob}"  "</span> " glene77is --- v.5 "
<b><span foreground='"'red'"'>"---------------------------------------------------------"</span></b>
<b><span foreground='"'red'"'>" 	Cold-Tar-Backup method is this  : "</span></b>
<b><span foreground='"'green'"'>" Click "BackUp" for simple single Backup "</span></b>
	or
<b><span foreground='"'red'"'>"---------------------------------------------------------"</span></b>
<b><span foreground='"'red'"'>" IF you want to write the Tar.Gz file to SPECIAL subdir"</span></b>
<b><span foreground='"'brown'"'>"THEN write '/CTB_config.sh'  "</span></b>
<b><span foreground='"'brown'"'>"... Read method is 'cat' into 'var' "</span></b>
<b><span foreground='"'brown'"'>"... cat will pull out ALL contents"</span></b>
<b><span foreground='"'brown'"'>"...   including any embedded quote marks"</span></b>
<b><span foreground='"'brown'"'>"... good example is:   /mnt/home/   "</span></b>
<span foreground='"'red'"'>"CTB calls Tar.gz for fast backup "</span>
<b><span foreground='"'green'"'>"'TAR' the 'Unix Tape ARchive' method"</span></b>
<span foreground='"'blue'"'>"CTB is designed specifically for "</span>
<span foreground='"'red'"'>"    "Official" Puppy Linux"</span>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFOLDER"</span></b>
<b><span foreground='"'green'"'>"Puppy 32/64-bit FRUGAL SaveFILE.4fs"</span></b>
<b>1)</b> CTB <b>automatically appends
   the "DTS yr-mo-dy-seconds" stamp</b>
   to the Backup file .tar.gz name.
   This kills possible duplications !
<b>2)</b> CTB <b>automatically pre-Runs 
	"SnapMergePuppy"</b> to update/merge 
	the RAM into the 'saveDATA'.
<b><span foreground='"'darkred'"'>CTB will back-up from 'source'->'target'</span></b>
... exactly as prescribed in 'PUPSTATE'.
<b><span foreground='"'darkred'"'>CTB is controlled by the 'PUPSTATE' var</span></b>
... as written by the Puppy Linux OS .
<b><span foreground='"'darkred'"'>CTB 'PUPSTATE' contains the "State" values</span></b>
... of the currently running Puppy OS.
<b><span foreground='"'darkred'"'>CTB will use <span foreground='"'green'"'>'PUPSTATE'</span> data</span></b>
... to find the Source and Target .
<b><span foreground='"'darkred'"'>CTB can be <span foreground='"'green'"'>MODIFIED</span> to back-up</span></b>
... ANY 'source' to any 'target'.
To RESTORE:
''XArchive', will 'Extract all' from inside 
<b>saveDATA-CTB---tar.gz</b> file.
<b><span foreground='"'darkred'"'>"Note: When Running Executable BASH script :"</span></b>
Always check the file "\'set action\'"
... ' $ @ '  'Use-Command'
Always check the file "\'type\'"
... 'Exec'
Always check the file "\'Properties\'"
... 'Exec'
Always check the file "\'Permissions\'"
...'Executable'
Always examine other running scripts
to see how Your System is setting things.
... end of file 'HELP' text ..................................."\
> ${lcFileHelpTxt}   # /tmp/box_help	
Sbr_Box_Message "=${DISTRO_NAME} = HELP = gtk 'Sbr_Box_Message' and /tmp/box_help"
} #(: end: Sys_Help_Box
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_PupState() {    # ACTIVE
    tcVerDtsTmpPS="${gcSysDevDob}"  
    . /etc/rc.d/PUPSTATE
    gcSysDevDob="${tcVerDtsTmpPS}"  
    lcPupSave=${PUPSAVE}
    
    lcPupSaveNameCut="`echo $lcPupSave | cut -f 3 -d "/"`" 
    lcPupSaveNameSrc="${lcPupSaveNameCut}" 
    lcFileNameDTS="/0-CTB-DTS"
    touch -f "${lcFileNameDTS}"	
    lcPupSaveNameTrgTmp="${lcPupSaveNameSrc}-CTB-`date +%y%m%d-%H%M-%S`"     
    lcPupSaveNameTrg="${lcPupSaveNameTrgTmp}.tar.gz"
} #( end: fx(Sys_PupState)
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function CTB_ReStart() {    # ACTIVE
        
    rm -f "${CTB_FlgLockFile}"     
    rm -f "${CTB_FlgBackupStatus}" 
    ${gcCtbZeroRun}     ### rc.z_CTB.sh 
} # end: fx(CTB_ReStart)
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function CTB_StartUp() {    # sbr Main()  #  ACTIVE
    #!  CTB_StartUp calls to Set Version DTS subroutine
    Sys_SetVerDts   
    #!  CTB_StartUp calls for Puppy "STATE" file data to be loaded. 
    Sys_PupState        
     
    export CTB_REFRESH_INTERVAL=1000 
    #! flags show the "BackUp" or "DONE" status in "BackUp buttom" of GUI.
    export CTB_BackUpStatus="/tmp/CTB_BackUp_Status"
    #! flags generate/export the name of the 'lock-file', unique to "CTB" program.
    export CTB_FlgLockFile="/tmp/CTB_FlgLockFile"
    export CTB_PupSaveDataName="/mnt/home"`grep PUPSAVE /etc/rc.d/PUPSTATE | cut -f 3 -d "," | cut -f 1 -d "'" ` 
    lcSaveData="`echo $lcPupSave | cut -f 3 -d ","`"
    export CTB_PUPSAVE_PATH="/mnt/home${lcSaveData}"
    export -f Sys_Str2DevTrm
    export -f CTB_TrgFilename
    export -f Sys_Box_HLP   
    export -f CTB_ReStart
    export -f CTB_ClearFlgSys
    export -f CTB_BackUpRun
    echo "" 
    #! aa="$(du -c -m -s ${CTB_PupSaveDataName} )"     # error flag on Zero-length file 
    aa="$(du -c -m -s ${CTB_PupSaveDataName} )"     # error flag on Zero-length file 
    #! read -r b ccc <<< "$aa"
    read -r b ccc <<< "$aa"
    lcPupRamObj="${b}"
    export lcPupRamObjMsg=" # Source saveDATA Size : ${lcPupRamObj} MB # "
    echo "" > /dev/console
} # end: fx(CTB_StartUp)
#
#(!
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function CTB_TrgFilename()  {   # ACTIVE on main gui splash
    n=0
    lcMsgSpacer="           : " #  used for display spacer on gui screen.
    echo -n " ${lcMsgSpacer} Backup DTS .ext : -CTB-`date +%y%m%d-%H%M-%S`        "  
} #( end: fx(CTB_TrgFilename)
#
#!
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function CTB_BackUpRun() {    # ACTIVE 
	n=0
lcDialogColor="  -fg yellow    -bg blue "
lcMsgStr="--- ${gcCTBmodeId} Running Backup ---"    # splash "RUNNING" background yel/red splash 
/usr/lib/gtkdialog/box_splash ${lcDialogColor}  -border true -close never \
-text " 
.              ${lcMsgStr}              
.
.
.
.
.
.
" &
		GTKPIDRUNNING=${!}
        sleep 1  
    Sys_SYNC
    Sys_SMP
        PWDir="$PWD"
        CWDir=$PWDir  # Swap Working Directories, CWDir=$PWDir , /Root into /Current .
    lcDialogColor="  -fg yellow    -bg darkred "
/usr/lib/gtkdialog/box_splash ${lcDialogColor} -border true -close never -text "
.   .. Please Wait .. ${gcSysDevDob} .. ${gcCTBmodeName}
. Cold-Tar-Backup is Creating 'tar.gz' BackUp
.     Source saveDATA Size > ${lcPupRamObj} MB
.     Source File:  '${lcPupSaveNameSrc}'
.
.
.
.              ... Progress Dialog ...
.
.
.
.
.                TarOut: ${gcCtbConfigTrgPrefix}
. ${lcPupSaveNameTrg##*/} 
.
.                                                           " &
    GTKPIDTOP=$!    
    sleep 2
    
	
	cd ${1%/*} 
    lcDialogColor="  -fg yellow -bg blue "
    lcMsgStr=":${gcCTBmodeId}: < Tar Running > :${gcCTBmodeName}:"  # && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
    /usr/lib/gtkdialog/box_splash  $lcDialogColor -border true -close never -text "
    ${lcMsgStr}  
    .                      " &
    sleep .5
    GTKPIDRUNNING=${!}	   # kill blue splash "RUNNING"
    lcMsgStr=""
        /bin/echo -e  " "  #: simple color string to terminal so tar process shows proper colors.  
        /bin/echo -n -e "\\033[1;36m" 
    	n=0
	lcTarRetVal=0	
	export lcTarOptSaveNameSrc="${lcPupSaveNameSrc}"
	export lcTarOptSaveNameTrg="${gcCtbConfigTrgPrefix}${lcPupSaveNameTrg}"		
                    lcMsgStr="-----------------------------" && Sys_Str2DevTrm "$lcMsgStr" "4" "3"
                    lcMsgStr=">>> begin TarOpt process" && Sys_Str2DevTrm "$lcMsgStr" "1" "3"
                    lcMsgStr="Src: ${lcTarOptSaveNameSrc}" && Sys_Str2DevTrm "$lcMsgStr" "5" "3"
                    lcMsgStr="Trg: ${lcTarOptSaveNameTrg}" && Sys_Str2DevTrm "$lcMsgStr" "5" "2"
                    lcMsgStr="-----------------------------" && Sys_Str2DevTrm "$lcMsgStr" "4" "3"
        TAROPT="-c -z --checkpoint=1000"    # TarOpt
		tar ${TAROPT} -f ${lcTarOptSaveNameTrg} ${lcTarOptSaveNameSrc} 
 
		lcTarRetVal=0	
		lcTarRetVal=$?  
		rm -f /tmp/flagnextpassthru	   
        lcMsgStr="<<< End:  TarOpt process =======" && Sys_Str2DevTrm   "${lcMsgStr}"   "3" "3"
        echo " "
        sleep 1
        aa="$(du -c -m -s ${lcTarOptSaveNameTrg} )"    # error flag on Zero-length file  
        read -r b ccc <<< "$aa"
        lcPupRamObjStr="${b}" 
        lcMsgTos="Tar-out-size :${lcPupRamObjStr}: MB" 
        #
        if [ ${lcTarRetVal} -eq 1 ] ; then	 
            gcCTBerror="1"	#(:  this event will disable the ScanList process. 
            lcMsgStrX="... Tar Process Message Error : 'File NOT Found' / 'InValid' ..." # && Sys_Str2DevTrm "$lcMsgStr" "3" "3"
            lcDialogColor="  -fg black -bg red  "
            /usr/lib/gtkdialog/box_splash  $lcDialogColor -border true -close never -text " $lcMsgStrX :$lcMsgTos: " &
            GTKPIDtpem=${!}
            sleep 5
            kill "${GTKPIDtpem}"
            lcMsgStrX=""
        else
            gcCTBerror="0"	
        fi
		kill ${GTKPIDRUNNING}
        kill ${GTKPIDRUNBLUE}  
    lcMsgStrT=" Tar < DONE > " 
    lcDialogColor="  -fg yellow -bg blue  "
    /usr/lib/gtkdialog/box_splash  $lcDialogColor -border true -close never -text "\ 
    .  ${lcMsgStrT} :: ${lcMsgTos}:   
    .                                        " &
    GTKPIDdone=${!}
    sleep 5
    kill "${GTKPIDdone}"
    sleep 1
        cd "$CWDir" 
		sleep .1
		kill ${GTKPIDTOP}
	rm -f "${CTB_FlgLockFile}"  
	CTB_ClearFlgSys	
    touch  "${CTB_BackUpStatus}"   # set STATUS flag to "active"
} #( end: fx(CTB_BackUpRun)
#
#! 
#! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_SYNC() {    # ACTIVE sync
n=0
lcMsgStr=">>> SYNC <<<"
lcDialogColor="  -fg yellow    -bg black "
/usr/lib/gtkdialog/box_splash ${lcDialogColor} -border true -close never \
-text "     $lcMsgStr   " &
		GTKPIDSYNC=$!
		sleep 1  
    sync       1>/dev/null 2>&1 
	sleep .5
    kill $GTKPIDSYNC   # kill "SYNC"
} # end: fx(Sys_SYNC)
#
#(! ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Sys_SMP() {    # ACTIVE snapmergepuppy
n=0
lcRunNum="19"
lcRunSeq="1"
lcDialogColorBg="  -fg red -bg black "  # background
lcMsgStr="${gcCTBmodeId} SnapMergePuppy nice -n ${lcRunNum}  [${lcRunSeq}]"
/usr/lib/gtkdialog/box_splash ${lcDialogColorBg} -border true -close never -text "$lcMsgStr" &
		GTKPIDSMP1=$!
		sleep .5  
lcDialogColorFg="  -fg yellow    -bg black "  # foreground
lcRunNum="19"
lcLoopCnt="3"
if [ ! -s ${lcLoopCnt} ] ; then 
    ii=${lcLoopCnt}
else
    ii=1
fi
for (( i = 1; i <= $ii ; i++ )) ## "C"syntax "C" syntax 'C'syntax 'C' syntax
do 
    n=0
    lcMsgStr=" <$i>  nice -n ${lcRunNum} SnapMergePuppy"  # foreground 
    /usr/lib/gtkdialog/box_splash ${lcDialogColorFg} -border true -close never -text ".  $lcMsgStr  ." &
    GTKPIDSMP0=$!
        nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw    1>/dev/null 2>&1 
    sleep .2    # expose splash during SMP
    kill $GTKPIDSMP0
done # end: for (( i = 1; i <= $ii ; i++ ))
#(
#(######################################################################
		sleep .5
		kill $GTKPIDSMP1
} #( end: fx(Sys_SMP)
#!
#!#############################################################################
#! End of High SubRoutines 
#!#############################################################################
#!
#(!-----------------------------------------------------------
#(!   MAIN()  #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(!   MAIN()  #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(!   MAIN()  #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(!-----------------------------------------------------------
#
    echo 
    MODE="`grep PUPMODE /etc/rc.d/PUPSTATE | cut -f 2 -d "="`"
    if [ "$MODE" = "12" ] || [ "$MODE" = "13" ]; then
        n=0
    else
        lcMsgStr="MODE is not FRUGAL mode '12' or '13' " 
        lcDialogColor="  -fg black -bg red  "
        /usr/lib/gtkdialog/box_splash  $lcDialogColor -border true -close never -text " $lcMsgStr :$lcMsgTos: " &
        GTKPIDtpem=${!}
        sleep 5
        kill "${GTKPIDtpem}"
        exit 1
    fi
    #! end: fi [ "$MODE" = "12" ] || [ "$MODE" = "13" ]; then
    #!  must exit at "main( )" this stack level in order to Quit/Clear the $0 program. 
    CTB_StartUp     # Must be First-Call !
    #! 
    #!
    #! -----------------------------------------------------------------
    if [ -f ${CTB_FlgLockFile} ]  ; then
        /usr/lib/gtkdialog/box_splash -fg black -bg red -border true -close never -text "\
        .
        . Found:  LockFile : Soft-Lock !!!      
        . ---> Will Continue Running <---
        .                                         "&
        #------------------------------------------------------------------------
        sleep 3
        RETVAL=$?
        GtkPid_Sbr_Box_Splash=$!	
        kill ${GtkPid_Sbr_Box_Splash} 
        #------------------------------------------------------
    fi	
    touch  "${CTB_FlgLockFile}" 
#! begin:  MAIN GUI ### setup/prepration :
if [ ${gcCTBmode} = "B" ] ; then 		
	lcSD_Flg_HLP=" Help "     		
else
	lcSD_Flg_HLP=""
fi
#! === begin: check for status flag
lcBackUpStatus="---"  
if [ ! -f "${CTB_BackUpStatus}" ]; then 
	export lcBackUpFocus="true"		
	export lcQuitFocus="false"		
    export lcBackUpStatus="Backup"  
else
	export lcBackUpFocus="false"	
	export lcQuitFocus="true"		
    export lcBackUpStatus="Done"  	
    rm -f ${CTB_BackUpStatus} 		
fi
lcGuiColor3="green"
lcGuiColor2="blue"
lcGuiColor1="darkred"
lcGuiColor0=${lcGuiColor3}	
lcCtbFrameTitle="Cold-Tar-Backup  v.${gcSysDevVer}"
#!============================================================  
#! ### Top of maingui ############################################
#!============================================================   
export CTB_Main_Gui\
='<window title="'${DISTRO_NAME}.Cold-Tar-Backup_to_save_DATA_' "icon-name="gtk-convert" default_width="500"  resizable="false">
<vbox>
    <frame>
        <hbox>
			<text editable="false" use-markup="true" xalign="0">
				<label>"                       " </label>  </text>
           <text editable="false" use-markup="true" xalign=".5">
                <label> 
                "<span  color='"'$lcGuiColor0'"'> <b>'"${lcCtbFrameTitle}"' </b> </span>  <span color='"'$lcGuiColor3'"'><b>''</b></span><span color='"'$lcGuiColor2'"'>'${gcSysDevDob}'</span>" 
                </label>
           </text>
			<text editable="false" use-markup="true" xalign="0">
				<label>"                       " </label>  </text>
        </hbox>
    </frame>
    <frame>  
        <text editable="false" use-markup="true" >
            <label> "for Puppy Frugal Systems" </label>
        </text>
        <text editable="false" use-markup="true" >
            <label> "<b>Source: '${lcPupSaveNameSrc}' </b>" </label>
        </text>
        <text editable="false" use-markup="true" >
            <label> "<b>Target Subdir : '${gcCtbConfigTrgPrefix}' :</b>" </label>
        </text>
       <text height-request="36"   >
                <variable>'CTB_TrgDts'</variable>
                <input> 'CTB_TrgFilename' '\$CTB_PUPSAVE_PATH' </input>
        </text>
        <timer milliseconds="true" interval="'${CTB_REFRESH_INTERVAL}'" visible="false"   >
               <action>refresh:CTB_TrgDts</action>
        </timer>
        <hbox>   
            <text editable="false">
                <label> "*'${lcPupRamObjMsg}'*                       " </label>
            </text>
        </hbox>
    </frame>
	<frame> 
		<hbox>
			<text editable="false" use-markup="true" xalign="0">
				<label>"   " </label>  </text>
			<button  tooltip-text="Display Help-Notes, box_help" label="'${lcSD_Flg_HLP}'"  xalign=".5"
				has-focus="false">  <action>EXIT:"GuiHLP+"</action>  </button>
			<text editable="false" use-markup="true" xalign="1">
				<label>"     " </label>  </text>
			<button label=" '${lcBackUpStatus}'  "  
				has-focus="'${lcBackUpFocus}'"
				tooltip-text="    ALWAYS read the <HELP> page and <FAQ> file ! " >
				<action>EXIT:"GuiBackUpCall+"</action>	 </button>
			<text editable="false" use-markup="true" xalign="1">
				<label>"     " </label>  </text>
			<button   has-focus="'${lcQuitFocus}'">
				<label> " 'Quit' " </label>
				<input file icon="gtk-no"></input>
				<action>EXIT:"GuiQuitCall+"</action>  </button>
			<text editable="false" use-markup="true" xalign="1">
				<label>"                                " </label>  </text>
		</hbox>
    </frame>
</vbox>
</window>'
if [ ${gcCTBmode} = "B" ]  ; then  
	eval "`gtkdialog --center -p CTB_Main_Gui`"     
else
	EXIT="GuiBackUpCall+"    
fi
#
###############################################################################################################
###############################################################################################################
#!
#! ---------------------------------------------------------------------
function CTB_Fall_Thru() { # marker
    n=0
    #!	 CTB: Fall-Thru to Sequential Test on If/Fi routines. 
} # end: CTB_Fall-Thru
#
#!
#! ------------------------------------------------------------------------
if [ "$EXIT" = "GuiBackUpCall+" ] ; then
    n=0
	if [ "$lcBackUpStatus" = "Backup" ] ||  [ "$lcBackUpStatus" = "Backup+Scan" ] || [ "${gcCTBmode}" = "A" ] ; then  
        lcTarRetVal=0	#  default value before CTB_BackUpRun
		CTB_BackUpRun "${CTB_PUPSAVE_PATH} --- ${CTB_BACKUP_PATH}"	
    if [ ${gcCTBmode} = "B" ]   ; then    
			CTB_ReStart     
		else
			EXIT="QUIT"  
		fi
	else
	    EXIT="QUIT"  
	fi
    EXIT="QUIT"  #(: setup Fall-Thru
	CTB_ClearFlgSys	
    rm -f ${CTB_BackUpStatus} 
fi # end: ft(EXIT:"GuiBackUpCall+")
#
#!
#! ------------------------------------------------------------------------
if [ "$EXIT" = "GuiHLP+" ] ; then
    n=0
    Sys_Box_HLP    
    CTB_ReStart	
fi # end: ft(EXIT:"GuiHLP+")
#
#!
#! -----------------------------------------------------------------------
if [ "$EXIT" = "GuiQuitCall+" ] || [ "$EXIT" = "QUIT" ]  || [ "$EXIT" = "" ] ; then
	n=0
	CTB_ClearFlgSys	
    rm -f ${CTB_BackUpStatus} 
    lcMsgStr="<<<>>>"""
fi # end: ft(EXIT:"QuitCall+")
exit 0
#------------------------------------------------------------------------
#------------------------------------------------------------------------
    #! #####################################################################
    #!
    #! Meta Characters for System Docs and Linux Comments.
    #! '#(:' System Docs are transferred  by 'TXN' into 'Comments.txt'
    #!       used for System Dox to build Documentation for System Project . 
    #!       TXN will pull these out to a separate file for project team share. 
    #!         #(: effectively becomes a 'cut' line in FileOut.sh 
    #!
    #! '#!'  are program dox, 'Keepers' in the source code. 
    #!
    #! '#~' , '# ' , '#:' 
    #!    regular Bash Comments are Culled via 'TXN'
    #!       TXN will kill these common comments, 
    #!          clear the clutter, for min prog/script size.
    #!
    #! "#" are Bash comments to Keep in source code.
    #!     must not have a "space" following. 
    #!
    #! Format Indents are maintained, 'as is' . 
    #!
    #! #####################################################################
#!
#!  BASH is a very common *nix shell, 
#!     and it's programming language is purely procedural 
#!     and focused on command execution. 
#!  Updates to Bash itself has broken older shell scripts 
#!      which worked good in UNIX.
#!  Caveat: IFS, if [ -f filename ...] et al,  when successful, 
#!      can generate err flgs which are detected by 'set -e' 
#!  BASH has quirks, not fully compatible with sh, Ksh, Tsh, Zsh, etc. 
#!      BASH requires constant local debug-testing during development. 
#!
#!(######################################################################
#!
