#!/bin/bash
#
########################################################################
###  "E2R" 
### Back 2 Root, /my-applications 
########################################################################
#
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export gcSysDevDobPrev=""
export gcSysDevDob="221010-0905"		
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer ID name of this Linux BASH script
export gcSysDevId="E2R"	
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#:### MGN PATH  "rc.sysinit" calls function-x to check/link "/etc/rc.d"
#:### PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/root/my-applications/bin/ 
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/usr/lib/gtkdialog/:/root/my-applications/bin/
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#
### .sh format so GEANY sees a 'script' executable.
###
### name : rc.z_E2R, Backup 2 Root , to /root/my-applications .
###
### /intrd/mnt/dev_save/MY_/usr-share/gae-Dev/Edit_E2R
###
### purpose : Backup Edited Projects to /root/my-applications
### 
### param : system state constants from /etc/rc.d/PUPSTATE .
### sends : none
###
########################################################################
    ###
    ### goal:
    ### copy Dev-Source "Raw" to "/etc/rc.d" .
    ###     linked to 'application.desktop' files, drag-n-drop to desktop.
    ### copy Dev-Source  "DateTimeStamped" to "/etc/rc.d" .
    ###     rolling backup.dts
    ###
    ###
    ####################################################################
#
### .sh format so GEANY sees a 'script' executable.
### "gc" var are 'global' and should not be changed. 
###      Always copy to 'lc' 
#
########################################################################
#
#  Standard GNU General Public License Header :
#
#  2020 root <glen.e77is@Gmail.com>
#  website : www.GeoCities.WS/glene77is
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  To received a copy of the GNU General Public License
#  write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
#######################################################################
#
### Developed using Geany, with option "Execute" 
### for trace in "BASH Terminal" for debug.
### many of our "echo" lines will show trace in the terminal screen.
###
### Using Geany with option "Execute" activates "BASH Terminal" mode . 
### We obtain good debugging via "BASH Terminal" mode. 
#
########################################################################
### --- latest version dates---
### 200213-1030 gae,
### 200214-1900 gae, cut/pasted Clear-3-Cache code from S2F
### 200224-0615    ### /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
### 200403-1700   some cleanup.
### 200404-2120   some cleanup.
### 201031-0700	gae, receives param "SLP", "RCZ", "BMA", "ALL"
### 201102-1045 gae, MGN calls with param "ALL", "BMA", "RCZ", "SLP"  else default "" 
### 220517-0900
########################################################################



#:##################################################
function Sys_SetVerDts() {   #: A	
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################

###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
export gcDtsVer="${gcSysDevDob}"
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

export gcSysDts="`date +%y%m%d-%H%M-%S`"   
	#  grave-mark in date funxtion !!!

export gcSysOs="UpupBB-19.03 v:8.0 +??"
	#~ export lcE2Rdistro="UpupBB-19.03 v:8.0 +20"    # Manual entry

export gcSysVer="${PUPSFS}"
	# 3073 4.9.163-lxpup-32-pae #1 SMP Thu Mar 14 15:41:19 GMT 2019 i686 i686 i686 GNU/Linux"

export lcSysNameBase="E2R"
	### "Back 2 Root"  used in code as label

export lcSysFlgE2R="E2R_FlgLock"

		#
        lcFileDtsOut="/0-E2R_DTS"		
        touch  "${lcFileDtsOut}"       ### this is a Zero-Byte DTS Marker file .
		#

    ### trace results to terminal window.
    echo "gcDtsVer: ${gcDtsVer} ......."
    echo "VerDts: ${gcSysVer} ......."
    echo "SysDts: ${gcSysDts} ......."

###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####
}
# end: Sys_SetVerDts




#:##################################################
function Sys_ShowSplash() {   #: N
    ### called: 
    ### param:
    ### purpose:
    ### rationale :
 
   ### Sys_ShowSplash "${lcMsgStr}"  "green" "red" gtk-ok && sleep 2 && kill ${GTKPIDX}
	/usr/lib/gtkdialog/box_splash -fg ${2} -bg ${3} -close never -icon ${4} -text "          ${1}" && PIDX=$! && GTKPIDX=$!
}   ### end Sys_ShowSplash




#:##################################################
function Sys_PupState() {   #: A
    ###
    ### called by main ()
    ### param
    ### purpose :
    ###     consolidation of PUPSTATE
    ###     control generation of local var
    ### rationale :
    ### Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    ###
    #
    ### >>> maintain gcDtsVer
    lcVerDtsTmp="${gcDtsVer}"
	#
    . /etc/rc.d/PUPSTATE
    #
    gcDtsVer="${lcVerDtsTmp}"
    ### <<< maintain gcDtsVer
    #
	echo "BK ==============================================="  
	lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameMount = ${lcSaveFileNameMount}"
	lcSaveFileNameBaseSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameBaseSrc = ${lcSaveFileNameBaseSrc}"
	echo "BK ==============================================="  
	#
    # direct import, similar varname.
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    lcPupSubDir=${PSUBDIR}
    lcPupHome=${PUP_HOME}
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
	
	# maintain similarity to PUPSTATE "name"
    lcPupSaveNameRaw="PUPSAVE : ${lcPupSve}"  
    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" 
    lcPupSaveNameDts="${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`" 
    lcPupSaveNameTrg="${lcPupSaveNameDts}.tar.gz"
    lcPupSaveNameSrc="${lcPupSaveName##*/}"
    lcPupDistroVer=${gcSysDistroVer}

    lcPupNowDts="`date +%y%m%d-%H%M-%S`" 

##################################################
###	funxtion is to backup all developmental modules into "/root/my-applications"
###	method:
### 		gather param "lcParamCopy" 
###		execute scripts  to  copy  'source' subdir  into  'target'  subdir 
##################################################

    ### Build List of Files to be sent thru "E2R" 
    ### Determine the 'location' of script files
    ### filenames must be parsed,
    ### tested for location of running script.
    ### Preferred Archive location is "/root/my-applications"
    ### Editing location is "/mnt/home/MY_/usr-share/gae_Dev/"

	### E2R (Back-2-Root) target for standard copy process 
	export lcTrgFnCopyBase="/root/my-applications"
	export lcTrgFnCopyBin="/root/my-applications/bin"
	export lcTrgFnCopyTrg="${lcTrgFnCopyBase}"
	#-----------------------------------------------------

	export E2R_lockfile="/tmp/E2R_lockfile"

		#~ lcSrcBh="/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_"
		#~ lcSrcExt=".sh"
		#~ lcSrcBase01="TST"
		#~ lcSrcBase02="S2F"
		#~ lcSrcBase03="MGN"
		#~ lcSrcBase04="E2R"
		#~ lcSrcBase05="GTK"
		#~ lcSrcBase06="C3C"
		#~ lcSrcBase07="CTB"
		#~ lcSrcBase08="CTU"
		#~ lcSrcBase09="CTM"
		#~ lcSrcBase10="CBU"
		#~ lcSrcBase11="B2T"
		#~ lcSrcBase12="PMT"
		#~ lcSrcBase13="YAF"

		#~ lcTrgSubdir01="/root"
		#~ lcTrgSubdir02="/root/my-applications"
		#~ xxxlcTrgSubdir03="/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_z_backup"

		### develop for an 'array' approach for the 'list'.
		#~ for i in $(cat /proc/cmdline)
		#~ if [ "$i" != "" ];then #variable is in to be "Copied"
		 #~ echo -n "Loading user-list modules..." 
		 #~ for MODULE in $ADDLIST
		 #~ do
			#~ lndummy=0
			#~ E2R_Copy param
		 #~ done
		#~ fi
		#~ done
    #
}
# end: Sys_PupState
#------------------------------------------------------------------------------


#:##################################################
function Sys_E2R_SetUp() {   #: N
    ### called: 
    ### param:
    ### purpose:
    ### rationale :
    ### purpose:  remove any written tmp file
    ###
    echo ">>> Set ${E2R_lockfile} ..."
	touch  ${E2R_lockfile} 

    ### kill any lingering $pid displays
	#~ busybox ps | grep 'GTKPID04' | grep -v grep | awk '{print $1}' | \
	#~ while read pid ; do kill $pid ; done
    ### all pid have been killed 
    
    echo "<<< Sys_E2R_Cleanup : 'DONE'"

    #~ exit 0
    ### gaurantee an absolute "quit".
} 
# end: MGN_cleanup
#------------------------------------------------------------------------------



#:##################################################
function Sys_E2R_Cleanup() {   #: A
    ### called: main 
    ### param:
    ### purpose:
    ### rationale :
    ### purpose:  remove any written tmp file
    ###
    echo "Remove ${E2R_lockfile} ..."
	rm -rf "${E2R_lockfile}"
    ### kill any lingering $pid displays
	#~ busybox ps | grep 'GTKPID04' | grep -v grep | awk '{print $1}' | \
	#~ while read pid ; do kill $pid ; done
    ### all pid have been killed 
    
    echo "Sys_E2R_Cleanup : 'DONE'"

    #~ exit 0
    ### gaurantee an absolute "quit".
} #
# end: MGN_cleanup
#------------------------------------------------------------------------------



#:##################################################
function E2R_Copy_Splash() {   #: A
    ### called: 
    ### param:
    ### purpose:
    ### rationale :
    ### method: E2R_Copy_Splash: kill prev, splash 

### Dialog Copy Splash Check 
### 4 
lcParam1=${1}
### lcSrcFnBase setup by caller E2R_Copy_One 

    kill ${GTKPIDCHK}    ### kill any previous splash

#--------------------------------------------------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "          ${lcParam1}             " &  
#--------------------------------------------------------------------------------------------------------------

	GTKPIDCHK=$!	### kill #((splash
    sleep .3

	# kill ${GTKPIDCHK} # All Use Same PID, so Single Late Kill 
}
# end: E2R_Copy_Splash



#:##################################################
function E2R_Copy_Check() {   #: N
    ### called: 
    ### param:
    ### purpose:
    ### rationale :

### purpose : check that "cp" command succeded 'OK'.
### param is lcFnAll the filename bare only.
### param is lcFnTrg the filename full target output.
### called by : E2R_Copy
###           : E2R_Copy_Check "${lcFnAll}" "${lcFNtrgY??}"

	lnDummy=0

### E2R_Copy_Check ###
lcFnTrgCk="${1}"  ### find this file ! 
lcFnTrgBaseCk="${2}"

#:######################################################################
if [ 0 = 1 ];then

	lnDummy=0

    echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
    echo "+++ START:  Copy-Check "
    echo "=== lcFnTrgCk = ${lcFnTrgCk} "
    echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"

    if [ ! -f "${lcFnTrgCk}" ] ; then     ### generate a "NON-FATAL" Error .
        /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text " >>> ERROR <<< \
               ${lcFnTrgBaseCk}                    "&

        sleep 1
        pidx=$!
        GTKPIDER=$!

        lcMsgStr="Copy_Check >>> ERROR <<< ${lcFnTrgBaseCk} ======================"
        echo "$lcFnTrgCk"
        echo "$lcFnTrgCk"
        echo "$lcFnTrgCk"
        echo "... line 286 ... Copy_Check___ERROR___ "

        sleep 2
        kill ${GTKPIDER}

    #~ else


	#~ if [ 0 -eq 1 ] ; then
		#~ lnDummy=0
	#~ fi ### begin : if [ 0 -eq 1 ]

        #~ ### (5)
    #~ /usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "OK!  ${lcFnTrgBaseCk}" &

        #~ sleep .7
        #~ pidx=$!
        #~ GTKPIDOK=$!

        #~ ### temp splash
        #~ kill ${GTKPIDOK} ### kill just before/after return

    fi
fi
echo "=== lcFnTrgCk = ${lcFnTrgBaseCk} "
echo "....... END: Copy_Check ...... "
echo "=================================================================="

}
# end: E2R_Copy_Check







#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#######  COPY  #########################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#######  COPY  #########################################################
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#######  COPY  #########################################################

#:##################################################
function E2R_CopyOne() {   #: A
    ### called: 
    ### param:
    ### purpose:
    ### rationale :

lnDummy=0

lcSrcFnBaseP=${1}
lcSrcFnTitleP=${2}
lcSrcFnTitlePS=${3}	# subdir

	E2R_Copy_Splash	"${lcSrcFnBaseP}"

    lcSrcFnCopyPP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcFnBaseP}/${lcSrcFnTitleP}"
    lcTrgFnCopyPP="/root/my-applications"

    cp -v ${lcSrcFnCopyPP} ${lcTrgFnCopyPP}  

	sleep .3

} #
# end: fx(E2R_CopyOne)


#:##################################################
function E2R_CopyOneBin() {   #: A
    ### called: 
    ### param:
    ### purpose:
    ### rationale :

lnDummy=0

lcSrcFnBaseP=${1}
lcSrcFnTitleP=${2}

	E2R_Copy_Splash	"${lcSrcFnBaseP}"

    lcSrcFnCopyPP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_${lcSrcFnBaseP}/${lcSrcFnTitleP}"
    lcTrgFnCopyPP="/root/my-applications/bin"

    cp -v ${lcSrcFnCopyPP} ${lcTrgFnCopyPP}  

	sleep .3

} #
# end: fx(E2$_CopyOneBin)

# ft(MNT)
#:##################################################
function E2R_CopyDirect() {   #: A
    ### called: 
    ### param:
	### call format: E2R_CopyDirect "SrcFnBase" "SrcFnDirect" "TrgFnDirect"
    ### purpose:
    ### rationale :

n=0

lcSrcFnBaseP=${1}
lcSrcFnDirectP=${2}
lcTrgFnDirectP=${3}

	E2R_Copy_Splash	"${lcSrcFnBaseP}"

    cp -v ${lcSrcFnDirectP} ${lcTrgFnDirectP}  

	sleep .3

} #
# end: fx(E2R_CopyDirect)

# ft(MNT)
#:##################################################
function E2R_CopyOneDirect() {   #: A
    ### called: 
    ### param:  FnBase, SrcFnAll, TrgFnAll 
	### call format: E2R_CopyOneDirect "SrcFnBase" "SrcFnAll" "TrgFnAll"
    ### purpose:
    ### rationale :
# working gae CopyOneDirect 
n=0

lcSrcFnBaseP=${1}		# MntPone.sh
lcSrcFnAllP=${2}		# "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MntPone.sh"
lcTrgFnAllP=${3}		# "/root/my-applications/bin"

	E2R_Copy_Splash	"${lcSrcFnBaseP}"

    cp -v ${lcSrcFnAllP} ${lcTrgFnAllP}  

	sleep .3

} #
# end: fx(E2R_CopyOneDirect)





###>>> E2R_Copy >>>
### we "Execute" in "BASH Terminal Screen" and 'echo' shows progress.

### called by: Main () for each file to E2R
### purpose: copy Src into three Trg subdir as backup w DTS.
### given lcAllFnBase as lcTrgFnRootSubdir

###<<< E2R_Copy <<<
	#~ lcFnBaseSrcParm=${1}    ### FileName base 
	#~ lcSrcFnBase="${lcFnBaseSrcParm}"	# ${1}
	#~ E2R_Copy_Splash	"${lcSrcFnBase}"
	#~ ### Dialog Copy Splash Check ##################################################
	#~ ### 4
	#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
	#~ ${lcFnBaseSrcParm}    " &  
	#~ ### 4 lines end '&' at pos 84
		#~ sleep .8
		#~ GTKPIDCHK=$!
		# export GTKPIDCHK
	#~ echo "=============================================================="


##############################################################
### given BaseFn ( "B2T" ) as an example. 
### then build full path/subdir/Edit_BaseFn/rc.z_BaseFn 

	#~ echo    "parm1=${lcFnBaseSrcParm}"
	#~ lcSrcFnBaseFn="${lcFnBaseSrcParm}"

	#~ ### example:  "/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_"
	#~ lcSrcFnSubdir="/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_"	# + SrcFnBase
	#~ ###                      Subdir    BaseFn          prefix            BaseFn
	#~ lcSrcFnAllCopy="${lcSrcFnSubdir}${lcSrcFnBaseFn}/rc.z_${lcSrcFnBaseFn}.sh"
	#~ ###            "/initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_" + "MGN" +".sh"

	#~ ### finally append .sh to target name
	#~ lcFnSrcY="${lcSrcFnAllCopy}" 		###.sh" ### error 
	#~ ###    /initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/Edit_" + "MGN" + ".sh"

	#~ ### Source FileName Copy 
	#~ lcSrcFnCopy="${lcFnSrcY}"

	#~ echo "=================================================================="
	#~ echo "BaseFn=${lcSrcFnBaseFn}"
	#~ echo "Subdir=${lcSrcFnSubdir}"
	#~ echo "AllCopy=${lcSrcFnAllCopy}"
	#~ echo "SrcY=${lcFnSrcY}"
	#~ echo "=================================================================="

	#~ echo "=== Copy Var ==="
	#~ read
	#~ sleep .1

	#~ ### Copy ###############################################################

	#~ lcAllFnBase="${lcFnBaseSrcParm}"

	#~ ### Trg 01 #############################################################
	#~ ### copy into '/root/my-applications'  with straight filename, no archive by date
	#~ ### lcTrgFnCopyBase has been exported as  '/root/my-applications' 
	#~ ### Can be changed to "/bin" so that "terminal" can see it in common path. 

	#~ lcTrgFnRootBase="${lcAllFnBase}"
	#~ lcTrgFnRootFull="rc.z_${lcAllFnBase}"

	#~ ### this is subroutine:  fx(E2R_Copy)

	#~ ###==================================================================
	#~ ### funxtion: ARCHIVE developmental subdir ==========================================
	#~ ### operation: Move2Root (/$source) (/root/my-applications) 
	#~ ###==================================================================

	#~ ### example: lcTrgFnRootSubdir="/root/my-applications"	### ARCHIVE subdir 
	#~ lcTrgFnRootSubdir="/root"	### ARCHIVE subdir 
	#~ ###============================================================================

	#~ lcTrgFnRootCopyDts="${lcTrgFnRootSubdir}/${lcTrgFnRootFull}-${gcSysDts}"
	#~ lcTrgFnCopy="${lcTrgFnRootSubdir}/${lcTrgFnRootFull}.sh"
	#~ echo "=== lcTrgFnRootCopy = ${lcTrgFnRootCopy} ======="

		#~ cp -v ${lcSrcFnCopy} ${lcTrgFnCopy}  
	 
		#~ E2R_Copy_Check ${lcTrgFnCopy} ${lcAllFnBase}

	#~ # working gae fx(E2R_Copy)
	#~ read
	#~ exit 0


	#~ ####################################################################

	#~ echo "=== end M2$_Copy ============================================"

	### rc.z_E2R.sh calls internal E2R_Copy 











#######  start Main()  #########################################
#######  start Main()  #########################################
#######  start Main()  #########################################

### main() ###
### main() ###
### main() ###

clear   ### lingering stuff from BASH terminal screen.

lcE2Rparam1=${1}
	# lcE2Rparam1=${2}

	#~ lcE2Rparam1="ALL"	### force Back2Root ( /my-applications) for all files 
	### as written below : 
	### for subdir:
	###	BMA, CTB, CTU, CTM, CBU, C3C, MGN, E2R, SLP, S2F, RCZ, WRM, YAF, TST, GTK  

#:##################################################
if  [ ! ${lcE2Rparam1} ]; then
	lcE2Rparam1="ALL"  
	lcMsgStr="  E2R param :'${lcE2Rparam1}': "
	echo "=== $lcMsgStr ==="
else
	lcMsgStr="  E2R param OK :'${lcE2Rparam1}': "
	echo "=== $lcMsgStr ==="
fi

echo "=== Sys_SetVerDts"
Sys_SetVerDts      ###  get Author's Version DTS .

echo "=== Sys_PupState"
Sys_PupState

	# Sys_E2R_SetUp
		### purpose:  remove any written tmp file
		###
    echo ">>> Set ${E2R_lockfile} >>>"
	touch  ${E2R_lockfile} 
		### kill any lingering $pid displays
		#~ busybox ps | grep 'GTKPID04' | grep -v grep | awk '{print $1}' | \
		#~ while read pid ; do kill $pid ; done
		### all pid have been killed 
    echo "<<< Set ${E2R_lockfile} <<<"

### main() ###

	### preset in Sys_SetVerDts ()
	#~ gcSysOs="UpupBB-19.03 v:8.0 +20"    ### Manual entry
	#~ gcSysDts="-`date +%y%m%d-%H%M-%S`.dts"  ### grave-mark in date() !!!
	#~ gcSysDts= ${gcSysDts}.dts

	### system Date-Time-Stamp via command 'date'
	###   plus '.dts' extension for selection/deletion as a group by C3C.
	### DTS for archive files.
	### files are Year-Month-Day-Second stamped so no dupelicates.
	### use the `" grave mark, not single "'" quote mark.

#########################################################################
echo "### in Main (0) ###"
#########################################################################

lcFileE2Rname="Backup : Edit-2-Root"
lcFileVerDts="${gcDtsVer}"
lcFileSrc=""
lcFileTrg=""
lcSleep5="sleep 5"   ### some standard wait time.
lcSleep3="sleep 3"   ### some standard wait time.
lcSleep1="sleep 1"   ### some standard wait time.
lcTypeRun=" runRAM : "
lcTypeSaveFolder="saveFOLDER"
lcTypeSaveFile="saveFILE.4fx"

###=======  start MAIN Gui   ==============================================

# Selection XML GUI Not Required 

###=======  start MAIN Screen   ====================
###
### all "echo" will appear in BASH Terminal Screen.
### test code via Geany, "Execute" , Terminal .

###=== MAIN splash ===###
### precedes the group of all E2R_Copy

lcMsgStr="...mgn... E2R : $lcFileE2Rname : v:${gcDtsVer} terminal trace"
echo "=== $lcMsgStr"	### terminal display tracer

### (3) ### main() splash is "background" for all 'action' splashes.
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never -text "\
.           ...mgn... E2R : v:${gcDtsVer}
.
.                            
.                  Backup : Edit-2-Root
.                              
.
.
.
.
.
....................................................................." &
### 11 lines ### ending pos 72
### (3) ### main() splash is "background" for all 'action' splashes.

    sleep 1
	pidx=$!
	GTKPID0MAIN=$!
	### no 'kill' now.  
	### will kill ${GTKPID0MAIN}  after prg runs through. 
    sleep .1

### above method expands main splash vertical height
### so to allow for intermediate green progress splash.




#######  E2R  #######################
#######  E2R  #######################
#######  E2R  #######################




#########################################
###	E2R funxtion is to backup all these modules into "/root/my-applications"
###	method:
### 	gather param "lcParamCopy" 
###		execute scripts copy into target subdir 
#########################################

### now, a sequence of "Action blocks"  for  "copy" .
### each triggers a "copy-check" .
### each splash is small and is written over the previous splash .
### 'kill' are delayed so that previous splash remains on screen longer.

#########################################


### call E2R_Copy(0)
    ### (0)
    ### "${1}" ### this is the only var to change for each E2R process.

#~ echo
#~ echo "+++++++++++++++++++++++++++++++++++
#~ echo "### Build Fn'P'rimary and send as param to 'E2R_Copy' "
#~ echo "+++++++++++++++++++++++++++++++++++

#########################################
echo "### in Main (1) ###"
###    funxtion is to backup all these modules into "/root/my-applications"

#~ BMA
#~ RCZ
#~ WRM
#~ PLY

#~ MGN
#~ C2M
#~ C3C
#~ CTB
#~ CTU
#~ CTA
#~ E2R
#~ SLP
#~ S2F
#~ MNT
#~ YAF
#~ PMT
#~ TST
#~ GTK
#~ ABT
#~ MNU

#~ MGN, C2M, C3C, CTB, CTU, CTM, CBU, CTC, E2R, #~ MNT, S2F, RCZ, WRM, PLY, 
#~ GTK, ABT, YAF, PMT, TST,  SLP, BMA, MNU 

########################################################################
### SRC ################################################################
lcSrcFnSubdir="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_" 

### TrgBin ################################################################
#    lcTrgFnCopyPP="/root/my-applications/bin"

########################################################################

echo "lcSrcFnSubdir === ${lcSrcFnSubdir}"
### E2R /etc/rc.d/* 

#~ lcSrcFnFull="rc.z_${lcSrcFnBase}"     ### FileName rc.z_TST ( no dts ) ( no .sh )
#~ echo "lcSrcFnFull === ${lcSrcFnFull}"
#~ lcSrcFnCopy="${lcSrcFnSubdir}${lcSrcFnBase}/${lcSrcFnFull}.sh"
#~ echo "--------------------------------"
#~ echo "lcSrcFnCopy === ${lcSrcFnCopy}"
#~ echo "--------------------------------"

#########################################
#########################################

	### above is a setup for the "long form"
	### the"short form" is much simpler
	### just name of source sub-diretory

	###	note:   "/rc.z_"  is prefix for each of these developmental modules.
	###    funxtion is to backup all these modules into "/root/my-applications"

# working gae MGN

#########################################
### ft(MGN) ###################################
###

lcAllFnBase="MGN"
echo ">>> FnBase === ${lcAllFnBase}"	

    #~ kill ${GTKPIDCHK}    ### kill #(( copy  

	lcSrcFnBase="MGN"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}	
	# will Splash, copy-one, kill. 

	lcSrcFnBase="MGN"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}	
	# will Splash, copy-one, kill. 

   
#########################################
### ft(MNT) ###################################
###

#:=== P =======================
lcSrcOneFnBase="MNT"
lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh"
lcTrgOneSubAll="/root/my-applications"
E2R_CopyOneDirect ${lcSrcOneFnBase} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

lcSrcOneFnBase="MNT"
lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MNT.sh"
lcTrgOneSubAll="/root/my-applications/bin"
E2R_CopyOneDirect ${lcSrcOneFnBase} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 


#:----------------------------------
#:----------------------------------
#:----------------------------------
### working gae E2R CopyOneDirect
### E2R_CopyOneDirect
# working gae CopyOneDirect 
    # lcSrcFnBaseP="xxx.sh"
    # lcSrcFnAllP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_XXX/rc.z_xxx.sh"
    # lcTrgFnAllP="/root/my-applications"
# E2R_CopyOneDirect ${lcSrcFnBaseP} ${lcSrcFnAllP} ${lcTrgFnAllP} 

#:=== P =======================
lcSrcOneFnBase="MntPone"
lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MntPone.sh"
lcTrgOneSubAll="/root/my-applications"
E2R_CopyOneDirect ${lcSrcOneFnBase} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

lcSrcOneFnBase="MntPone"
lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MntPone.sh"
lcTrgOneSubAll="/root/my-applications/bin"
E2R_CopyOneDirect ${lcSrcOneFnBase} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

#:=== U =======================
lcSrcOneFnBase="MntUone"
lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MntUone.sh"
lcTrgOneSubAll="/root/my-applications"
E2R_CopyOneDirect ${lcSrcOneFnBase} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 

lcSrcOneFnBase="MntUone"
lcSrcOneFnAll="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_MNT/rc.z_MntUone.sh"
lcTrgOneSubAll="/root/my-applications/bin"
E2R_CopyOneDirect ${lcSrcOneFnBase} ${lcSrcOneFnAll} ${lcTrgOneSubAll} 


#########################################
### ft(C2M) ###################################
###
lcAllFnBase="C2M"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="C2M"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}

	lcSrcFnBase="C2M"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}


#########################################
### ft(C3C) ###################################
###
lcAllFnBase="C3C"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="C3C"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
    
	lcSrcFnBase="C3C"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}

    
###############################################
### ft(S2F) ###################################
#
lcAllFnBase="S2F"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="S2F"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
    
	lcSrcFnBase="S2F"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}


### ft(S2F-1) ###################################	

lcAllFnBase="S2F-1"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="S2F-1"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}


### ft(S2F-3) ###################################	

lcAllFnBase="S2F-3"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}


### ft(S2F-19) ###################################	

lcAllFnBase="S2F-19"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}


###############################################
### ft(CTB) ###################################

lcAllFnBase="CTB"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
#--- Second Copy into /root/my-applications/bin -----------------------------

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}


###############################################
### ft(CTU) ###################################

lcAllFnBase="CTU"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}


###############################################
### ft(CTA) ###################################
#
lcAllFnBase="CTA"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}


#########################################
### ft(E2R) #############################
#  
lcAllFnBase="E2R"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
    
lcAllFnBase="E2R"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}


#########################################
### ft(GTK) #############################
#
lcAllFnBase="GTK"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
    

#########################################
### ft(ABT) #############################
#
lcAllFnBase="ABT"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
    

#########################################
### ft(LIB) #############################
#
lcAllFnBase="LIB"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}


#########################################
### ft(YAF) #############################
#
lcAllFnBase="YAF"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}



#########################################
### ft(MNT) #############################
#
lcAllFnBase="MNT"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
    
	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}



###############################################
### ft(CNN) ### Copy-No-Notes ### Copy-All-Code #############################
#
lcAllFnBase="CNN"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}



###############################################
### ft(TXN) ### test for Copy-All-Code #############################
#
lcAllFnBase="TXN"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}_exe.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}




###############################################
### ft(PAK) ### test for Pull All KeyWords  #############################
#
lcAllFnBase="PAK"
echo ">>> FnBase === ${lcAllFnBase}"	

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}

	lcSrcFnBase="${lcAllFnBase}"
	lcSrcFnTitle="rc.z_${lcSrcFnBase}_exe.sh"
E2R_CopyOne ${lcSrcFnBase} ${lcSrcFnTitle}
E2R_CopyOneBin ${lcSrcFnBase} ${lcSrcFnTitle}

	sleep .5




#########################################
### begin "Long Form" for "special" program sets to multiple subdir
#########################################



# E2R_CopyDirect format example:
#    lcSrcFnBaseP="wrmpoweroff"
#    lcSrcFnDirectP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMpoweroff"
#    lcTrgFnDirectP="/root/my-applications"
# E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 




#########################################
### ft(WRM) #############################
#
### /initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/a_WRM_/rc.z_wrmexit
### /initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/a_WRM_/rc.z_wrmpoweroff
### /initrd/mnt/dev_save/MY_/usr-share/gae_Dev_/a_WRM_/rc.z_wrmreboot

### ft(WRM) #############################

lcAllFnBase="wrmpoweroff"
echo ">>> FnBase === ${lcAllFnBase}"	

    lcSrcFnBaseP="wrmpoweroff"
    lcSrcFnDirectP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMpoweroff"
    lcTrgFnDirectP="/root/my-applications"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 
    lcTrgFnDirectP="/root/my-applications/bin"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 

    lcSrcFnBaseP="wrmpoweroff"
    lcSrcFnDirectP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMpoweroff.sh"
    lcTrgFnDirectP="/root/my-applications"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 
    lcTrgFnDirectP="/root/my-applicationsh/bin"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 


lcAllFnBase="wrmexit"
echo ">>> FnBase === ${lcAllFnBase}"	

    lcSrcFnBaseP="wrmexit"
    lcSrcFnDirectP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMexit"
    lcTrgFnDirectP="/root/my-applications"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 
    lcTrgFnDirectP="/root/my-applications/bin"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 

    lcSrcFnBaseP="wrmexit.sh"
    lcSrcFnDirectP="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMexit.sh"
    lcTrgFnDirectP="/root/my-applications"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 
    lcTrgFnDirectP="/root/my-applications/bin"
E2R_CopyDirect ${lcSrcFnBaseP} ${lcSrcFnDirectP} ${lcTrgFnDirectP} 
   


##########################################
### ft(BMA) #############################
#
###  BMA  ### ### Book Marks_Alpha #################
### must copy running /BMA.html, /BMM.html, /BMP.html  

lcAllFnBase="BMA"		###   /BMA   ### BookMarks_Alpha
echo ">>> FnBase === ${lcAllFnBase}"	

	#--------------------------------
	lcSrcFnTitle="BMA"
    E2R_Copy_Splash	"${lcSrcFnTitle}"

    lcSrcFnCopy="/BM*.html"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy}
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy}

	#--------------------------------
	lcSrcFnTitle="/BMA_files"
	E2R_Copy_Splash	"${lcSrcFnTitle}"

    lcSrcFnCopy="/BMA_files"
    lcTrgFnCopy="/root/my-applications"
    cp -v -r ${lcSrcFnCopy} ${lcTrgFnCopy}
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v -r ${lcSrcFnCopy} ${lcTrgFnCopy}

	#~ sleep .5
    #~ kill ${GTKPIDCHK}


#########################################
### ft(MNU) #############################
### MNU ### /menu.lst ##########################
### source is real-time menu procs 

    # ### method: E2R_Copy_Splash: kill prev, splash . 

	### 210808 change to E2R real-time files

lcAllFnBase="MNU"		###  
echo ">>> FnBase === ${lcAllFnBase}"	

	#---------------------------------------------------------------
	lcSrcFnTitle="MNU  Menu.Lst"
	E2R_Copy_Splash	"${lcSrcFnTitle}"

    lcSrcFnCopy="/initrd/mnt/dev_save/menu.lst"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    
	#---------------------------------------------------------------
	lcSrcFnTitle="MNU  Menu-Advanced.Lst"
	E2R_Copy_Splash	"${lcSrcFnTitle}"

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-advanced.lst"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 

	#---------------------------------------------------------------
	lcSrcFnTitle="MNU  Menu-Xp.lst"
	E2R_Copy_Splash	"${lcSrcFnTitle}"

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-xp.lst"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    
	#---------------------------------------------------------------
	lcSrcFnTitle="MNU  Menu_Phelp.lst"
	E2R_Copy_Splash	"${lcSrcFnTitle}"

    lcSrcFnCopy="/initrd/mnt/dev_save/menu_phelp.lst"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    
	#---------------------------------------------------------------
	lcSrcFnTitle="MNU  Menu-splash.lst"
	E2R_Copy_Splash	"${lcSrcFnTitle}"
	sleep .5
    kill ${GTKPIDCHK}

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-splash.lst"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    
	#---------------------------------------------------------------
	lcSrcFnTitle="MNU  Menu-Boot-*.lst"
	E2R_Copy_Splash	"${lcSrcFnTitle}"
	sleep .5
    kill ${GTKPIDCHK}

    lcSrcFnCopy="/initrd/mnt/dev_save/menu-Boot-*.lst"
    lcTrgFnCopy="/root/my-applications"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 
    
	#~ sleep .5
    #~ kill ${GTKPIDCHK}



#########################################
### ft(JWM) #############################
### JWM subdir ###############################
### source is real-time sys procs

lcAllFnBase="/usr/share/jwm/tray_templates"	###
echo ">>> FnBase === ${lcAllFnBase}"	

	### 210808 change to E2R real-time files

	#---------------------------------------------------------------
	lcSrcFnTitle="JWM  Tray Templates"
	E2R_Copy_Splash	"${lcSrcFnTitle}"


    lcSrcFnCopy="/usr/share/jwm/tray_templates/jwm-gae-default"
    lcTrgFnCopy="/root/my-applications"
    cp -v -r ${lcSrcFnCopy} ${lcTrgFnCopy} 
    lcTrgFnCopy="/root/my-applications/bin"
    cp -v ${lcSrcFnCopy} ${lcTrgFnCopy} 

	#~ sleep .5
    #~ kill ${GTKPIDCHK}

### <<< end Long Form Copy ###

if [ 0 -eq 1 ] ; then
	lnDummy=0
fi ### end: if [ 0 -eq 1 ]

###################################################################

    # this ONE kill can clear all E2R_Copy_Splash 
    sleep .5
    kill ${GTKPIDCHK} 

###   DONE  ###########################################################



### (D) ### several "DONE" splashes in different colors as Exit Bannering .
### (D) ### several "DONE" splashes in different colors as Exit Bannering .
### (D) ### several "DONE" splashes in different colors as Exit Bannering .

 	#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text   "\ 
   #~ $lcFileE2Rname DONE:." &

    #~ sleep .5
	#~ GTKPID0D0=$!

 	/usr/lib/gtkdialog/box_splash -fg green -bg yellow -close never -text   "       $lcFileE2Rname DONE:-" &

    sleep .5
	GTKPID0D1=$!

    sleep .5
 	/usr/lib/gtkdialog/box_splash -fg orange -bg blue -close never -text    "       $lcFileE2Rname DONE:--" &

    sleep .5
	GTKPID0D2=$!

    sleep .5
#------------------------------------------------------------------------
 	/usr/lib/gtkdialog/box_splash -fg yellow -bg darkgreen-close never -text "\
. 	
. 	    $lcFileE2Rname               
. 	DONE:---DONE:---DONE:---   
.
. 	                                      " &
#------------------------------------------------------------------------
    sleep 3.5
	GTKPID0D3=$!

	#~ E2R_Copy_Splash	"... Killing Splash ..."
    #~ sleep 1.5
    #~ kill ${GTKPIDCHK}

    ### kill the DONE bannering .

    #~ sleep .5
    #~ kill ${GTKPID0D5}
    sleep .5
    kill ${GTKPID0D4}
    sleep .5
    kill ${GTKPID0D3}
    sleep .5
    kill ${GTKPID0D2}
    sleep .5
    kill ${GTKPID0D1}
    sleep .5
    kill ${GTKPID0D0}
    
    echo "==========> kill ---Done ---"

    sleep .1
    kill ${GTKPID0MAIN}   ### main

    Sys_E2R_Cleanup

	kill ${GTKPID0MAIN} 

echo "   E2R block DONE"
echo "<<< back from 'E2R' "
echo "=== Main_E2R {0} mainE2R"

    ### system funxtion "sleep" will timeout and echo "terminated"

    exit 0

    ### Do Not RESTART script auto ###
    ### NO !!!   do not call restart
    ### MGN is the 'caller' 
    ### MGN will handle "ReStart"


### END of E2R script ### end of main() ###
########################################################################
