#!/bin/bash
#  
### rc.z_S2F.sh  main version   (W)ith Notes
#
#--------------------------------------------------------
#(: System Developer Initial DOB 
export gcSysDevDob="221111-0830"
#--------------------------------------------------------
#(: System Developer ID name of this Linux BASH script
export gcSysDevId="S2F"	# this script filename in author's system
#(:

    gcGtkDialog="1"

	# Master Count for Looping Repeated Runs of rc.z_S2F.sh 
	gcLoopCnt="19"
	# Master Count is set to 1, 2, 3, 19 for copies of rc.zS2F#.sh . 

    gcSleepCnt=".3"
    gcSleepCmn="3"
    gcSleepQck=".3"
#(:------------------------------------------------------
 



###############################################################################
### === Signature for top-of-file in Terminal screen ==========================
	/bin/echo -e " "
    lcMsgStr=":${0}:"
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;33m $lcMsgStr \\033[1;37m***\\033[0;39m" # > /dev/console  
### end: Signature ============================================================


#:######################################################################
function Sys_SetVerDts() {   #: A

### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################

#(: export gcS2fDtsVer="$gcSysDevDob"

export gcS2fSysDtsNow="`date +%y%m%d-%H%M-%S`"   ### grave-mark in date() !!!

export gcS2fSysKrn="`uname -r`"
export gcPupKernName="Kern:`uname -r`"

export gcSleepQck=".2"

}
# end: Sys_SetVerDts

  

#:######################################################################
function Sys_PupState() {   #: A

    ### Standard System subroutine from gae library. 
    ### Standard System Var from OS 
    ### called by PreTest()
    ### param
    ### purpose :
    ###     consolidation of PUPSTATE
    ###     control generation of local var
    ### rationale :
    ### Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    ###
    #
    #--- load PUPSTATE --- from only location : "/etc/rc.d/"
    . /etc/rc.d/PUPSTATE
    #
    sleep ${gcSleepCnt}
    #
	echo "BK ==============================================="  
	lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameMount = ${lcSaveFileNameMount}"
	lcSaveFileNameBaseSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameBaseSrc = ${lcSaveFileNameBaseSrc}"
	echo "BK ==============================================="  
	#
    echo " " 
	echo "==============================================="  
    echo ":${MarkPupState}:"
	echo "==============================================="  
    #
    ### direct import, similar varname.
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    lcPupSubDir=${PSUBDIR}
    lcPupDts="`date +%y%m%d-%H%M-%S`"   ### grave-mark in date() !!!
    lcPupHome=${PUP_HOME}
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
	lcPupKernName="Kern:`uname -r`"
#
	if [ -f /tmp/snapmergepuppy-error ] ; then 
		echo "ERROR clear on entry snapmergepuppy ==================" 
		rm -f /tmp/snapmergepuppy-error	### clear on entry
	fi	

}
# end: Sys_PupState





#:######################################################################
function Sfs_PreTest() {   #: A

echo ">>> begin S2F_PreTest"

echo "PupMode=$PUPMODE ...   'nice -n 19 ' version ... trace in terminal"

if [ "$gcGtkDialog" -eq "1" ] ; then 
#-----------------------------------------------------------------------
		lcMsgStr="Pre-Test by PeeBee "
		/usr/lib/gtkdialog/box_splash -fg blue -bg lightgreen -close never -text "$lcMsgStr" &
		GTKPIDPTST=$!
#-----------------------------------------------------------------------
fi

### begin original code from PeeBee

. /etc/rc.d/PUPSTATE	### load current environment constants

echo "(trace-a) "  
if [ $PUPMODE -ne 13 ] ; then
	echo "if [ $PUPMODE -ne 13 ] ; then"
	echo "save2flash: ERROR : Wrong PUPMODE ($PUPMODE)"
	sleep 3
	exit 1
fi

if pidof rc.z_S2F.sh &>/dev/null ; then
	echo "if pidof rc.z_S2F.sh &>/dev/null ; then"
	lcMsgStr="... pidof rc.z_S2F.sh ..."
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console  
else
		lnDummy=0
	lcMsgStr="... NOT ... pidof rc.z_S2F.sh ..."
	/bin/echo -e "\\033[10G\\033[1;37m*** \\033[1;31m $lcMsgStr \\033[1;37m***\\033[0;39m" > /dev/console  
fi

echo "begin: (trace-b) will find pidof Xorg"  
if pidof X &>/dev/null || pidof Xorg &>/dev/null ; then
	echo "if pidof X &>/dev/null || pidof Xorg &>/dev/null ; then"
	echo "if [ -z "$DISPLAY" ] ; then "
	if [ -z "$DISPLAY" ] ; then
		echo "....... -z DISPLAY ......." 
		echo "export DISPLAY=':0'  ???"
		export DISPLAY=':0'
	else
		lndummy=0
		echo "....... NOT -z DISPLAY ......." 
	fi
	sleep .3
else
	lndummy=0
	echo ">>> not  pidof X   or  not pidof Xorg <<<"
	sleep .3
fi

echo "end: (trace-b)"  

### test from original code... from PeeBee

echo "(trace-5) "  
if [ "$1" = "pup_event" ] ; then
		echo "???????"
	echo "if [ '$1' = 'pup_event' ] ; then ???" > /dev/console
	RUNPS="`busybox ps`"
	#some apps should not be disturbed by this background stuff...
	if [ "`echo "$RUNPS" | grep -w -E 'make|cc|gcc|imake|cmake|new2dir|xorriso|xorrecord|xine|gxine|petget|wget|axel|dotpup|mplayer|gmplayer|gcurl|gimv|burniso2cd|growisofs|cdrecord|pcdripper|xfmedia|xmms|ripoff|pdvdrsab|pburn|mhwaveedit|installpkg\.sh|downloadpkgs\.sh|removepreview\.sh'`" != "" ] ; then
		echo "??? ERROR ???"
		sleep 3
		exit 1
	fi
fi
### read


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
### end original code from PeeBee
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

### clear err flg before new run
if [ -f /tmp/snapmergepuppy-error ] ; then
	rm -f /tmp/snapmergepuppy-error
	#~ sleep ${gcCleepCnt} 
fi

if [ "$gcGtkDialog" -eq "1" ] ; then 
#---------------------------------
		sleep ${gcSleepCnt}
		kill $GTKPIDPTST
#---------------------------------
fi

echo "<<< end Sfs_PreTest"
#~ read

}
# end: Sfs_PreTest
########################################################################
########################################################################
########################################################################









#:######################################################################
function S2F_Sync() {   #: A

### begin clear colors ###
### reset to avoid alien values in next gtkdialog
/bin/echo -en "\\033[0;39m"		>  /dev/console	### color clear
/bin/echo -en "\\033[60G"    >/dev/console 
/bin/echo -en "\\033[1;33m"    >/dev/console 
/bin/echo -e  "\\033[0;39m"   >/dev/console 
### end to avoid alien values in next gtkdialog
### end clear colors

### begin clear colors ###
### reset to avoid alien values in next gtkdialog
/bin/echo -en "\\033[0;39m"		>  /dev/console	### color clear
/bin/echo -en "\\033[60G"    >/dev/console 
/bin/echo -en "\\033[1;33m"    >/dev/console 
/bin/echo -e  "\\033[0;39m"   >/dev/console 
### end to avoid alien values in next gtkdialog
### end clear colors

if [ "$gcGtkDialog" -eq "1" ] ; then 
### little <SYNC> red splash 
/usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "." &
    # RETVAL=$?
	GTKPIDSYNC0=$!
    sleep ${gcSleepQck}	
	kill ${GTKPIDSYNC0}

### little <SYNC> blue splash 
/usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
.                                   
.               < SYNC >            
.                                   "&
    # RETVAL=$?
	GTKPIDSYNC=$!
fi

		echo ">>> SYNC  begin ..."
		sync    					### flush buffers 
		echo "<<< SYNC  done ..."

if [ "$gcGtkDialog" -eq "1" ] ; then 
    sleep ${gcSleepQck}	
	kill ${GTKPIDSYNC}
fi

} # end: fx(S2F_Sync)



#~ function S2F_Sync() {
#~ ### little <SYNC>  splash 
#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "< SYNC >"&
    #~ # RETVAL=$?
	#~ GTKPIDSYNC=$!
		#~ echo ">>> SYNC  begin ..."
		#~ sync    					### flush buffers 
		#~ echo "<<< SYNC  done ..."
    #~ sleep ${gcSleepQck}	
	#~ kill ${GTKPIDSYNC}
#~ } # end: fx(S2F_Sync)



#:######################################################################
function S2F_RunSMP() {   #: A

if [ "$gcGtkDialog" -eq "1" ] ; then 
		# SPLASH little green
		lcMsgStr="Running Cnt:${1}--Nice:${2}-${3}"
		/usr/lib/gtkdialog/box_splash -fg blue -bg lightgreen -close never -text "$lcMsgStr" &
fi

# Active RunFile
		nice -n ${2} ${4} /initrd/pup_ro1 /initrd/pup_rw
# Active RunFile

if [ "$gcGtkDialog" -eq "1" ] ; then 
		GTKPIDRUN=$!
		sleep ${gcSleepCnt} 
		kill $GTKPIDRUN
fi

}
# end: fx(S2F_RunSMP)










#:######################################################################
#:#####   MAIN()  ######################################################
#######   MAIN()  ######################################################
#######   MAIN()  ######################################################


### all 'echo' show in Geany "Execute" BASH Terminal screen
### clear previous color settings
### reset to avoid alien values in next gtkdialog

/bin/echo -en "\\033[0;39m"		>  /dev/console	### color clear
/bin/echo -en "\\033[60G"    >/dev/console 
/bin/echo -en "\\033[1;31m "    >/dev/console 

# /bin/echo -e  "\\033[0;39m"   >/dev/console 

echo "======================================================"

echo ">>> SetVerDts ......."
Sys_SetVerDts

echo ">>> PupState ......."
Sys_PupState


### BIG main-splash background for SFS ==================================
### begin setup for tracking Passing Seconds . 
 
### Immediate Now-Date allows trace on time required for each "nice snapmergepuppy" 
	lcSysNowDts00="`date +%y%m%d-%H%M-%S`"   ### grave-mark in date() !!!
	lcSysNowDts00="`date +%y%m%d-%H%M-%S`"		### grave-mark in date() !!!
	lcSysNowDts01="`date +%y%m%d-%H%M-%S`" 		### allow visual timing of each cycle

	lcMsgStrTime="    ----- Start Time ----- ${lcSysNowDts00} "


if [ "$gcGtkDialog" -eq "1" ] ; then 
# SPLASH MAIN BIG brown
# position dependent on left margin 
#-----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg brown -close never -text "\
.   S2F : Cnt=${gcLoopCnt} : ${gcSysDevDob}
.   ${PSUBDIR}:   K:${gcS2fSysKrn}
.   ${lcMsgStrTime}
.
.
.
.
.      nice -> snapmergepuppy ${gcFlgGitHub}
.                                                                        "&
#------------------------------------- col 74 line length for sizing splash

    RETVAL=$?
	GTKPIDMAIN=$!
    sleep ${gcSleepQck}

  /bin/echo "- " 
  /bin/echo "- " 
  /bin/echo "- " 
fi
   

########################################################################
    sleep ${gcSleepQck}

#=======================================================================

echo "======================================================"
echo ">>> PreTest ......."
Sfs_PreTest

echo "======================================================"
echo ">>> Sync ......."
S2F_Sync	# linked into binary 'busybox' 

### SnapMergePuppy always throws this "error flag":
### "/tmp/snapmergepuppy-error"   of  size 0 
###
###     : corrected inconsistent transfer function
###     : via repeated calls to 'snapmergepuppy' .
###	    : added "nice" priority function
###		: "error flag file still generated.

echo "======================================================"
### begin clear colors ### #2 run for this ###
### reset to avoid alien values in next gtkdialog
/bin/echo -en "\\033[0;39m"		>  /dev/console	### color clear
/bin/echo -en "\\033[60G"    >/dev/console 
/bin/echo -en "\\033[1;33m "    >/dev/console 
/bin/echo -e  "\\033[0;39m"   >/dev/console 
### end to avoid alien values in next gtkdialog
### end clear colors


### Top of Standard S2F ################################################
### Set Var ############################################################

### end splash to clear colors 



### MainGui #####################################################################
### MainGui #####################################################################
### MainGui #####################################################################
 
#=======================================================================
#(: test for exist the latest SMP GitHub version.
#(: generate "$gcRunFile" the name of a specific "snapmergepuppy" 

echo "=== select SMP version ======================================="
	if [ -f /usr/sbin/snapmergepuppy-github.sh ] ; then 
		lnDummy=0
		export gcFlgGitHub="<GitHub>"	# display in splash
		export gcRunFile="/usr/sbin/snapmergepuppy-github.sh  /initrd/pup_ro1 /initrd/pup_rw"
	else
		lnDummy=0
		export gcFlgGitHub="-"
		export gcRunFile="snapmergepuppy  /initrd/pup_ro1 /initrd/pup_rw"
	fi


#=======================================================================

# begin === While Do Done =====================================================
#  1            2            3              4  
# "$gcRunCnt" "$gcNiceNum" "$gcFlgGitHub" "$gcRunFile"

# receives gcRunCnt, gcNiceNum, gcFlgGitHub, gcRunFile 

	#~ touch "/0-S2F-0-DTS.mark"

echo "=== Run LoopCnt ==================================================="
#:######################################################################
	WAITCNT=${gcLoopCnt}
#:######################################################################
	while [ ${WAITCNT} -gt 0 ];do
	 	# Active RunFile
		gcRunCnt="${WAITCNT}" && gcNiceNum="19" && S2F_RunSMP "$gcRunCnt" "$gcNiceNum" "$gcFlgGitHub" "$gcRunFile"
		# Active RunFile
		WAITCNT=`expr $WAITCNT - 1`
		echo -n " $WAITCNT" >/dev/console
	done
#:######################################################################

#=======================================================================
#=======================================================================
#=======================================================================


### that's all. 

  /bin/echo "- " 
  /bin/echo "- " 
  /bin/echo "- " 
  /bin/echo " " > /dev/console


lcSysNowDtsDone="`date +%y%m%d-%H%M-%S`" 

echo "==== DONE =================================================="

if [ "$gcGtkDialog" -eq "1" ] ; then 
# Splash ALL DONE plus elapsed time
lcMsgStr="DONE : ${gcFlgGitHub} : ${lcSysNowDtsDone}"
#-----------------------------------------------------------------------
	/usr/lib/gtkdialog/box_splash -fg darkgreen -bg yellow -close never -text "${lcMsgStr}" &
	GTKPIDDONE=$!
#-----------------------------------------------------------------------
    sleep ${gcSleepCmn}

#=======================================================================

	kill ${GTKPIDSMP}	### has lingered behind in background
    sleep ${gcSleepQck}
	kill ${GTKPIDDONE}
	sleep ${gcSleepQck}
    kill ${GTKPIDMAIN}	### has lingered as background
fi

### End: Standard S2F ################################################

  /bin/echo " "
  /bin/echo " "
  /bin/echo " "
  /bin/echo " "

#:######################################################################
### optional documentation sent to terminal 

if [ 1 -eq 0 ] ; then

  /bin/echo -n -e "\\033[1G" 
  /bin/echo -n -e "\\033[1;35m" 

lcParStr="
### (S2F) ##############################################################
###
### The Sfs_PreTest gives some protection 
### that there is no other 'snapmergepuppy' running 
### which may be actively altering the system DATA.
###
### Note: 
### SaveDATA (File or Folder) must be 'Static' 
### 	so the data will be pure. 
### SaveDATA must be 'Static' ( no other SnapMergePuppy running ) 
### 	during any Backup Operation by any utility 'backup' program. 
### Any Other system processes must be on 'hold', so nice = 19 .  
### Otherwise, 
###		there is (logically) possible erroneous data transferred 
### 	during the Save2Flash operation. 
###
### This 'Static DATA' requirement is common to all Backup Programs. 
### This 'Static DATA' requirement is the reason that our S2F program 
### 	makes use of the 'nice' process 
### 	to prioritize 'snapmergepuppy' to a high level, 
### 	thus placing other system functions on 'hold' 
### 		during the Save2Flash operation. 
###
### Multiple cycles (re-runs) of S2F due to SMP error flag observed in Terminal.
### This error flag is from the binary processes, not in BASH code. 
### It has been noted ( via Murga Forum ) 
###   that that SMP process is running to the end of a list 
###   and is thus setting a non-fatal error flag. 
###
### Repeated runs using the 'nice' BASH command is used for this reason, 
###     in order to give high priority to 'snapmargepuppy'. 
###     and run SMP until the error flag disappears (almost). 
###     Sometimes 19 runs will reduce the flag to a single instance. 
###
###	'sync' is only a link into binary 'busybox' . 
###
### (S2F) ###############################################################"

	/bin/echo -n "$lcParStr"  
	/bin/echo -e "\\033[0;m" 

    /bin/echo -n -e "\\033[1G" 
    /bin/echo -n -e "\\033[1;31m" 

lcParStr="
### (S2F) ###############################################################
*** 'nice' BASH command : 
Usage: nice [OPTION] [COMMAND [ARG]...]
Run COMMAND with an adjusted niceness, which affects process scheduling.
With no COMMAND, print the current niceness.  Niceness values range from
-20 (most favorable to the process) to 19 (least favorable to the process)."

	/bin/echo -n "$lcParStr"  
	/bin/echo -e "\\033[0;m" 

    /bin/echo -n -e "\\033[1G" 
    /bin/echo -n -e "\\033[1;32m" 

lcParStr="
### (S2F) ###############################################################
*** 'nice' BASH command : 
Mandatory arguments to long options are mandatory for short options too.
  -n, --adjustment=N   add integer N to the niceness (default 10)
      --help     display this help and exit
      --version  output version information and exit

NOTE: your shell may have its own version of nice, which usually supersedes
the version described here.  Please refer to your shell's documentation
for details about the options it supports.
###(S2F) ###############################################################"

	/bin/echo -n "$lcParStr"  
	/bin/echo -e "\\033[0;m" 


#:######################################################################
### SMP = "snapmergepuppy" 
###
### SMP always sets  "/tmp/snapmergepuppy.lock"     !!!
### SMP always clears "/tmp/snapmergepuppy.lock" 
###		and
### SMP always sets  "/tmp/snapmergepuppy-error"
### SMP always clears "/tmp/snapmergepuppy-error"  !!!
#-----------------------------------------------------------------------

fi
# end: if [ 0 -eq 0 ] 

	if [ -f /tmp/snapmergepuppy-error ] ; then 	### from SMP and taropt 
		echo "snapmergepuppy - EXIT - ==========================" 
		rm -f /tmp/snapmergepuppy-error		### clear on EXIT
	fi	

	if [ -f /tmp/flagnextpassthru ] ; then 		### from SMP and taropt 
		echo "flagnextpassthru - EXIT - ==============================" 
		rm -f /tmp/flagnextpassthru			### clear on EXIT
	fi	



###  return 0 # this is only for function() 'return'  
echo "=== DONE === " 

### END ### 
########################################################################





