#!/bin/bash
#  
#(: rc.z_C2M ,    "Change 2 Menu "   ,  using the "FrameWork"
#(:  .sh format so GEANY sees a 'script' executable.
#(:  chmod +x rc.z_C2M.sh
#
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer Initial DOB 
export gcSysDevDobPrev=""
export gcSysDevDob="220913-1552"		
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#(: System Developer ID name of this Linux BASH script
export gcSysDevId="C2M"	
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

#:### PATH  "rc.sysinit" calls "functions_x" to check/link "/etc/rc.d"
#:### PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/root/my-applications/bin/ 
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/usr/lib/gtkdialog/:/root/my-applications/bin/ 





#(: dependency on these two standard Puppy programs :
#(:     gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
#(:        Built with support for: GTK+ 2, Glade.
#(:     gxmessage-2.12.4
#(:        Copyright (C) 2009 Timothy Richard Musson
#
#(: "lc" var are 'local' and subject to change / reuse / reassignment 
#(: "gc" var are 'global' and should not be changed. 
#(:      Always copy into 'lc' for use .
#(:
#(: method of Programmer Docs and Linux Comments.
#(: "#(:" Docs are retined by "CNN" 
#(:       used for Prog Dox to build Documentation for project . 
#(:       CNN will pull these out to a separate file for project. 
#(: "#:"  Comments are culled via "CNN"
#(:       used for common comments 
#(:       CNN will kill these common comments, for min prog/script size.
#(: 




#=== List of FOUR developing OS ===

#"Ubuntu Jammy Jellyfish 22.04 + some Debian Bullseye"
# gcSysDevEol="April 2027"  

#"Ubuntu Bionic Beaver 19.03"
# gcSysDevEol="May 2025"  

#"Ubuntu Focal Fossa" 
#"PuppySlacko-7 v.14.2"

# "Slacko-7" 
# "slacko-7.0_DpupS7_14.2"

###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




#(: ;;; FrameWork for Header for each SubRoutine ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(:		copy this framework directly into all developing sub-routines
#(:		as the "Sys" standard method of
#(:		(1) recording Developer's VerDts
#(:		(2) recording the Linux Sys Documented ID info.
#(:     (3) documenting sub-routine's "modus operandi".
#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx( )
#(: called by: 
#(: param: 
#(: purpose: 
#(: call this way: 
#(: calls: 
#(: returns: 
#(: method: 
#(: rationale: 
#(: note: 
#(:


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#
#(: Geany Execute Terminal is: 
#(: /usr/bin/xterm -e bash -c -e "/bin/sh %c"
#
#(: C2M will be used in 13+ Linux Puppy OS, so DISTRO_SPECS var and PUPSTATE var/info must be floating. 
#(: ie; to be loaded by each OS at run-time. 
#(: DISTRO_SkPECS: "${DISTRO_NAME}" "${DISTRO_VERSION}" "${DISTRO_PUPPYSFS}" 
#(:    "$DISTRO_DB_SUBNAME" "${DISTRO_PUPPYDATE}" "{$BUILD_FROM_WOOF}"
#
#(:  PUPSTATE: "$PUPMODE", "$PDEV1", "$DEV1FS", "$PUPSFS", "$PUPSAVE", "$PMEDIA"  
#
# Linux BASH command "cut" help 
# 	PUPSAVE has these:
# 	PUPSFS='sda1,ext4,/pup_UpupFF-sda/puppy_upupff+d_20.12.sfs'
# 	PUPSAVE='sda1,ext4,/pup_UpupFF-sda/upupff+dsave-D08-sda-D'
# f = field,  N = Numbered field, -d is delimiter 
# so, -f N -d "/" 
# is  cut -f 3 -d "/" 
#    cut field #3 out to delimiter 
# and   lcPUPSFS  is cut -f 3 -d "/" "$PUPSFS"
#       lcPUPSAVE is cut -f 3 -d "/" "$PUPSAVE"
# so this example:
#    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" 
#
# lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
# lcSaveFileNameBaseSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
#
# lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" # B2T 'cut' savefilename from PUPSTATE file
#   	### f third field, comma delimited, "/" to end
# lcPupSaveNameDts="NameDts = ${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`" ### grave-mark in date ( ) !!!
#


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_SetVerDts)   #: A
#(: called by: Main
#(: param: 
#(: purpose: 'gc' and 'Sys' System Standard Constants can be installed here.
#(: call this way:  Sys_SetVerDts
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note: 
#(:

#:######################################################################
function Sys_SetVerDts() {   #: A
#
# ln(dummy)={x["''"]}
lnDummy=0 # common "stub" so bare funxtion() will not fault during test/dev. 
# ln(dummy)={x["''"]}
lnDummy=0 # common "stub" so bare funxtion() will not fault during test/dev. 
#ATADRIVES is all internal ide/pata/sata drives, excluding optical, excluding usb...
ATADRIVES='sda sdb sdc sdd sde sdf sdg sdh sdi '
#ATAOPTICALDRIVES is list of non-usb optical drives...
ATAOPTICALDRIVES='sr0 '
#these directories are unionfs/aufs layers in /initrd...
RW_LAYER='/pup_rw'
SAVE_LAYER='/pup_ro1'
PUP_LAYER='/pup_ro2'


### OK to wait until PUPSTATE is mounted/loaded, then assign most values in funxtion(Sys_PupState) . 

gcSysDts="`date +%y%m%d-%H%M-%S`"   ### Sys_SetVerDts
		### Note: grave-mark in date ( ) !!!

#(: gcSysDtsNow 
#(: 		### Rationale: some Puppy OS default to GMT, we prefer Local time. 
#(: 		### This is Attempt to generate a "NOW" this moment date-time constant.
#(: 		### Date : grave-mark in date () !!!
#(: 		###  Dts="`date +%y%m%d-%H%M-%S`"
#(: 		### adust from default "z" time 
#(: 		###		to local mid-america dts ( -5 hours ). 
#(:			###		Does not calc DayLightSavingsTime
#(:			###		But still a consistent error day-to-day. 
#(: 	lcNowDts=""
#(: 	lcNowDts="`date +%y%m%d%H%M-%S`"
#(: 	lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:7}"
#(: 	gcSysDtsNow="${lcNowDts}-local"
#(:
 
lcNowDts="${lcNowDts:0:6}-${lcNowDts:6:7}"
gcSysDtsNow="${lcNowDts}-local"

gcSysDtsNow="${lcNowDts}"
	#
	### common location of all "My_Dev" executable Editing Source Code
gcSys_MyDev="/initrd/mnt/dev_save/MY_/usr-share/My_Dev_"

	# log remains in /tmp for record until OS shutdown.
gcMntAllLogP="/tmp/C2M_MntAllP.log "
gcMntAllLogU="/tmp/C2M_MntAllU.log "

#	gcMntAllLogP="/tmp/C2M_MntAllP.log "
#	gcMntAllLogU="/tmp/C2M_MntAllU.log "


#######################################################
#   "C2M_HEADER" related to DISTRO_SPECS and PUPSTATE
#######################################################

	echo "   . " 
. /etc/rc.d/PUPSTATE
. /etc/DISTRO_SPECS

### === Signature === main ============================
# rc.sysinit Header
# PUPSTATE already loaded
# DISTRO_SPECS already loaded
export gcSysDistroName="${DISTRO_NAME}"
export gcSysDistroVersion="${DISTRO_VERSION}" 
export gcSysDistroPuppySFS="${DISTRO_PUPPYSFS}"
export gcSysDistro_Db_Subname="$DISTRO_DB_SUBNAME"		
export gcSysKernPup="`uname -r`"
export gcSysKernName="Kern:`uname -r`"

########################################################################
### === Signature for top-of-file === appears in terminal 

# begin: Signature 
# Display system funxtions not setup yet.  So, Must echo this way. 	
	lcMsgStr="...${0}......."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;31m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DobPrev:=${gcSysDevDobPrev}..." 
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DevDob:=${gcSysDevDob}...."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DistroName:=${DISTRO_NAME}..."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DistroVer:=${DISTRO_VERSION}..."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
	lcMsgStr="DistroDbSubname:=${DISTRO_DB_SUBNAME}..."
		/bin/echo -e "\\033[5G\\033[1;37m*** \\033[1;33m$lcMsgStr\\033[1;37m***\\033[0;39m" 
# end: Signature 

} # end: fx(Sys_SetVerDts)
########################################################################







#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sbr_Str2DevTrm)  #: A
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note :   
### 
### Str2DevTrm displays to "/dev/console"  as used by rc.sysinit and rc.shutdown 
###
### version for Geany BASH LxTerminal ( "Str2Trm" used by C2M.sh is embedded in C2M.sh )
###
    ### called by Main ()
    ### purpose: Standard Message-2-Terminal routine 
    ###    designed for use from Geany Execute Terminal 
	###    does not display into /dev/console 
	###		unless ReDirect lcDevConsole=" > /dev/console" is enabled. 
    ### param: "char string" "# color" "# margin"
    ### purpose : generate system date/time constants.
    ### rationale : One Time Manual Entry   for Geany "terminal" use.
    ### note :
    ###		bash can're-type' under some circumstances. 
###
### if using Geany "BASH terminal" for tracing, 
### then must use Sbr_Str2DevTrm() 
### which is done in C2M.sh, E2R.sh, S2F.sh, C3C.sh, CTB.sh, GTK.sh, et al .  
###
    ### usage:
    ###    Sbr_Str2DevTrm "string" "color" "margin"
    ###    Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    ###    Sbr_Str2DevTrm "$lcMsgStr" "2" 15
    ###    Sbr_Str2DevTrm "$lcMsgStr"  3  10
	###
    ###  Shell script variables are not "typesafe,	
	###	BASH may 'type convert'  char vs number
    ### example:
    ###    lcMsgStr="xxx" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    ###    lcMsgStr="xxx" && Sbr_Str2DevTrm "$lcMsgStr"  2    3
	###
    ### returns: action
	###
### alternative tests : param zero check and substitution:
### [ -z "${1}" ] && lcParStr="message"	### string
### [ -z "${2}" ] && lcParClr="5"  ### color :  1,2,3,4,5   for  red,grn,yel,blu,pur
### [ -z "${3}" ] && lcParMrg="3"  ### margin : 1,2,3,4,5  where mrg=5,10,15,20,25,30
#
#:######################################################################
function Sbr_Str2DevTrm() {   #: A
#
### capture all params
lcS2TStr=${1}   ### STRING message 
lcS2TClr=${2}   ### COLOR name or number
lcS2TMrg=${3}   ### MARGIN number 1,5,10 ... 2,3,4,5,etc
### 
lcS2Topt=${4}	### "C"onsole "T"erminal
#
lcDevConsole=""	### default to "T"erminal 
#
### Sbr_Str2DevTrm	##########################################
###   Control ReDirect to "Console" or "Terminal" 
###   Normal default to "T"erminial 
#
### ReDirect 
case "${lcS2Topt}" in
   "C") lcDevConsole=" > /dev/console" ;; 
   "T") lcDevConsole="" ;; 
    *)  lcDevConsole="" ;;	### default "T"erminal mode
esac
#
### Sbr_Str2DevTrm	##########################################
### if exist, then trap margin from param#3  as "number"|"char"   
### default left-margin=10 for Sbr_Str2DevTrm
### if ${lcDevConsole} ;; used for margin, then error = "ambigious redirect" 
#
### Margin 
case "${lcS2TMrg}" in
   0|"0") /bin/echo -n -e "\\033[0G"    >/dev/console ;; 
    *) /bin/echo -n -e "\\033[${lcS2TMrg}G"    >/dev/console ;;
esac
### 
### Sbr_Str2DevTrm	##########################################
### trap color from param#2  "name"|"number"   ### default is "3" 
### Color: red, grn, yel, blu, pur, cyn, wht, wblu, wgrn, wgry
#
### Color
case "${lcS2TClr}" in
    ""|"0")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;;
    *)  /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; ### default = yel
esac
###
### Sbr_Str2DevTrm	###########################################
###   ${lcDevConsole}
	/bin/echo -n "$lcS2TStr"  ${lcDevConsole} 
	/bin/echo -e "\\033[0;m"  ${lcDevConsole} 
	return  0
###
} # end: fx(Sbr_Str2DevTrm)



#(: =====================================================================
#(: fx(Sys_Dump_HLP)	#: A guiHLP+
#(: called by:  Main_GUI
#(: param: 
#(: purpose:  MGN Help general
#(: calls: 
#(: method:  > /tmp/box_help & /usr/lib/gtkdialog/box_help 
#(: sends: 
#(: rationale: 
#(: note : 
#(: 	gtkdialog/box_help will handle format and embedded color text codes. 
#(: 	xmessage will NOT handle format and color embedded text codes.
#(: 	system gtkdialog "box_help" location is  '/usr/lib/gtkdialog/box_help'
#(:	note: uses CTB code
#(:
 
### gcMgnDob is declared/assigned at beginning (top) of program
### fx(MGN_SetVerDate) is called at top of '=== MAIN ( ) ==='

### echo this out as one long string, to standard /tmp/help_box
### then call it via Sbr_Box_Message "=== 'Sbr_Box_Message' for '/tmp/box_help'"

#:######################################################################
function Sys_Dump_HLP() {   #: ACTIVE
n=0
lcSysNameBase="C2M"

	echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "========"</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"     "${lcSysNameBase}" Help "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "========" </span></span>

<b><span foreground='"'green'"'>"'Change 2 Menu'"</span></b>
#
### Further Reading at Murga Linux Forum /utilities.
### forum.puppylinux.com/viewtopic.php/ 
### search for topic
#

# gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
# Built with support for: GTK+ 2, Glade.
#


............................................................."\
> /tmp/box_help
# copy from CTB code 
Sbr_Box_Message "=== HELP === 'Sbr_Box_Message' > /tmp/box_help + box_help"

#~ /usr/lib/gtkdialog/box_help  "Puppy_Manager_Help !!!" \
#~ "https://forum.puppylinux.com/viewtopic.php?f=106&t=622"
#~ rm -f "/tmp/box_help"       ### remove the lingering temp file. 

# falls thru to MGN_ReStart

	# BasePIDFile is "/tmp/box_help"
	# output storage file MUST BE "/tmp/box_help" due to hard-code in "gtkdialog/box_help"
} #
# end: fx(Sys_Dump_HLP)



#(: ====================================================================
#: fx(Sbr_ARB_init)   #: A
#(: called by: 
#(: receives param: 
#(: purpose:  read config, then 'cat a single line of data into a var
#(: usage :
#(: returns: 
#(: method: 
#(: note:
#(: purpose:

function Sbr_ARB_init() {   #: A 

    gcC2MConfigArbFn="/root/my-applications/bin/C2M_Config_Arb"   #: ? ASSIGNED fx(Sys_PupState)

if [ -f ${gcC2MConfigArbFn} ] ; then  #: read config 	
    lnDummy=0
    # "cat" command is ticky
    # this subdir is always visible to system via PATH.  
    #    But, "/C2M_Config_Arb" was not visible (?) . 
    gcC2MConfigArbId=`cat ${gcC2MConfigArbFn}`   #:  extract and export Idd
    #
    chmod +x ${gcC2MConfigArbFn}
    # verify 
    echo "gcC2MConfigArbId:${gcC2MConfigArbId}:"
    # not required:  "export" 
    # this method of 'cat skips requirement for 'permissions' , from CTB
else
	#  Not Found" 
    # make an empty example file 
    touch ${gcC2MConfigArbFn}
    #
    # trace
	gcC2MConfigArbId="??"	  # insert dummy
    echo "${gcC2MConfigArbId}" > ${gcC2MConfigArbFn}

	echo "ID:gcC2MConfigArbId:${gcC2MConfigArbId}:"
	echo "FN:${gcC2MConfigArbFn}:Not Found:"
# -----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
.     ${gcC2MConfigArbId} Not Found  
.     ${gcC2MConfigArbFn} empty file created   
.                                               "&
# ------------------------------------------------------------------------
        RETVAL=$?
        GtkPid_Sbr_Box_Splash=$!	# capture PID
        sleep 3
        kill ${GtkPid_Sbr_Box_Splash} 
        #
fi
} 
# end: #: fx(Sbr_ARB_init)


 


##############################################################
##############################################################
##############################################################
#(: begin: CTB Sbr Box DATA Dump SubRoutines

#(: ====================================================================
#(: fx(Sbr_Box_Message)	  #: A
#(: internal mod on gtkdialog box_help 
#(: called by : 
#(:    GuiHLP+  to  fx(Sys_Box_HLP)  to  Sbr_Box_Message
#(:    GuiFAQ+  to  fx(Sys_Box_FAQ)  to  Sbr_Box_Message
#(:
#(: receives param : Header$1 and loads '/tmp/box_help'
#(: purpose : custom Simple Message sbr 
#(:   based on gtkdialog box_help code processes.
#(: usage :
#(:   HEADING is a short "title bar" description. 
#(:   XML code is custom written to format "/tmp/box_help".
#(: returns: 
#(: method: 
#(:     gtkdialog --center -p XML-Format-file (which loads /tmp/box_help ) 
#(:
#(: note:
#(: purpose :  Simple Message sbr based on gtkdialog box_help
#(:   which allows author to change the "lead-in" XML code 
#(:   and thus change the "format" of this custom "message_box". 
#(:   Sbr_Box_Message does provide a "OK" user button. 
#(:   Sbr_Box_Message does provide a "markup" on text. 
#(:   Sbr_Box_Message does allow dimension changes. 
#(:   Sbr_Box_Message does not require a "URL" param.
#(: note:
#(:   XML assumes /tmp/box_help and "gtkdialog -p" internal code. 
#(:   XML sets up the markup and color options for the imported text. 
#(:   XML sets up the "OK" control button, and will show/close/"OK"
#(:
#
#:###################################################################### 
function Sbr_Box_Message() {   #: A 
#
lnDummy=0
#
export TEXTDOMAIN=libstardust
export OUTPUT_CHARSET=UTF-8
#
# we are allowing a param for "HEADING"
if [ "$1" ] ; then
	Box_Msg_Heading="${1}"	# parm #1 if sent. 
else	# else simple standard 'heading'.
	Box_Msg_Heading="$(gettext '---Sbr_Box_Message---')"
fi
#
export Box_MessageXML='
<window title="'$Box_Msg_Heading'" default-height="550" default-width="760">
<vbox space-expand="true" space-fill="true">
  <vbox space-expand="true" space-fill="true">
    <vbox scrollable="true" shadow-type="3" space-expand="true" space-fill="true">
      <vbox space-expand="false" space-fill="false">
        <text xpad="10" ypad="15" use-markup="true"><input file>'/tmp/box_help'</input></text>
      </vbox>
    </vbox>
  </vbox>
  <hbox space-expand="false" space-fill="false">
    <button>
      '"`/usr/lib/gtkdialog/xml_button-icon ok`"'
      <label>'$(gettext 'Ok')'</label>
    </button>
  </hbox>
</vbox>
</window>'
 #
 # same as eval "`gtkdialog --center -p Box_MessageXML`" 
gtkdialog --center -p Box_MessageXML	# assumes /tmp/box_help
#
# This gtk box sub-routine shows text via "gtkdialog box_help" code.
# This "gtkdialog -p" will read the default '/tmp/box_help' file via "XML" code block. 
# The XML code block sets up the markup and color options for the imported text. 
# (1) Markup/color are valid
# (2) Sets up the "OK" control button, and will show/close/"OK"
#
} # end: fx(Sbr_Box_Message) # CTB Active
#
#(: end: CTB Sbr Box DATA Dump SubRoutines
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
########################################################################



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_Dump_HLP)	# guiHLP+
#(: called by:  Main_GUI
#(: param: 
#(: purpose:  C2M Help general
#(: calls: 
#(: method:  > /tmp/box_help & /usr/lib/gtkdialog/box_help 
#(: sends: 
#(: rationale: 
#(: note : 
#(: 	gtkdialog/box_help will handle format and embedded color text codes. 
#(: 	xmessage will NOT handle format and color embedded text codes.
#(: 	system gtkdialog "box_help" location is  '/usr/lib/gtkdialog/box_help'
#(:	note: uses CTB code
#(:
 
### gcSysDevDob is declared/assigned at beginning (top) of program
### fx(C2M_SetVerDate) is called at top of '=== MAIN ( ) ==='

#:######################################################################
function Sys_Dump_HLP() {   #: N
#

### echo this out as one long string, to standard /tmp/help_box
### then call it via Sbr_Box_Message "=== 'Sbr_Box_Message' for '/tmp/box_help'"

	echo "\
<span background='"'brown'"'><span foreground='"'yellow'"'> "========"</span></span>\
<span background='"'yellow'"'><span foreground='"'blue'"'>"     "${gcSysNameBase}" Help "</span></span>\
<span background='"'brown'"'><span foreground='"'yellow'"'> "========" </span></span>

<b><span foreground='"'green'"'>"'Puppy Change-2-Menu'"</span></b>

<span foreground='"'blue'"'>"Authors note about 'C2M' BASH coding :"</span>
C2M code is <span background='"'white'"' foreground='"'red'"'>"documented code "</span>
C2M code is <span background='"'white'"' foreground='"'green'"'>"modular  code "</span>
C2M code is <span background='"'white'"' foreground='"'green'"'>"readable code "</span>
C2M code is <span background='"'white'"' foreground='"'green'"'>"modifiable code "</span>

###########################
 Note abt '${gcSysNameBase}_help_box':
 If scripting Error in Help Page,
 then Help Page may fail.
###########################

"'Further Reading'" links to Murga-Linux
under Murga 'FileSystem' topic
which contains our 'current-version.zip'
and user notes.




Caution:
If you have multiple Linux OS media mounted,
then the wrong one may become live !
due to a sequential search. 
Check your OS systems for specific names.
Use unique subdir names for unique OS systems. 
We use unique subdir names 
like '"/pup-UpupJJ-sda"' and '"/pup-UpupBB-sda"' 
which contain a reference '"sda"' to a specific HD.
OS mounted/booted on other HD 
contain a HD reference likd '"hlx"' and '"lex"', etc. 

<span foreground='"'red'"'>"Note on running executable BASH script :"</span>
Always check the file "\'set action\'"
... ' $ @ '  'Use-Command'
Always check the file "\'type\'"
... 'Exec'
Always check the file "\'Properties\'"
... 'Exec'
Always check the file "\'Permissions\'"
...'Executable'
Always examine other running scripts
to see how Your System is setting things.


<span foreground='"'red'"'>'"ROX Debug Method :"'</span>
Use the ROX 'Run in Terminal' to Execute a script.
<span foreground='"'red'"'>'"Geany Debug Method :"'</span>
Use the Geany Execute funxtion
   to run the script 'BASH-Terminal'
All 'echo' commands will display.

<span foreground='"'blue'"'>"About : "</span> <span foreground='"'green'"'>"${gcSysNameBase}"</span>
<span foreground='"'green'"'>"${gcSysNameBase} is a Simple Modular Program ! "</span>
<span foreground='"'green'"'>"${gcSysNameBase} has few Bells / No Whistles ! "</span>
<span foreground='"'green'"'>"${gcSysNameBase} has few Hidden Options ! "</span>
<span foreground='"'green'"'>"${gcSysNameBase} is easy to Read / Modify ! "</span>

# This CAVEAT:
# <span foreground='"'red'"'>"Do Not Un-Plug the Flash Drives !"</span>
# <span foreground='"'green'"'>"because they may still be shuffling data"</span>
# <span foreground='"'green'"'>"into the final storage place on the chip."</span>
# <span foreground='"'red'"'>"Do Call" <span foreground='"'purple'"'>"'pmount'"</span> "to handle the Flash Drives !"</span>
#


### output "HELP" temp file MUST BE "/tmp/box_help" 
### due to hard-code in "gtkdialog/box_help"

... '"Help"'   will run, and return to ''Main_Gui''.
... '"Source"' will run, and 'ReStart' this program. 
... '"BackUp"' will run, and 
...     ... then do a fresh 'ReStart' program to ''Main_Gui''.
... ''User'' should Run '"${gcSysNameBase}"' script 
...    in '"Geany"' or '"ROX"' '"terminal"'
...    to view/trace action of internal operations !

#
### Further Reading at Murga Linux Forum /utilities.
### forum.puppylinux.com/viewtopic.php/ 
### search for topic
#

# gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
# Built with support for: GTK+ 2, Glade.
#
.
.
............................................................."\
> /tmp/box_help
# copy from CTB code 
Sbr_Box_Message "=== HELP === 'Sbr_Box_Message' > /tmp/box_help + box_help"

	### BasePIDFile is "/tmp/box_help"
	### output storage file MUST BE "/tmp/box_help" due to hard-code in "gtkdialog/box_help"
} # end: fx(Sys_Dump_HLP)


### last lines: first param is title :
###     "C2M_Help_Box"
### last lines: second param is "Further Reading" URL
###     "http://murga-linux.com/puppy/viewtopic.php?p=1050224"
### URL string will not penetrate the NEW MURGA SECURE program. 
#
### call fx(C2M_Help_Box) 
#
### NOTE: 
### > /tmp/box_help
### /usr/lib/gtkdialog/box_help  "Pupsave-Back-2-Tar-Help" \
### "http://murga-linux.com/puppy/viewtopic.php?p=1050224"
### Reference string does not work on NEW MURGA SECURE CODE ! 
# 
### NOTE:
### /usr/lib/gtkdialog/box_help is the only dialog that is useful for "Help" .
### per /usr/lib/gtkdialog/box_help
### because 'box_help' displays the formatting and color codes
###
### gtkdialog source textfile name is hard-coded into 'box_help' : 
###     <text xpad="10" ypad="15" use-markup="true"><input file>/tmp/box_help</input></text>
###     <input file>/tmp/box_help</input>
### thus: 
###     only one "box_help" at a time. 
###
### see CTB , C2M , GTK programs for gtk-dialog example "FAQ" 
###
### Notes:
### last lines: first param is title :
###     "C2M---Change-2-Menu---Help"
### last lines: second param is "Further Reading" URL
###     "http://murga-linux.com/puppy/viewtopic.php?p=1050224"
### call fx(Sys_Help_Box)
###
### > /tmp/box_help
### /usr/lib/gtkdialog/box_help  
### "Cold-Tar-Backup utility for frugal Puppy installs" 
### "https://forum.puppylinux.com/viewtopic.php?f=106&t=622&i=1"
#
### NOTE:
### Alternative method based on 'help_box' is NOT viable: 
### rationale: 'help_box' has many formatting options and colors. 
#
#lcSourceTxt="/tmp/box_source"   
#echo  "${gcZeroRun}" >> ${lcSourceTxt}  
### $ ZERO ### deposits copy of source code, 
### but 'help_box' does not 'see' file in proper format. 
#
#/usr/lib/gtkdialog/box_help  ${lcSourceTxt} 
## "PupSave...DATA"  \
## "http://murga-linux.com/puppy/viewtopic.php?p=1050224" 
#rm -f "${lcSourceTxt}"       ### remove the lingering temp file. 
### does not kill a splash of itself !!! 
# kill ${lcSourceTxt}
#
########################################################################





#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(C2M_ClearFlags)
#(: called by: Exit:ARB_00, et al 
#(: param: 
#(: purpose: Clear ALL Flags
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : some flags are still hard-code ; ie, LockFile , BackUpStatus
#(:
#:######################################################################
function C2M_ClearFlags() {   #: N
#
	###  
	lnDummy=0

    lcMsgStr=">>> Clear Temp Files <<<" && Sbr_Str2DevTrm "$lcMsgStr" "5" "4"

### main splash
#~ lcMsgStr="... Clear Temp Files ... "
#~ /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "${lcMsgStr}" &
#~ ###################################### col 74 line length for sizing splash
    #~ RETVAL=$?
	#~ GTKPIDMAIN=$!
	#~ sleep .6
	#~ /bin/echo " " > /dev/console
	#~ #
	#~ kill ${GTKPIDMAIN}

	### FIXIT ### clear flag/Lock-Files in /tmp
	### which are applied during run of rc.z_C2M.sh

		# ReRun C2M may require a lingering temp flag. 
		# for menu "applied" posting on next Re-Run of C2M. 
		
		#(: Status Flags should Carry-Over
		# rm -f "${C2M_TouchCBXstatus}" ### CBX applied flag must linger for GUI	# Carry-Over
		# rm -f "${C2M_E2Rstatus}"	### E2R applied flag must linger for GUI 		# Carry-Over
		# rm -f "${C2M_BackUpStatus}" ### CBX applied  flag must linger for GUI		# Carry-Over

		### not used xxx rm -f "${CTB_lockfile}"  ### release 'Running' flag.

		#~ rm -f "${C2M_LockFile}"  ### this is "C2M_LockFile"	###  but not E2R  CBX

		rm -f "/tmp/snapmergepuppy-error"  ### this is SMP flag ,  Not Used 

		rm -f "/tmp/box_help"       ### remove the lingering temp file. 

		#~ rm -f "/tmp/box_source"       ### remove the lingering temp file. 

	/bin/echo " " > /dev/console
	#
	#
}	### end: C2M_ClearFlags







### do EDITING above ######################################################








        #(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        #(: fx(C2M_SYNC)   #: N   #: Not Required
        #(: called by:
        #(: param: 
        #(: purpose: 
        #(: calls: 	
        #(: method: 
        #(: sends: 
        #(: rationale: 
        #(: note : 
        #(: 
            # '/sbin/sync' is a link into 'busybox' binary '/bin/busybox'
            # begin clear colors # have experienced alien colors downstream.
            # reset to avoid alien values in next gtkdialog
            # /bin/echo -en "\\033[0;39m"		>  /dev/console	### color clear
            # /bin/echo -en "\\033[60G"    >/dev/console 
            # /bin/echo -en "\\033[1;33m"    >/dev/console 
            # /bin/echo -e  "\\033[0;39m"   >/dev/console 
            #  end to avoid alien values in next gtkdialog
            #  end clear colors

            # begin clear colors ###
            # reset to avoid alien values in next gtkdialog
            # /bin/echo -en "\\033[0;39m"		>  /dev/console	### color clear
            # /bin/echo -en "\\033[60G"    >/dev/console 
            # /bin/echo -en "\\033[1;33m"    >/dev/console 
            # /bin/echo -e  "\\033[0;39m"   >/dev/console 
            # end to avoid alien values in next gtkdialog
            # end clear colors

        #:######################################################################
        function C2M_Sync() {   #: N   #: Not Required
        n=0
        # little <SYNC> red splash 
        # -----------------------------------------------------------------------
        /usr/lib/gtkdialog/box_splash -fg yellow -bg red -close never -text "." &
            # RETVAL=$?
            GTKPIDSYNC=$!
            sleep .1 	
        # little <SYNC> blue splash 
        # -----------------------------------------------------------------------
        /usr/lib/gtkdialog/box_splash -fg yellow -bg blue -close never -text "\
                       < SYNC >            "
        # ----------------------------------------------------------------------
            # RETVAL=$?
            GTKPIDSYNC0=$!
                echo ">>> SYNC  begin ..."
                sync   	
                echo "<<< SYNC  done ..."
            sleep .7 
            kill ${GTKPIDSYNC}
            sleep .3 
            kill ${GTKPIDSYNC0}
            sleep .3 
        }
        # end: fx(S2F_Sync)


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(C2M_SnapMergePuppy-1)   #: A
#(: called by: IF/FI SnapMergePuppy-1
#(: param: 
#(: purpose: 
#(: calls: 	nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
#(: method: code calling handled internal,  
#(: sends: 
#(: rationale: 
#(: note : 
#(: 
#:######################################################################
function C2M_SnapMergePuppy_1() {   #: A
    n=0
    #
    ### purpose: one-shot "SMP" 
    # nice -19 puts SMP at top of priority stack
    llRun01=1
    lcRunTime01="19"
# ----------------------------------------------------------------------
lcRunNum="${lcRunTime01}"
# left margin position dependent
/usr/lib/gtkdialog/box_splash -fg yellow -bg brown -close never -text "\
.
.           ...Save-2-Flash...Standard...
.             nice -n ${lcRunNum} snapmergepuppy
.                                                                        "&
# -------------------------------------- col 74 line length for sizing splash
    RETVAL=$?
    GTKPIDSMP=$!
    echo ">>> SnapMergePuppy >>>"
    nice -n ${lcRunNum} snapmergepuppy /initrd/pup_ro1 /initrd/pup_rw
    echo "<<< SnapMergePuppy <<<"
    sleep .3
    #
    kill ${GTKPIDSMP}
    #
}
# end: fx(C2M_SnapMergePuppy_1)



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(C2M_ReStart)   #: A
#(: called by: ft(EXIT:guiDumpHLP) ft(EXIT:guiQ-ReStart) 
#(:   if [ "$EXIT" = "ARB_00" ] 
#(:   ft( EXIT:RB_JJ || EXIT:RB_BB || EXIT:RB_FF || EXIT:RB_S7 )
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
        # C2M_SnapMergePuppy_1  # ACTIVE
        # echo "Remove lingering PID splash ..."
        # busybox ps | grep 'C2M_' | grep -v grep | awk '{print $1}' | \
        # while read pid ; do kill $pid ; done

#:######################################################################
function C2M_ReStart() {   #: A

    lcMsgStr="--------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcMsgStr="> > > Restarting $0 < < <" && Sbr_Str2DevTrm "$lcMsgStr" "5" "4"
    lcMsgStr="--------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    # sleep 1

    #--------------------------------------------------
       . ${gcZeroRun} 
    #--------------------------------------------------

    # if calls are stacked ,
    # then prg will ${gcZeroRun} "$0" and also repeat section 
    # and run code below .

    echo ""
    lcMsgStr="----- Error Trap -----------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcMsgStr="> > > Exit < < < < < < < < < Calls were Stacked ... " && Sbr_Str2DevTrm "$lcMsgStr" "5" "4"
    lcMsgStr="> > > non-fatal error  < < < Calls were Stacked ... " && Sbr_Str2DevTrm "$lcMsgStr" "5" "4"
    lcMsgStr="----------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    echo ""

    sleep 1

    exit 0  
    # gae, 200607-1000    
    # prevent repeated fall-thru 
    # and popping stack and "Restart"

}
# end: fx(C2M_ReStart)



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(C2M_ReBoot)   #: A
#(: called by: Exit:ARB_00, et al 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#:######################################################################
function C2M_ReBoot() {    #: A
    #
    lcMsgStr="--------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcMsgStr="> > > ReBooting $0 < < <" && Sbr_Str2DevTrm "$lcMsgStr" "5" "4"
    lcMsgStr="--------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
	sleep 3

        C2M_SnapMergePuppy_1  # ACTIVE

        lcFnRun="/usr/bin/wmreboot" # WRM first calls config
        [ -f "${lcFnRun}" ]  &&  ${lcFnRun}  &&

        # /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMreboot
        # . /root/my-applications/WRMreboot
        # . /usr/bin/wmreboot
        # . WRMreboot
 
    exit 0  
	#
}
# end: fx(C2M_ReBoot)



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(C2M_PowerOff)   #: A
#(: called by: Exit:ARB_00, et al 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#:######################################################################
function C2M_PowerOff() {    #: A
    #
    lcMsgStr="--------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcMsgStr="> > > Power Off  $0 < < <" && Sbr_Str2DevTrm "$lcMsgStr" "5" "4"
    lcMsgStr="--------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
	sleep 3

       C2M_SnapMergePuppy_1  # ACTIVE

       lcFnRun="/usr/bin/wmpoweroff" # WRM first calls config
       [ -f "${lcFnRun}" ]  &&  ${lcFnRun}  &&

        # /initrd/mnt/dev_save/MY_/usr-share/My_Dev_/Edit_WRM/rc.z_WRMpoweroff
        # . /root/my-applications/WRMpoweroff
        # . /usr/bin/wmpoweroff
        # . WRMpoweroff
    exit 0  
	#
}
# end: fx(C2M_PowerOff)




 



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(Sys_PupState)   #: A
#(: called by: 
#(: param: 
#(: purpose: export -f subroutinename
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
    #
    # called by Main ( )
    # param
    # purpose:
    #     consolidation of PUPSTATE
    #     control generation of local var
    #     control configfile 
    # rationale:
    # 	Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    # sends:
    # note:
	# 	dox for export 
	#		export      varname 
	# 	export -f	file or funxtion
	# 	export -d 	directory 
	#		
	# ##########################################################################

    # The partition that has the upupff+dsave file is mounted here...
    # depends on boot method 
    # PUP_HOME='/mnt/dev_save' if one/only boot is directly into partition.
    #     and also here ? 
    # PUP_BASE='/initrd/mnt/dev_save' if boot is via several USB in sequence.

#:######################################################################
function Sys_PupState() {    #: A
	# ---------------------------------------
    #  >>> maintain gcSysDevDob
    lcVerDtsTmp="${gcSysDevDob}"
	#
	# --- load PUPSTATE --- from system location : "/etc/rc.d/"

		if [ $PUPMODE -eq 2 ] ; then
			#
			lcMsgStr="
		EXIT:  PUPMODE is 2 
		C2M requires 'Frugal Install' 
		PUPMODE must be '13'           "
			#
			xmessage -timeout 3 -name 'C2M' -center -bg brown -fg yellow "${lcMsgStr}"
			exit
			#	
		else
			lcMsgStr="PUPMODE=${PUPMODE}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
		fi
	#
    #  <<< restore gcSysDevDob
    export gcSysDevDob="${lcVerDtsTmp}"
	# ---------------------------------------
	#
    # fx(Sys_PupState)
	# ===================================== 	gae === PUPSTATE is "LOADED" now !

	export gcSysDistroLoc="${PDEV1}"
    ### from PUPSTATE, is ready now. 

	export gcZeroRun="$0"
    ### $0 "$ZERO"  ### will restart this program ###
    ### but sometimes , with calls and returns, 
    ### this environmental variable is lost. 
    ### So "gcZeroRun" is used to preserve this value !    
    ###

	echo "BK ==============================================="  
	lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameMount = ${lcSaveFileNameMount}"
	lcSaveFileNameBaseSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameBaseSrc = ${lcSaveFileNameBaseSrc}"
	echo "BK ==============================================="  
	#

    ### Here, export + declare + assign  
	### Here, current values are hard-code, so, need to be cut/pulled from PUPSTATE

    ### System Distro ID String hard code needs  upgrade.  Same for CTB for taropt .
    export gcSysDistroVer="${PUPSFS}"	
    # BionicPup32-19.03+?? always on SDA1
    # export gcSysDistroLoc="= SDA1 = "		
    ### System Kernel ID String extracted via "`uname -r`"
    export gcSysKernVer=${gcSysKernVer}
	# BB kernal "4.9.163"	
	export gcSysVer="${PUPSFS}"	### ${gcSysDistroVer}
	# "Linux puppypc3073 4.9.163-lxpup-32-pae #1 SMP Thu Mar 14 15:41:19 GMT 2019 i686 i686 i686 GNU/Linux"

# work on use of 'cut' to extract values from PUPSTATE
# gcPupSfsFile="`echo $lcVAR | cut -f 2 -d "/"`" 

# PUPSTATE has these:
# gcSysDistroVer="${PUPSFS}"
# gcSysKernVer='5.4.81'    32-bit pae' example   "`uname -r`"
# gcC2MKernVer="`uname -r`"	### KERNVER="`uname -r`"

# fx(Sys_PupState)

	# pulled from PUPSTATE pulled from rc.zSLP.sh
	export gcPupSfsFile="`echo "$PUPSFS" | cut -f 3 -d ','`"
    export gcC2MDistroVer="${PUPSFS}"
    export gcC2MKernVer="`uname -r`"	 

	# Need to pull values from PUPSTATE
		# gcSysDistroVer 
		# gcSysKernVer
	# PUPSFS='sda1,ext4,/pup_UpupFF-sda/puppy_upupff+d_20.12.sfs'
	# PUPSAVE='sda1,ext4,/pup_UpupFF-sda/upupff+dsave-D08-sda-D'
		# gcSysDistroVer="${PUPSFS}"
		# gcSysKernVer="`uname -r`"	 

	# export gcSysNameBase="C2M"	### used ${gcSysNameBase}in code in 'gcSys' label

	# export gcSysHomeSubDir="/initrd/mnt/dev_save/MY_/usr-share"
	# export gcSysHomeSubDir=${PUP_BASE}	### not used 

	export -f Sys_SetVerDts
	export -f Sbr_Str2DevTrm
    export -f C2M_ReStart

    # working gae NameBase 
    export gcSysNameBase="C2M"  
    # used in ${gcSysNameBase} code as systemlabel, in GUI 
	export gcC2Mname="Change2Menu"
	# export gcOsSubId="" # RB_Alternate_Menu # NOT , will cover current new value

    # export GTK2_RC_Files="/root/.gtkrc-2.0"

    # direct import, into similar varname.
    # export lcPupSave=${PUPSAVE}
    # PUPSAVE='sda1,ext3,/pup_UpupBB+21/upupbbsave-BB+21_1202'

    export lcPupMode=${PUPMODE}
    export lcPupHome=${PUP_HOME}
    export lcPupSave=${PUPSAVE}
    export lcPupMode=${PUPMODE}

    # gcPupSubDir in main gui title. 
	export gcSysSave="`echo -n "$PUPSAVE" | cut -f 3 -d ','`"
    # long format subdir
    export gcPupSubDir=${PSUBDIR}  
    # PSUBDIR='/pup_UpupBB+19' short format "PUPSTATE" file .
    export gcPupSubDirDts="${gcPupSubDir}.BKP-`date +%y%m%d-%H%M-%S`"

# gcPupSuDir can be parsed to control Main Gui dimensions

# fx(Sys_PupState)

#  maintain similarity to PUPSTATE "name"
    lcPupSaveNameRaw="PUPSAVE : ${lcPupSave}"  # B2T 'raw' savefilename from PUPSTATE file
    lcMsgStr="Raw = ${lcPupSaveNameRaw}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`"
	### f third field, comma delimited, "/" to end
    lcMsgStr="Name = ${lcPupSaveName}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

    lcPupSaveNameDts="NameDts = ${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`"

    lcPupSaveNameTrg="${lcPupSaveNameDts}.tar.gz"
    lcMsgStr="NameTrg = ${lcPupSaveNameTrg}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

    lcPupSaveNameSrc="${lcPupSaveName##*/}"
    lcMsgStr="NameSrc = ${lcPupSaveNameSrc}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

    #  PUPSAVE='sda1,ext3,/pup_UpupBB+21/upupbbsave-BB+21_1202'
    #    /initrd/mnt/dev_save/pup_UpupBB+21/upupbbsave-BB+21_1202

	# first value #2 position to delimiter "/"
    lcPupSaveData="`echo $lcPupSave | cut -f 2 -d "/"`"
	#  
	# second value
    lcPupSaveData="/initrd${lcPupHome}/${lcPupSaveData}/${lcPupSaveName}"
    lcMsgStr=">>>SaveData = ${lcPupSaveData}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    echo "--- only valid if 'saveDATA name' is manually inserted hard-code ---"

    # lcMsgStr="${}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcPupDistroVer="${PUPSFS}"	
    # "${lcPupDistroVer}"  ### 'BionicPup32-19.03+?? +++'-sig

########################################################################


# fx(Sys_PupState)
# insert custom var into PupState ( ) :

    #  Original Free Ram Calculation :
    # parm2=$2
    # parm2="/initrd/mnt/dev_save/pup_UpupBB+21/upupbbsave-BB+21_1202"
    # parm2="${lcPupSaveName}"

	echo
    # saveDATA size calc ###
    echo "--- saveDATA size calc"
    # saveDATA size calc ###
	aa="$(du -c -m -s ${lcPupSaveData} )"     
    # -c = --total, -m = --block-size=1m, -s = --summarize
	read -r b ccc <<< "$aa"
    lcMsgStr="saveData: ${ccc}" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcPupRamObj="${b}"
    lcPupRamObjMsg="# DATA size > ${lcPupRamObj} MB "

    lcMsgStr="$lcPupRamObjMsg" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"	
    # SaveDATA size 
    # export lcPupRamObjSize="${lcMsgStr}"
	
	FREERAM=`free | grep -o 'Mem: .*' | tr -s ' ' | cut -f 4 -d ' '` 
    # see rc.sysinit for calc
	export gcFreeRamNow="${FREERAM}" 
	export gcFreeRamData="# Ram: ${gcFreeRamNow} Bytes " 
	export gcPupSave="${PUPSAVE}" 
	# PUPSAVE='sda1,ext4,/pup_Slacko7-sda/slackosave-7-ram-84M'

# #######################################################################

    lcPupDts="`date +%y%m%d-%H%M-%S`"

    #  gcC2Mname="Change2Menu"
    lcC2Mverdts="${gcSysDevDob}"
    lcSleep="sleep 1"

	# temp flg files 
	export C2M_CBXstatus="/tmp/C2M_CBX_Status"
	export C2M_E2Rstatus="/tmp/C2M_E2R_Status"
	export C2M_LockFile="/tmp/C2M_LockFile"   
	export C2M_CBXstatus="/tmp/C2M_CBX_Status"

	export gcFreeRamNow="${FREERAM}"
	export gcFreeRamData="# Ram: ${gcFreeRamNow} Bytes "
	export gcPupSave="${PUPSAVE}"

}
# end: fx(Sys_PupState)






### 'export' Marks each NAME for automatic export
### to the environment of subsequently executed commands.
### If VALUE is supplied, assign VALUE before exporting.
### see Main ( ) for example.
###





# ## all function ( ) moved to top of code ### all function ( ) moved to top of code
# ## all function ( ) moved to top of code ### all function ( ) moved to top of code
# ## all function ( ) moved to top of code ### all function ( ) moved to top of code
################################################################################























################################################################################
### all GUI Selection blocks moved to bottom of code, "Fall-Thru" method
### all GUI Selection blocks moved to bottom of code, "Fall-Thru" method
### all GUI Selection blocks moved to bottom of code, "Fall-Thru" method
### fx(name) is "funxtion"  real. 
### ft(name) is "fall-thru" (if/fi)
###

#**********************************************************************#
#
#######   start  MAIN RUN ( )   ##############################################
#######   start  main run ( )   ##############################################
#######   start  MAIN ( )   ##############################################
#


#**********************************************************************#
#**********************************************************************
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(C2M_Main)    # ACTIVE
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#**********************************************************************
#: ###^^^ MAIN Header ^^^###
echo
lcMsgStr=">>> Start C.2.M. Header " && Sbr_Str2DevTrm "$lcMsgStr" "5" "3"
lcMsgStr=">>> Start C.2.M. Header " && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
lcMsgStr=">>> Start C.2.M. Header " && Sbr_Str2DevTrm "$lcMsgStr" "3" "3"

	#
    lcMsgStr=" " && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

    Sys_SetVerDts

    lcMsgStr="Ver Dts :${gcSysDts}:" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcMsgStr="Now-Dts :${gcSysDtsNow}:" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    lcMsgStr=" " && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

	#(: top of main () ====================================================
echo
echo
echo

	#
    ### proc for Puppy reads & writes the "state" variables into "PUPSTATE"
    lcMsgStr=">>> Sys_PupState >>>" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

    Sys_PupState   ### Gather the "state" variables from OS

    lcMsgStr="<<< Sys_PupState <<<" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    ### Build other C2M system constants.
	#
    lcMsgStr=" " && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

########################################################################
########################################################################
########################################################################

### via Sys_PupState
### gcC2Mname="Change2Menu"
### lcC2Mverdts="${gcSysDevDob}"
### lcC2Msleep="sleep 3"

### via Sys_PupState
### export lcC2Mdistro gcC2Mname lcC2Mdts lcC2MSleep
### export funxtion () to environment, prior to possible call via Main_Gui screen.
### export -f C2M_help_box     ### this is Main ()


echo "............................................................."


# ## begin === MAIN GUI() ##############################################


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ### MAIN() ###
#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx()
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:

# ## NOTES:

# 
# #######################################################################
#: ## Each Main_GUI Selection will 'Fall-Thru' to  "if ... fi" routine.
# #######################################################################
# 

# ## MAIN ############################################################
# ## MAIN ############################################################
# ## MAIN ############################################################

# ## note: Possible Icons for Main_GUI ???
# ~ export gui_yes="gtk-yes"
# ~ export gui_no="gtk-no"
# ~ export gui_icon_no="gtk-no"
# ~ export gui_file_icon_no="gtk-no"
# ~ export gui_label_all="ALL+"
# ~ export gui_label_all="ALL*"
# ~ default_width="500"
# ------------------------------------------------------------------------------

touch "/0-C2M-Run-DTS-0"       #: Zero-Byte DTS Main Gui Marker file .

#------------------------------------------------------------------------------
	# these controls are related to the Main GUI 
#------------------------------------------------------------------------------

#(: control the "CBX" "DONE" status of the CheckBox Applied activity.
if [ -f "${C2M_CBXstatus}" ]; then
    rm -f "${C2M_CBXstatus}"
    export lcCBXstatus="   ...Applied..."
else
    export lcCBXstatus="   ,,,,,,C2M,,,,,,   "
fi
lcMsgStr="CheckBoxStatus=:${lcC2Mstatus}:" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"

#------------------------------------------------------------------------------
#(: control the "E2R" "DONE" status of the Back2Root Applied activity.
if [ -f "${C2M_E2Rstatus}" ]; then
    rm -f "${C2M_E2Rstatus}"
    export lcE2Rstatus="   ...Applied..."
else
    export lcE2Rstatus="   ,,,,,,E2R,,,,,,   "
fi
lcMsgStr="lcE2Rstatus=:${lcE2Rstatus}:" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
#------------------------------------------------------------------------------



##########################################################################
#=========================================================================
# working gae ARB   var='cat 	and   gui color   
#
# All this could be done in main Gui HEADER, since it is gui related.
#
# gcC2MConfigArbFn="/root/my-applications/bin/C2M_Config_Arb"   # ASSIGNED fx(Sys_PupState)
#
# code activated via user selection of in ft(EXIT : RB_???) 
#  List ALL :    'EXIT:ARB_00', 'EXIT:ARB_JJ', 'EXIT:ARB_BB', 'EXIT:ARB_FF', 'EXIT:ARB_S7', 
#
#------------------------------------------------------------------------------


#--- mainrun ---------------------------------------------------------------------------
Sbr_ARB_init   #: purpose: read config-file for "Id" 
#--- mainrun ---------------------------------------------------------------------------


# code activated via EXIT/Action section must write name of "Alternate RB" menu into AltRb_Status file. 
#     'EXIT:RB_00', 'EXIT:RB_JJ', 'EXIT:RB_BB', 'EXIT:RB_FF', 'EXIT:RB_S7' could be inserted. 

#------------------------------------------------------------------------------
# begin: 
# working gae ARB   gui color
		#
        # translate config "Id" 
        #   into color-label "lcOsSubSplClr", 
        #      then into "lcGuiColorRB" 
        #
		# Trap Empty OS colors in gui
		# default initial colors , before User Select OS , 
        #
		#: Test config for previous Idd 
		echo ">${lcOsSubSplClr}<=======" 
		if [ ! ${lcOsSubSplClr} ] ; then 
			#: test the 	OS Idd extracted/cat from config for previous color in gui 
			case "${gcC2MConfigArbId}" in
			   "ORG") lcOsSubSplClr="black" ;; 
			   "00)") lcOsSubSplClr="black" ;; 
			   "JJ") lcOsSubSplClr="purple" ;; 
			   "BB") lcOsSubSplClr="red"    ;; 
			   "FF") lcOsSubSplClr="green"  ;; 
			   "S7") lcOsSubSplClr="blue"   ;; 
				*)  lcOsSubSplClr="black" ;;
			esac
		fi
		echo ":${lcOsSubSplClr}:=======" 
        # ! this before gui !
        #
# end:  
# falls thru to main gui 

##########################################################################

export lcGuiColorRB="${lcOsSubSplClr}"    
# standard gui colors used in this gui
export lcGuiColorbrn="brown"
export lcGuiColorgrn="green"
export lcGuiColorblu="blue"
export lcGuiColorred="red"


###########################################################
### from TechMint to consolidate screen real-estate

### gtkdialog 
#~ width-request="1400"
#~ height-request="860"
#~ resizable="true"
#~ space-expand="true" 
#~ border-width="10" 
#~ <hbox space-fill="true" space-expand="true"> 
#~ <notebook tab-label="One | Two| Three| Four| Five|"> </notebook> 


### terminal commands to make a BASH script file 'run'. 
# $ chmod +x $myProgramFile
# $ ./myProgramFile
###		?  gtk-apply gtk-color-select  gtk-about


#------------------------------------------------------------------------------
#
#(: title line outside top of frame
export lcGuiFrameTitle="'Change-2-Menu......' "  

#(: title line inside of form. 
export lcGuiTitle=": C2M_${gcSysDistroLoc} : ${gcSysDevDob} :"

#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fg(C2M_Master_GUI=)
#(: called by: main program via fall-thru
#(: param: only the Fall-Thru <ACTION> sub-name .
#(: purpose: Master gtkdialog XML Menu structure. 
#(: calls: 
#(:    every thing via gui buttons to [ gui fall-thru "IF/ ft(name) /FI" ] 
#(:
#(: method: 
#(:   (1) gui <action> "EXIT:ft(name)" 
#(:   (2) 'gui fall-thru to "IF/ ft(name) /FI" (at bottom of source code)
#(:   (3) call with param to "subroutines"     (at top of source code) . 
#(:
#(: sends: "EXIT" = choice 
#(: rationale: 
#(: note : 
#(: 	this width=1200 works good on UpupBB. Other Distro may require adjustment. 
#(: note:
#(: Standard Gui Button Call Method is TWO-STEP: 
#(:  (1) gui-Buttons "call" to a "Fall-Thru funxtion written as ft("IF/FI") (in lower part of source). 
#(:  (2) "IF/FI" funxtions then call regular subroutine funxtion() (at top of code). 
#(: EXAMPLE:  button "MntAll" is <action>'EXIT:MNT+'</action>
#(: which will exit and fall-thru to "ft( 'EXIT:MNT+' )" 
#(: which will then call "funxtion Sys_C2M_pMount()" (written in top part of source).	
#(: This is the Standard Method written into this Main Gui, 
#(:   which allows parameters to be sent to complex sub-routines . 
#(:   which avoids lack of parameter passing in the gui Button gtkdialog process. 
#(:


# Window forms quickly if dimensions are "literal" and "in-line". 
# export lnGuiMainXReq="840"
# export lnGuiMainYReq="1175"
# BUT, different OS will require adjust. So, set space-expand="true". 

# window dimensions: set up for JammyJellyfish OS, with default font.  
# height-request="870" is OK. 
# width-request="???" has problems with "FF" and "S7".  So, DO NOT SPECIFY wideth, let space-expand="true" handle this.
#

# Warning:  Warning:  Warning:  Warning:  Warning:  Warning:  Warning:  Warning:  Warning: 
	#~ <button has-focus="false" height-request="1" tooltip-text="Button Spacer C0" > 
	#~ <label> "too wide can force screen expansion" </label>	<action>lnDummy:C0</action> </button>

# current gtk format is the standard SINGLE STRING method.  

### Top of main-GUI ####################################################
### Top of main-gui ####################################################
### Top of mainGUI  ####################################################
### Top of maingui  ####################################################

#: ### MAINGUI #########################################################


#(:
export C2M_Master_GUI='
<window  title="'${lcGuiFrameTitle}'" height-request="580" width-request="515"space-expand="true" border-width="2"  resizable="true" >  
<vbox>


    <frame>
       <button has-focus="false" height-request="12" space-expand="false" > <label> "" </label> 
            <action>lnDummy:FrameTop</action>
       </button>

    <hbox>
        <text editable="false" use-markup="true" xalign="-0"  space-expand="true" >
            <label>	"<span color='"'$lcGuiColorbrn'"'> <b> '${lcGuiTitle}' </b> </span> <span color='"'$lcGuiColorblu'"'> </span> " </label>
        </text>
    </hbox>

     <button has-focus="false" height-request="23" space-expand="true" > 
            <label> '"${gcPupSave}"' </label> 
            <action>lnDummy:FrameBot</action>
     </button>
   </frame>

    <hbox>
		<button has-focus="false" width-request="35" tooltip-text="Margin-LL" >
			<label> "" </label> <input file icon="gtk-select-color" ></input> <action>lcDummy:vCMargin-Left</action>
		</button>
        <button label="" has-focus="false" width-request="3"> <action>lnDummy:vCL</action> </button>
    <vbox>
		<vseparator height-request="3"></vseparator>
		<button tooltip-text="'EXIT:guiQ-ReBoot'  <Simple Quick Warm-REBOOT>" has-focus="false"> 
			<label> 'Exe:Quick-ReBoot' </label>
			<action>'EXIT:guiQ-ReBoot'</action>
		</button>
		<vseparator height-request="15"></vseparator>
        <text editable="false" use-markup="true" xalign="0"  space-expand="true" >
            <label>	
				"    <span color='"'${lcGuiColorRB}'"'><b>'===-Set-Next-Menu-===-${gcC2MConfigArbId}-==='</b></span>    "
            </label>
        </text>

		<hbox>
			<hseparator width-request="5"></hseparator>
			<button has-focus="false" height-request="30"  xalign="0" 
				tooltip-text="Select Alternate RB menu for Next OS , then Reboot" >
				<label> "'---ReBoot-to-Next-Menu-------'" </label>
				<input file icon="gtk-select-color" ></input>
				<action>lnDummy:0</action>
			</button>
			<hseparator width-request="55"></hseparator>
		</hbox>

		<hbox>
			<hseparator width-request="5"></hseparator>
			<button label="'0rig'"    tooltip-text="'Copy_orig_from_menu.lst00'" has-focus="false"> 
				<action>'EXIT:ARB_ORG'</action>  </button>
			<button label="'0-0'"    tooltip-text="'Alternate_EXIT:ARB_00_ALL'" has-focus="false"> 
				<action>'EXIT:ARB_00'</action>  </button>
			<button label="'J-J'"    tooltip-text="'Alternate_EXIT:ARB_J-J'" has-focus="false"> 
				<action>'EXIT:ARB_JJ'</action>  </button>
			<button label="'B-B'"    tooltip-text="'Alternate_EXIT:ARB_B-B'" has-focus="false"> 
				<action>'EXIT:ARB_BB'</action>  </button>
			<button label="'F-F'"    tooltip-text="'Alternate_EXIT:ARB_F-F'" has-focus="false"> 
				<action>'EXIT:ARB_FF'</action>  </button>
			<button label="'S-7'"    tooltip-text="'Alternate_EXIT:ARB_S-7'" has-focus="false"> 
				<action>'EXIT:ARB_S7'</action>  </button>
			<hseparator width-request="65"></hseparator>
		</hbox>

 		<vseparator height-request="15"></vseparator>

		<button tooltip-text="'EXIT:guiS-ReBoot' <Save then Warm-ReBoot>" has-focus="false"> 
			<label> 'Exe:Save-Re-Boot' </label>
			<action>'EXIT:guiS-ReBoot'</action>
		</button>

		<vseparator height-request="25"></vseparator>

        <button tooltip-text="'Before-Quit'" has-focus="false"> <input file icon="gtk-no" ></input> <action>lnDummy:0</action> </button>
        <button tooltip-text="'EXIT:guiMain-QUIT'  < Master Simple Quit C2M > " has-focus="false" height-request="66">
            <label>  "'QUIT-C2M-program'" </label>
            <action>'EXIT:guiMain-QUIT'</action>
        </button>
        <button tooltip-text="'After-Quit'" has-focus="false"> <input file icon="gtk-no" ></input> <action>lnDummy:0</action> </button>

		<vseparator height-request="12"></vseparator>

		<button label="  'Help'    " tooltip-text="'EXIT:guiDumpHLP'  <HELP dump>" height-request="27" has-focus="false"> 
			<action>'EXIT:guiDumpHLP'</action> </button>

 		<vseparator height-request="12"></vseparator>

  </vbox>

        <button label="" has-focus="false" width-request="3"> <action>lnDummy:vCR</action> </button>
		<button has-focus="false" width-request="35" tooltip-text="Margin-RR" >
			<label> "" </label> <input file icon="gtk-select-color" ></input> <action>lcDummy:vCMargin-Right</action>
		</button>
   </hbox>
   <hbox>
        <button label="." tool-tip="bottom right dot" has-focus="false" width-request="10"height-request="10" > <action>lnDummy:bottom-right-dot</action> </button>
   </hbox>

</vbox>
</window>'
#(: ===> remember the (') on last line of GUI !

#(: use <action>lnDummy:NameThisObj</action>, so to locate via terminal.  


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: fx(C2M_Main_Gui=eval)   #: A
#(: called by: SYS
#(: param: C2M Gui  has been exported
#(: purpose: evaluate the "C2M Main GUI" 
#(: calls: 
#(: method: 
#(:    'eval'  Execute arguments as a shell command, "Fall-Thru" method.
#(: sends: 
#(: rationale: 
#(: note : 
#(:
 
eval "`gtkdialog --center -p C2M_Master_GUI`"

#(:

#: #######################################################################
#: ## Each Main_GUI Selection will 'Fall-Thru' to  "if ... fi" routines.
#: #######################################################################

 
 

### End of MAIN_GUI ####################################################
### End of MAIN_GUI ####################################################
### End of MAIN_GUI ####################################################
### End of MAIN_GUI ####################################################
### End of MAIN_GUI ####################################################











#:    Trace visible in Terminal #########################################
lcMsgStr="------------------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "1" "1"
lcMsgStr="------  Main Gui   --- ${EXIT} ----------------Fall-Thru----" && Sbr_Str2DevTrm "$lcMsgStr" "3" "1"
lcMsgStr="---------  Fall-Thru  --- ${EXIT} -------------Fall-Thru----" && Sbr_Str2DevTrm "$lcMsgStr" "3" "1"
lcMsgStr="------------  Fall-Thru  --- ${EXIT} ----------Fall-Thru----" && Sbr_Str2DevTrm "$lcMsgStr" "3" "1"
lcMsgStr="---------------  Fall-Thru  --- ${EXIT} -------Fall-Thru----" && Sbr_Str2DevTrm "$lcMsgStr" "3" "1"
lcMsgStr="------------------------------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "1" "1"
#:   Trace visible in Terminal 




#: =======================================================================
#: begin: ft() Fall-Thru  --- "IF/FI" Calling Routines
#: =======================================================================





#: :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#: 'Q'uick :  ReStart, Reboot, PowerOff
#: :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiQ-ReStart)   # ACTIVE
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#
#:======================================================================
if [ "$EXIT" = "guiQ-ReStart" ] ; then
	# can be called by Main GUI in 'terminal' mode,
	# then will stack up calls, which terminal must release.
    lnDummy=0
	#
# -----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg orange -bg green -close never -text "\
.
.          Quick   ReStart C2M  
.
.                                                      "&
# ------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMAIN=$!
	sleep 1
	kill ${GTKPIDMAIN}
    #
    C2M_ReStart
	#
fi #
# end: ft(EXIT:guiQ-ReStart)


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiQ-ReBoot)    # ACTIVE
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#
#:======================================================================
if [ "$EXIT" = "guiQ-ReBoot" ];then
	#
    lnDummy=0
	#
# -----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "\
.
.           Quick  Warm ReBoot 
.                                                                        "&
# ----------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMAIN=$!
    sleep 1
	kill ${GTKPIDMAIN}
	#
    C2M_ReBoot    # ACTIVE
	#
	### program will not run into this point !
    EXIT=""	### but, force "Fall Thru", in case "exit 0" fails. 
	#
	### Do NOT NOT call the RESTART funxtion
    # "RE-BOOT" Should be a very 'final' quit action ###
    # SHOULD NOT NOT RESTART ###
	exit 0
	#
fi #
# end: ft(EXIT:guiQ-ReBoot)



# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#(: 'S2F' :SAVE:  ReStart, Reboot, PowerOff
# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiS-ReStart)     # ACTIVE
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#
#:======================================================================
if [ "$EXIT" = "guiS-ReStart" ] ; then
	### can be called by Main GUI in 'terminal' mode,
	### then will stack up calls, which terminal must release.
	#
    lnDummy=0
	#
#-----------------------------------------------------------------------
/usr/lib/gtkdialog/box_splash -fg orange -bg green -close never -text "\
.
.           Save  &  Re-Start C2M 
.
.                                                      "&
#------------------------------------------------------------------------
    RETVAL=$?
	GTKPIDMAIN=$!
	sleep 1
    #
	kill ${GTKPIDMAIN}
	#
	C2M_SnapMergePuppy_1  # ACTIVE    ft(EXIT:guiS-ReStart)
	#
    C2M_ReStart
	#
fi  #
# end: ft(EXIT:guiS-ReStart)


#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiS-ReBoot)      # ACTIVE
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#
#:======================================================================
if [ "$EXIT" = "guiS-ReBoot" ];then
	#
    lnDummy=0
	#
#
/usr/lib/gtkdialog/box_splash -fg yellow -bg green -close never -text "\
.
.         Save  &  Warm ReBoot 
.                                                                        "&
# col 74 line length for sizing splash
    RETVAL=$?
	GTKPIDMAIN=$!
    sleep 1
	kill ${GTKPIDMAIN}
	#
	C2M_SnapMergePuppy_1  # ACTIVE    ft(EXIT:guiS-ReBoot)
	#
    C2M_ReBoot  # ACTIVE
	#
    EXIT=""	### force "Fall Thru" if "exit 0" fails. 
    #
	# "exit 0' should terminate this program. 
	exit 0
	#
fi  # 
# end: ft(EXIT:guiS-ReBoot)



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT:guiMain-QUIT)   #: A  
#(: called by: Main GUI Fall-Thru , Big Button near Bottom of Screen 
#(: param: 
#(: purpose: Main Quit with trailer message. 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:
#
#:======================================================================
if [ "$EXIT" = "guiMain-QUIT" ] ; then
	#
	lnDummy=0
	#
    lcMsgStr="=== Main-QUIT ===" && Sbr_Str2DevTrm "${lcMsgStr}" "2" "7"
    #
    echo "---> After-Main-GUI Exit  "
    echo "[ "$EXIT" = "QUIT+" ]"
    echo "-------------------------------------"
    # Trace , cleanup,  exit
    # No Testing is required here.
	#
    echo
    echo
    lcMsgStr=" " && Sbr_Str2DevTrm "${lcMsgStr}" "2" "7"
    lcMsgStr="... C2M : ReadMe ! ... " && Sbr_Str2DevTrm "${lcMsgStr}" "2" "7"
    echo
    lcMsgStr=">>>  Hit 'Enter' to clear Terminal <<< "
    Sbr_Str2DevTrm "$lcMsgStr" "3" "7"
    Sbr_Str2DevTrm "$lcMsgStr" "2" "7"
    Sbr_Str2DevTrm "$lcMsgStr" "6" "7"
    echo
    lcMsgStr="       <<< Quit >>>" && Sbr_Str2DevTrm "$lcMsgStr" "1" "3"
    sleep .3
	# "exit 0' should terminate this program. 
    exit 0

    # "QUIT" Should be a very 'final' quit action ###
    # "QUIT" SHOULD NOT NOT RESTART ###

fi  #
# end: ft(EXIT:guiMain-QUIT)



#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft( EXIT:ARB_ORG || EXIT:ARB_00 || EXIT:ARB_JJ || EXIT:ARB_BB || EXIT:ARB_FF || EXIT:ARB_S7 )
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: (1) Install only a Two-Character "Id" into config-file
#(:         (2) Test Config, then build matching menu.lst
#(: sends: 
#(: rationale: 
#(: note : 
#(:
 
#   EXIT:ARB_ORG  #  EXIT:ARB_00  #  EXIT:ARB_JJ   # EXIT:ARB_BB   # EXIT:ARB_FF   # EXIT:ARB_S7








# working gae C2M execution

# BEGIN: Given, Parse, Write 
##############################

####################################################################
####################################################################
####################################################################

# begin: ft( EXIT:ARB_ORG || EXIT:ARB_00 || EXIT:ARB_JJ || EXIT:ARB_BB || EXIT:ARB_FF || EXIT:ARB_S7 )
# begin: ft( [ "$EXIT:ARB_ORG" ] || [ "$EXIT:ARB_00" ] || [ "$EXIT:ARB_JJ" ] || [ "$EXIT:ARB_BB" ]  || [ "$EXIT:ARB_FF" ] || [ "$EXIT:ARB_S7" ] )

# working gae ARB

####################################################################
######## GIVEN: EXIT:ARB_??? #######################################
####################################################################
# 
# begin: ft( [ "$EXIT" = "ARB_00" ] || [ "$EXIT" = "ARB_JJ" ] || [ "$EXIT" = "ARB_BB" ]  || [ "$EXIT" = "ARB_FF" ] || [ "$EXIT" = "ARB_S7" ] 

# working gae EXIT:ARB_   ARB_00   ARB_

if [ "$EXIT" = "ARB_00" ] || [ "$EXIT" = "ARB_JJ" ] || [ "$EXIT" = "ARB_BB" ]  || [ "$EXIT" = "ARB_FF" ] || [ "$EXIT" = "ARB_S7" ]  ; then 

   # PARSE: 

	#:##################################################################################################
	# ft( EXIT:ARB_00 || ft( EXIT:ARB_JJ || EXIT:ARB_BB || EXIT:ARB_FF || EXIT:ARB_S7 )

	lcOsSubClrBase="/boot/grub"	# 'base' allows easy change of location for colors 
	# echo the bare-bones Grub4Dos code 

	# General Menu Timeout in seconds (-3 will show). 
    	lcOsSubTout=""
    	lcOsSubDef="0"

    #;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    #: PARSE:
	#  do not parse for "ARB_ORG"

            #:======================================================================
            #~ if [ "$EXIT" = "ARB_ORG" ] ; then    # EXIT:ARB_ORG
                #~ lcOsSubDef="0"
                #~ lcOsSubId="ORG"
                #~ lcOsSubIdd="ORG"
                #~ lcOsSubDir="Main-Generic"
                #~ lcOsSubFn="/mnt/home/menu.lst00"
                #~ lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-yel.xpm"
                #~ lcOsSubSplClr="orange"	 
            #~ fi
    #:======================================================================
	if [ "$EXIT" = "ARB_00" ] ; then    # EXIT:ARB_00
    	lcOsSubDef="1"
		lcOsSubId="00"
		lcOsSubIdd="0-0"
		lcOsSubDir="Main-Generic"
		lcOsSubFn="/mnt/home/menu.lst00"
		lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-yel.xpm"
		lcOsSubSplClr="orange"	 
    	lcOsSubTout="32"
 	fi
    #:======================================================================
	if [ "$EXIT" = "ARB_JJ" ] ; then    # EXIT:ARB_JJ
		lcOsSubDef="1"
		lcOsSubId="JJ"
		lcOsSubIdd="J-J"
		lcOsSubDir="pup_UpupJJ-sda"
		lcOsSubFn="/mnt/home/menu.lstJJ"
		lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-pur.xpm"
		lcOsSubSplClr="purple"
       	lcOsSubTout="12"
	fi
    #:======================================================================
	if [ "$EXIT" = "ARB_BB" ] ; then    # EXIT:ARB_BB
		lcOsSubDef="2"
		lcOsSubId="BB"
		lcOsSubIdd="B-B"
		lcOsSubDir="pup_UpupBB-sda"
		lcOsSubFn="/mnt/home/menu.lstBB"
		lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-red.xpm"
		lcOsSubSplClr="darkred"
       	lcOsSubTout="12"
	fi
    #:======================================================================
	if [ "$EXIT" = "ARB_FF" ] ; then    # EXIT:ARB_FF
		lcOsSubDef="3"
		lcOsSubId="FF"
		lcOsSubIdd="F-F"
		lcOsSubDir="pup_UpupFF-sda"
		lcOsSubFn="/mnt/home/menu.lstFF"
		lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-grn.xpm"
		lcOsSubSplClr="green"
       	lcOsSubTout="12"
	fi
    #:======================================================================
	if [ "$EXIT" = "ARB_S7" ] ; then    # EXIT:ARB_S7
		lcOsSubDef="4"
		lcOsSubId="S7"
		lcOsSubIdd="S-7"
		lcOsSubDir="pup_UpupS7-sda"
		lcOsSubFn="/mnt/home/menu.lstS7"
		lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-blu.xpm"
		lcOsSubSplClr="blue"
       	lcOsSubTout="12"
	fi
    #:======================================================================

	# via Sys_Pup_State:  gcC2MConfigArbFn="/root/my-applications/bin/C2M_Config_Arb"   # fx(menu execution)
	echo "${lcOsSubId}" > "${gcC2MConfigArbFn}"  

#: =======================================================================
#: user selected:  lcOsSubId, lcOsSubI-d, lcOsSubDir, lcOsSubFn,  lcOsSubSplClr
#: =======================================================================
# white letters on SubSplashColor 
/usr/lib/gtkdialog/box_splash -fg white -bg ${lcOsSubSplClr} -close never -text "\
.      Install  Menu.lst:
. (ORG)  (00)  (JJ)  (BB)  (FF)  (S7) 
. ${EXIT} = menu.lst ${lcOsSubIdd}  install
.     pause + ReStart 
						"&
# -----------------------------------------------------------------------

	RETVAL=$?
	GtkPid_Sbr_Box_Splash=$!	
	sleep 1
	kill ${GtkPid_Sbr_Box_Splash} 

    # working gae ARB execution echo menu

	#-----------------------------------------------------------------------
	# Big Menu .lst  ECHO a 'full simple' menu, (not as extensive as original menu.lst00) 
	# , but not the menu.lst/menu.lst00 original which is very extensive. 
	# echo is not left margin position dependent.
    #-----------------------------------------------------------------------
    # Menu Var that is updated via user selection is   "default ${lcOsSubDef}"
    # ONLY Menu Var that is updated is   "default ${lcOsSubDef}" 
    #-----------------------------------------------------------------------

	#~ echo "# allow default forground/background colors"
    #~ echo "# splashimage=${lcOsSubSplXpm}"
    #~ echo "# color light-gray/red red/light-gray"
	#~ echo "# color white/brown red/yellow"
	#~ echo "# color white/brown yellow/red"
	#~ echo "# color white/brown yellow/green"

    #
	(
	echo "#!/bin/bash"
	echo "#======================================================"
	echo "# 'Assigned Menu.lst' by 'C2M'"
	echo "# written by rc.z_MGN.sh & rc.z_C2M.sh"
	echo "# insert user selected OS parameters"
	echo "# compare to MGN ft(EXIT=ARB_00) in MGN fx(Sbr_ARB_00)" 
	echo "# 220821, Glen Ellis" 
	echo "#======================================================"
	# begin: user selected
	# lcOsSubTout, lcOsSubDef, lcOsSubSplXpm
	echo "# OS=${lcOsSubId} : Operating System "
    echo "# DTS=${gcSysDts} : date generated"
 	echo "color white/brown yellow/blue"
	echo "timeout ${lcOsSubTout}"
	echo "default ${lcOsSubDef}"
	# end: user selected
	echo "###################################{ Menu with Wait }"
	echo "title  0{ 'C2M' Short Menu }---SDA1"
	echo "   find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
	echo "   root (hd0,0)"
	echo "###################################{ Jammy Jellyfish }"
	echo "title  1{ J-J }-UpupJJ+D+22.04  Jammy-Jellyfish - ram -SDA1"
	echo "  find --set-root --ignore-floppies --ignore-cd /MARK-SDA1 "
	echo "  kernel /pup_UpupJJ-sda/vmlinuz  psubdir=/pup_UpupJJ-sda pmedia=usbflash pfix=fsck,copy"
	echo "  initrd /pup_UpupJJ-sda/initrd.gz"
	echo "###################################{ UpupBB+29 Bionic-Beaver }"
	echo "title  2{ B-B }-UpupBB-19.03+30     - ram --------SDA1 "
	echo "  find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
	echo "  kernel /pup_UpupBB-sda/vmlinuz    psubdir=/pup_UpupBB-sda pmedia=usbflash pfix=fsck,copy"
	echo "  initrd /pup_UpupBB-sda/initrd.gz"
	echo "###################################{ UpupFF+D08.20.12 Focal-Fossa }"
	echo "title  3{ F-F }-UpupFF+D08-20.12    - ram --------SDA1 "
	echo "  find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
	echo "  kernel /pup_UpupFF-sda/vmlinuz    psubdir=/pup_UpupFF-sda pmedia=usbflash pfix=fsck,copy"
	echo "  initrd /pup_UpupFF-sda/initrd.gz"
	echo "###################################{ Slacko-7 'slacko14.2' }"
	echo "title  4{ S-7 }-Slacko7+14.2        - ram --------SDA1 "
	echo "  find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
	echo "  kernel /pup_Slacko7-sda/vmlinuz    psubdir=/pup_Slacko7-sda  pmedia=usbflash  pfix=fsck,copy"
	echo "  initrd /pup_Slacko7-sda/initrd.gz"

	echo "########################################################"
	echo "title ==={ P-M }  Any Parted-Magic }---"
	echo "	lock"
	echo "	find --set-root --ignore-floppies --ignore-cd  /pmagic/bzImage"
	echo "	kernel  /pmagic/bzImage  noapic  load_ramdisk=1  prompt_ramdisk=0  pmedia=ataflash rw  vga=791  sleep=3  loglevel=0  keymap=us"
	echo "	initrd  /pmagic/initramfs"
	echo "########################################################"
	echo "  "
	echo "title >>> menu-Boot-NamedDrive.lst ==="
	echo "    find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
	echo "	configfile /menu-Boot-NamedDrive.lst"
	echo " "
	echo "title >>> menu-Boot-ChainLoader.lst ==="
	echo "    find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
	echo "	configfile /menu-Boot-ChainLoader.lst"
	echo "########################################################" 
	echo " "
	echo "title   \n \n \n *** Grub4Dos commandline *** \n( for experts only )"
	echo "  commandline"
	echo " "
	echo "title   \n \n \n *** Halt computer *** \n( for experts only )"
	echo "  halt"
	echo " "
	echo "title   \n \n \n *** Re-BOOT command *** \n( standard command )"
	echo "  reboot"
	echo "########################################################"
	) > /mnt/home/menu.lst

	# set permissions  
	# force setting permission to 'exe' 
	chmod +x "/mnt/home/menu.lst"
	# 

   #------------------------------------------------------------------------------------------
			# below: "Small Menu .lst" , does not allow 'escape' for 'change of mind'. 
			# Direct Write of menu.lst
			# not used  
			# (
			# echo "!/bin/bash"
			# echo "timeout 5"
			# echo "title () { ${lcOsSubId} }---{ ${lcOsSubDir} }--- ram --------SDA1"
			# echo "find --set-root --ignore-floppies --ignore-cd /MARK-SDA1"
			# echo "kernel /${lcOsSubDir}/vmlinuz  psubdir=${lcOsSubDir} pmedia=usbflash pfix=fsck,copy"
			# echo "initrd /${lcOsSubDir}/initrd.gz"
			# ) > /mnt/home/menu.lst
   #------------------------------------------------------------------------------------------

            #-------------------------------------------------------------------
            # working gae ARB Alternate RB menu execution
            # # copy alternate menu.lst?? from stash.
            # cp ${lcOsSubFn} /mnt/home/menu.lst
            #-------------------------------------------------------------------
    #
	# end: ft(: EXIT:ARB_00 || EXIT:RB_JJ || EXIT:RB_BB || EXIT:RB_FF || EXIT:RB_S7 )
	#
	# Fall-Thru done
	C2M_ReStart
    #
    # end: ft( [ "$EXIT" = "ARB_00" ] || [ "$EXIT" = "ARB_JJ" ] || [ "$EXIT" = "ARB_BB" ]  || [ "$EXIT" = "ARB_FF" ] || [ "$EXIT" = "ARB_S7" ] 
fi
#
# begin: ft( [ "$EXIT" = "ARB_ORG" ] 
if [ "$EXIT" = "ARB_ORG" ] ; then

	####################################################################
	#### ORIGINAL "ARB_ORG"  ###########################################
	####################################################################
        #
        # Special "copy" an original menu into place. 
		lcOsSubDef="ORG"
		lcOsSubId="ORG"
		lcOsSubIdd="ORG"
		lcOsSubDir="Main"
		lcOsSubFn="/mnt/home/menu-orig.lst"
		lcOsSubSplXpm="${lcOsSubClrBase}/xpm-c-yel.xpm"
		lcOsSubSplClr="orange"	 
		#

# ---------------------------------------------------------------------------
# user selected:  lcOsSubId, lcOsSubI-d, lcOsSubDir, lcOsSubFn,  lcOsSubSplClr
# ${lcOsSubSplClr} some defaulted color -fg blue -bg orange
/usr/lib/gtkdialog/box_splash  -close never -text "\
.       Swap Original Menu.lst:
.              (ORG)  
. ${EXIT} = menu.lst ${lcOsSubIdd}  install
.    pause + ReStart 
. 					"&
# -----------------------------------------------------------------------
		RETVAL=$?
		GtkPid_Sbr_Box_Splash=$!	# capture PID
        #
		# for this "ARB_ORG" 
		# Special Simple Copy of the "original" menu.lst back into place. 
		cp /mnt/home/menu-orig.lst /mnt/home/menu.lst
		#
		# 'ID' has been selected
		export gcC2MConfigArbId="${lcOsSubIdd}"
		#
        # via Sys_Pup_State:  gcC2MConfigArbFn="/root/my-applications/bin/C2M_Config_Arb"   # fx(menu execution)
        echo "${lcOsSubId}" > "${gcC2MConfigArbFn}"  
        #
		sleep 5
		kill ${GtkPid_Sbr_Box_Splash} # after return
		# -----------------------------------------------------------------------
		#
		C2M_ReStart
		#
    # end: 	[ "$EXIT" = "ARB_ORG" ]    # EXIT:ARB_ORG
	####################################################################
	####  "ARB_ORG"  ###################################################
	####################################################################
fi
#
# end: ft( EXIT:ARB_ORG || EXIT:ARB_00 || EXIT:ARB_JJ || EXIT:ARB_BB || EXIT:ARB_FF || EXIT:ARB_S7 )
# end: ft( [ "$EXIT:ARB_ORG" ] || [ "$EXIT:ARB_00" ] || [ "$EXIT:ARB_JJ" ] || [ "$EXIT:ARB_BB" ]  || [ "$EXIT:ARB_FF" ] || [ "$EXIT:ARB_S7" ] )

# working gae ARB   end execution
# #######################################################################


#(: ====================================================================
#(: ft(EXIT:guiDumpHLP)
#(: called by: Main GUI Fall-Thru 
#(: param: 
#(: purpose: dump/display Pup HELP Code
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:   
#(:
#
#:######################################################################
if [ "$EXIT" = "guiDumpHLP" ] ; then
    echo "--- HELP --- Sys_Dump_HLP --- ${gcSysDistroName} ---"
    n=0
    Sys_Dump_HLP	# MGN_Help_Box    ### local funxtion name
    C2M_ReStart
fi #
# end: ft(EXIT:guiDumpHLP)







#: =======================================================================
#:   Bottom of C2M Fall-Thru code  
#:   C2M_Fall_Thru_Trap  
#: =======================================================================
 






#(: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: ft(EXIT='') 
#(: called by: Fall-Thru
#(: param: 
#(: purpose: MAIN Fall-Thru QUIT
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note : 
#(:

###################
# # #  C.2.M. # # #
###################

lcMsgStr="-" && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"
lcMsgStr="-------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"
lcMsgStr=">>>  FALL-THRU trap for 'loose' code  " && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"
lcMsgStr="-" && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"

lcMsgStr="======================================= "  &&     Sbr_Str2DevTrm "$lcMsgStr" "3" "5" 

DISTRO_NAME_Z="Alpha:"$(echo $DISTRO_NAME | tr -dc 'A-z')
lcMsgStr="=== Orig ${DISTRO_NAME_Z} "  &&     Sbr_Str2DevTrm "$lcMsgStr" "3" "7" 

DISTRO_NAME_Z="Numbers:"$(echo $DISTRO_NAME | tr -dc '0-9')
lcMsgStr="=== Orig ${DISTRO_NAME_Z} "  &&     Sbr_Str2DevTrm "$lcMsgStr" "3" "7" 

lcMsgStr="======================================= "  &&     Sbr_Str2DevTrm "$lcMsgStr" "3" "5" 

lcMsgStr="-" && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"

lcMsgStr="<<<  FALL-THRU trap for 'loose' code  " && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"
lcMsgStr="-------------------------------------" && Sbr_Str2DevTrm "$lcMsgStr" "2" "5"

touch "/0-C2M-Run-DTS-9"       ### this is a Zero-Byte DTS Main Gui Marker file .

    echo "FALL-THRU has final standard 'exit 0'"
	echo "... Will Pop the Stack if Layered ..." 
    exit 0

### end:   "EXIT:QUIT" "EXIT:QUIT+"

#=======================================================================
    ### "QUIT" Should be a very 'final' quit action ###
    ### "QUIT" SHOULD NOT NOT RESTART ###
#=======================================================================


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# end: ft(EXIT:'')   #: Bottom of Code 
#(: ===========================================================================









# Note:
        # "T-6") lcOsSubSplClr="cyan" ;; 
        # "X-7") lcOsSubSplClr="cyan" ;; 
        # "Q-7") lcOsSubSplClr="cyan" ;; 
        # "I-I") lcOsSubSplClr="cyan" ;; 
        # T-6
        # X-750
        # Q-7
        # I-I
        # S-64
        # S-LxS
        # X-708

# working gae ARB Alternate RB export 'Idd' 



####################################################
#
#  Standard GNU General Public License Header :
#
#  2020 root <glen.e77is@Gmail.com>
#  website : www.GeoCities.WS/glene77is
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  To received a copy of the GNU General Public License
#  write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
####################################################
#
# gtkdialog -v
# gtkdialog version 0.8.4 release (C) 2003-2007 Laszlo Pere, 2011-2012 Thunor
# Built with support for: GTK+ 2, Glade.
#
# xmessage -v
# gxmessage-2.12.4
# Copyright (C) 2009 Timothy Richard Musson
# This is free software. 
# You may redistribute copies of it under the terms of the GNU General Public License 
# <http://www.gnu.org/licenses/gpl.html>.
#  

#######################################################################
#
### Developed using Geany, with option "Execute" 
### for trace in "BASH Terminal" for debug.
### many of our "echo" lines will show trace in the terminal screen.
###
### Using Geany with option "Execute" activates "BASH Terminal" mode . 
### We obtain good debugging via "BASH Terminal" mode. 
#
########################################################################
#
#
###############################################################################
### Note: 

	# BASH is a very common *nix shell, 
	# and it's programming language is purely procedural 
	# and focused on command execution. 

	# Object Oriented Programming (OOP) is a programming paradigm 
	# that represents the elements of a problem as entities 
	# with a set of properties and actions that it can execute. 
	# If you use Bash to write very simple and short scripts, 
	# procedural programming is just fine, you don't need more.
	# But if your program becomes more and more bigger, 
	# a monster BASH program (> 1000 lines), 
	# then you need a better way to structure your program ...
	# Dec 22, 2012
	# hipersayanx.blogspot.com › 2012/12 › object-oriented-pr.
	#
            ### OOP Concepts foreign to Unix Scripting Shell Languages
            ###    Abstraction. 
            ###    Encapsulation. 
            ###    Inheritance. 
            ###    Polymorphism.

	### A monster BASH script program ( > 10,000 lines ) 
	### requires a modern high-level language like Python.
	#
	### 'strict' lockfile method NOT implemented.
	### 	exit 1   ### >>> exit >>> from script >>> ###
	### 'strict' lockfile method NOT implemented.
	### 'strict' WILL exit from PRG script at this 'base' stack level.
	###
	### IF 'strict' block is written into a funxtion() , 
	### 	THEN exit will only "pop" one level at that funxtion() level. 
	### 	and will not quit the PRG as desired. 

###############################################################################

   ### > Note about specifying the "System Location" :
   ### > Is it "/initrd/mnt/dev_save" or "/mnt/home" ??? 
   ### > BK = Barry Kauler calculated "system location" this way : 
   ### > calcs are performed after 
      ### (1) system has booted : 
      ### (2) 'aufs' is running : 
   ### > gcSaveFileNameMount : 
      ### ="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
      ### =cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d '=' 
   ### > gcSaveFileNameBaseSrc : 
      ### ="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
      ### =cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d '='
   ### > Author's current Upup system location is '"/initrd/mnt/dev_save"' 
   ### > BK = Barry Kauler calculated "system location" that way : 

###############################################################################

# # basename --help
# BusyBox v1.35.0 (2022-05-11 12:27:11 +08) multi-call binary.
# Usage: basename FILE [SUFFIX] | -a FILE... | -s SUFFIX FILE...
# Strip directory path and SUFFIX from FILE
#    -a		All arguments are FILEs
#    -s SUFFIX	Remove SUFFIX (implies -a)
# # basename --help




# COLOR: 
# from menu.lst code # work, but selection is blinking. 
# color white/purple
# color white/red
# color white/green
# color white/blue
#
# COLOR: good choice
# per FOSSwire.com
# black
# blue
# green
# cyan
# red
# magenta
# brown
# light-gray
# These below can be specified only for the foreground.
# dark-gray
# light-blue
# light-green
# light-cyan
# light-red
# light-magenta
# yellow
# white
# COLOR: not good choice
# color light-gray/red red/light-gray




# end Notes 
###############################################################################

