#!/bin/bash
#
### name : rc.z_C3C
### ### /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
###
### rc.z_Clear3Cache
### purpose : Clear Cache type directories
### param : system
### sends : none
#   
# S7 Iron C3C will kill all Iron Passwords
#
########################################################################
#  Standard GNU General Public License Header :
#
#  2020 root <glen.e77is@Gmail.com>
#  website : www.GeoCities.WS/glene77is
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  To received a copy of the GNU General Public License
#  write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
#######################################################################
#
### Developed using Geany, with option "Execute" 
### for trace in "BASH Terminal" for debug.
### many of our "echo" lines will show trace in the terminal screen.
###
### Using Geany with option "Execute" activates "BASH Terminal" mode . 
### We obtain good debugging via "BASH Terminal" mode. 
#
########################################################################

########################################################################
### extra saveDATA size from these : 
#/initrd/mnt/dev_save/pup_UpupBB+24/upupbbsave+24-gen/var/log/previous.messages
#/initrd/mnt/dev_save/pup_UpupBB+24/upupbbsave+24-gen/var/packages


########################################################################
### 200213-1030 gae,
### 200214-1900 gae, cut/pasted Clear-3-Cache code from S2F
### 200220-0630
### 200224-0615    ### /intrd/mnt/dev_save/MY_/usr-share/gae-Dev
### 200229-1000 gae, also delete /etc/rc.d/rc.*.dts
### 200302-0525
### 200314-0408
### 200318-0533
### 200320-0600
### 200321-0730
### 200330-1000
### 200402-2350
### 200403-0623
### 200404-0451 gae, language changed to sh
### 200404-2042
### 200406-0549
### 200413-1034 restored
### 200415-0706
### 200415-1744
### 200423-0608
### 200514-0625
### 200519-0723
### 200812-0555 gae, removed calls to cull FireFox. Must be handled Std. 
### 200819-0639 gae, cull /root/.cache/mozilla/firefox/35foaciw.default/cache2/entries
### 200910-0907
### 200915-0628
### 201024-1400
### 201027-0630
### 201114-0808
### 201209-0500
### 201215-0524
### 210103-1840
### 210205-1930
### 210222-1300
### 210306-0120
### 210718-0545
### 211223-1200
### 220205-0700 gae, /root/.cache/moonchild productions
### 220615-0623 gae, could use some touchup. 

########################################################################

#------------------------------------------------------------------------------------
export gcSysDevDob="220617-0945"
export gcSysDevDob="221206-0730"
#------------------------------------------------------------------------------------
#(: System Developer ID name of this Linux BASH script is "CTB"
export gcSysDevId="C3C"	
#(:-----------------------------------------------------------------------------------
#:### MGN PATH  "rc.sysinit" calls function-x to check/link "/etc/rc.d"
#:### PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/root/my-applications/bin/ 
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/etc/rc.d:/root/my-applications/bin/ 



#:#######################################################################
function Sys_SetVerDts() {
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################
### Manual Entry for  Developers Version  Date-Time-Stamp ################


###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#~ export gxVerDts="211223-1200"
#~ export gcDtsVer="211223-1200" 
export gcDtsVer="220615-0630"
###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

export lcSysDts="`date +%y%m%d-%H%M-%S`"   ### grave-mark in date() !!!

export lcSysVer="${PUPSFS}"
# Linux UpupBB 4.9.163-lxpup-32-pae puppypc3073 "
# #1 SMP Thu Mar 14 15:41:19 GMT 2019 i686 i686 i686 GNU/Linux"

export lcSysNameBase="C3C"	### used in code as label

    ### trace results to terminal window.
    echo "gxVerDts: ${gxVerDts} ......."
    echo "gcDtsVer: ${gcDtsVer} ......."
    echo "lcSysDts: ${lcSysDts} ......."

    ###^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^####
}   ### end: Sys_SetVerDts


#:#######################################################################
function C3C_Show_Splash() {    ### from orig Hot-Backup v.1.2 ### Not Called ###
	### Not Called ###
    ### called by Alternate "DONE" progress dialog splash.
    ### intended to be a 'bare minimum' progress dialog splash.
    ### receives no 'color' param , should show default black/grey .
    ### receives param only for "text"
	/usr/lib/gtkdialog/box_splash -close never -text "$@" &
	pidx=$!
}   ### end: B2T_Show_Splash
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!----


#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#~ function Sys_ShowSplash() {     ### not called
    #~ ### Sys_ShowSplash  "msg" "fg" "bg" "icon"
	#~ /usr/lib/gtkdialog/box_splash -fg ${2} -bg ${3} -close never -icon ${4} -text "${1}" & GTKPIDX=$!
#~ }   ### end: Sys_ShowSplash





#:#######################################################################
function Sys_PupState(){
    ###
    ### called by Main()
    ### param
    ### purpose :
    ###     consolidation of PUPSTATE
    ###     control generation of local var
    ### rationale :
    ### Puppy writes the "state" variables into /etc/rc.d/PUPSTATE .
    ###
    #--- load PUPSTATE ---
    . /etc/rc.d/PUPSTATE
    #
	#~ echo "BK ==============================================="  
	#~ lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
	#~ echo "SaveFileNameMount = ${lcSaveFileNameMount}"
	#~ lcSaveFileNameBaseSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
	#~ echo "SaveFileNameBaseSrc = ${lcSaveFileNameBaseSrc}"
	#~ echo "BK ==============================================="  
	#
    ### direct import, similar varname.
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
    lcPupSubDir=${PSUBDIR}
    lcPupDts="`date +%y%m%d-%H%M-%S`"   ### grave-mark in date() !!!
    lcPupHome=${PUP_HOME}
    lcPupSave=${PUPSAVE}
    lcPupMode=${PUPMODE}
#
### maintain similarity to PUPSTATE "name"
    lcPupSaveNameRaw="PUPSAVE : ${lcPupSve}"  # savefilename from PUPSTATE
    lcPupSaveName="`echo $lcPupSave | cut -f 3 -d "/"`" # savefilename
    lcPupSaveNameDts="${lcPupSaveName}.BKP-`date +%y%m%d-%H%M-%S`"     ### grave-mark in date() !!!
    lcPupSaveNameTrg="${lcPupSaveNameDts}.tar.gz"
    lcPupSaveNameSrc="${lcPupSaveName##*/}"
    lcPupSubDir="${lcPsubDir}.BKP-`date +%y%m%d-%H%M-%S`"      ### grave-mark in date() !!!
    lcPupDistroVer=${gcSysDistroVer}  ### 'BionicPup32-19.03+18 +++'-sig
###

########################################################################
    lcC3Cdistro="UpupBB-19.03 v:8.0 +??" ### Developers OS Version.
    lcC3Cdistrover="${lcPupDistroVer}"
    lcC3Cname="Clear3Cache"
	lcC3Clias="C3C"
    lcSleep0="sleep .3"
    lcSleep1="sleep .7"
    lcSleep2="sleep 1.8"

    #
}   ### end: Sys_PupState





#:#######################################################################
function C3C_Run_It() { ### active

    lcRunFnSrc=${1}

        ### These Target files/subdir are "STATIC" ###
        ### functions for 'Locate_Src' and 'Run_Src' are not required.
        ### written by Glen Ellis 

    ### test 'if' exist
     if [ -f ${lcRunFnSrc} ] ; then
        lcMsgStr="rm -fr ${lcRunFnSrc}"
        echo "=== ${lcMsgStr}"
# --- RunIt ------------------------------------------
box_splash -fg blue -bg yellow -close never -text "
     ${lcRunFnSrc}
           " &
# ----------------------------------------------------
        $lcSleep1
        GTKPID=$!
        kill $GTKPID

        rm -fr $lcRunFnSrc
        #~ $lcSleep2
        #
    else
        ### raise flag
        lcDummy=0
        lcMsgStr="${lcRunFnSrc}"
        echo ">>> ${lcMsgStr}"
# --- NotFound --------------------------------------------------------------------
box_splash -fg yellow -bg red -close never -text " 
         Not Found:
       ${lcMsgStr}
                   " &
# -----------------------------------------------------------------------
        $lcSleep1
        #~ $lcSleep1
        #~ $lcSleep2
        GTKPID=$!
        kill $GTKPID

        rm -fr $lcRunFnSrc
        $lcSleep1
        #
    fi

	echo "======= "
    
    #
}   ### end: fx(C3C_Run_It)







#######   MAIN()   #####################################################
#######   MAIN()   #####################################################
#######   MAIN()   #####################################################
#######   MAIN()   #####################################################
#######   MAIN()   #####################################################
#######   MAIN()   #####################################################


Sys_SetVerDts   ### call for version date

Sys_PupState    ### load Puppy system state constants

#:#############################################################
### borrowed from "/etc/rc.d/rc.sysinit"
###  plus :  /usr/lib/gtkdialog/:
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11R7/bin:/usr/lib/gtkdialog/:


#'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
### Locate_Src and Run_Src are NOT REQUIRED in his module.
### Not Required because all calls are to Static locations in System.


#'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
###   MAIN Splash   ####################################################
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### No Choices, no Selections required, therefore no GUI .............

clear
echo "===> $lcC3Cname : Running Now"
#~ lcMsgStr="    $lcC3Cname  ${gcDtsVer}    "  
#~ ### lingering bug: gcDtsVer is always "200428" 
#~ ### switched from gcDtsVer to gxVerDts 
#~ echo "${lcMsgStr} ${gcDtsVer} vs ${gxVerDts} ==="

### this is Main_Splash, and is BACKGROUND for other Splashes.
# --- Several --------------------------------------------------------------------
box_splash -bg red -close never -text "\
.  ...mgn...  $lcC3Cname   ${gcDtsVer}  
.    Clearing Several Cache / Storage areas
.
.
.        ...   Running  NOW !  ...
.
.
.
.
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPIDNOW=$!  &&  $lcSleep0
    ### kill $GTKPIDNOW after "done" splash

########################################################################
# /etc/rc.d/rc.z_S2F
# code is built upon /usr/share/sbin/save-2-flash
########################################################################



if [ "0" = "0" ] ; then   #  test flag.

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
########################################################################
###




############################################################################
### .cache
############################################################################
### Clear these possibly lingering .cache subdir,
###     which may be 100 MB size and enlarge the saveFolder grossly.
### Note: we have edited the "U-Light" browser profile
###     so that "U-Light" browser will call
###     "/root/.cache/light/light/Lite-profile.default"
###     This will be our common cache for U-light.
###     Other browsers can be handled the same way.
###     This routine clears the left-over trash.
############################################################################
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### Cache ################################################################

### this is Secondary_Splash
# --- Lingering --------------------------------------------------------------------
box_splash -bg lightblue -close never -text "\
.                ${lcC3Calias}
.        Clear Lingering Files in root
.
.
.
.
.........................................................." & ### line 9, pos 57

# -----------------------------------------------------------------------
RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
###
### done:
###--- Clear Lingering Files from running .root location ----------------------
export lcFileName="(06)  Cache event-sound"
lcFileSrc="/root/.cache/event-sound/*"
echo "===> execute: Rm : rm -fr  $lcFileSrc"
C3C_Run_It  "${lcFileSrc}"

###--- Clear Lingering Files -------------------------------------------
export lcFileName="(05)  Cache mesa_shader"
lcFileSrc="/root/.cache/mesa_shader_cache/*"
echo "===> execute: Rm : rm -fr  $lcFileSrc"
C3C_Run_It  "${lcFileSrc}"

###--- Clear Lingering Files -------------------------------------------
export lcFileName="(04)  "
lcFileSrc="/root/.cache/event-sound-cache*"
echo "===> execute: Rm : rm -fr  $lcFileSrc"
C3C_Run_It  "${lcFileSrc}"

kill $GTKPID0




##################################
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### shinobar : var spool cups tmp #############
##################################
###--- Clear Lingering Files -------------------------------------------


lcFileSrc="/root/C3C_No_Clear_Cups_"
if [ -f ${lcFileSrc} ] ; then   #  test flag. not required ? 

		### this is Secondary_Splash
		#-----------------------------------------------------------------------

#~ box_splash -bg lightblue -close never -text "\
#~ .                ${lcC3Calias}
#~ .            NOT Clearing CUPS Cache 
#~ .
#~ .
#~ .
#~ .
#~ .........................................................." & ### line 9, pos 57

		#-----------------------------------------------------------------------
#~ RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
		### kill $GTKPID0 after "done" splash
echo "===> NOT CLEARING ### CUPS ### ==="
#~ sleep 5


else

		### this is Secondary_Splash
		# --- CUPS --------------------------------------------------------------------

box_splash -bg lightblue -close never -text "\
.                ${lcC3Calias}
.            Clearing CUPS Cache 
.
.
.
.
.........................................................." & ### line 9, pos 57
		# -----------------------------------------------------------------------
		RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0


		#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		### CUPs ########################################################

		### CUPS ###
		###  [06/Mar/2020:04:45:39 +0500] Cleaning out old files in "/var/spool/cups/tmp".
		lcFileSrc="/var/spool/cups/tmp/*"
		lcFileName="(01)  ${lcFileSrc}"
		echo "===> execute: rm -fr  ${lcFileSrc}"

		C3C_Run_It  "$lcFileSrc"

		### CUPS ###
		###  [06/Mar/2020:04:45:39 +0500] Cleaning out old files in "/var/cache/cups".
		lcFileSrc="/var/cache/cups/*"
		lcFileName="(02)  ${lcFileSrc}"
		echo "===> execute: rm -fr  ${lcFileSrc}"

		C3C_Run_It  "$lcFileSrc"

		### CUPS ###
		###  [06/Mar/2020:04:45:39 +0500] Cleaning out old files in "/var/spool/cups/tmp/*".
		lcFileSrc="/var/spool/cups/tmp/*"
		lcFileName="(03)  ${lcFileSrc}"
		echo "===> execute: rm -fr  ${lcFileSrc}"

		C3C_Run_It  "$lcFileSrc"

		### CUPS ###
		###  [06/Mar/2020:04:45:39 +0500] Cleaning out old files in "/var/spool/cups/*".
		lcFileSrc="/var/spool/cups/*"
		lcFileName="(04)  ${lcFileSrc}"
		echo "===> execute: rm -fr  ${lcFileSrc}"

		C3C_Run_It  "${lcFileSrc}"

kill $GTKPID0

fi   ### CUPS ###

fi ### if [ "0" = "0" ] ; then
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&







#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
### PaleMoon: MoonChild ###########################
### PaleMoon: MoonChild ###########################
### PaleMoon: MoonChild ###########################

### /root/.cache/moonchild productions/pale moon/9b8dk8nh.default/cache2/entries
### /root/.cache/moonchild productions/pale moon/palemoon.default/thumbnails

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### MoonChild PaleMoon Cache ################

if [ "0" = "0" ] ; then   #  test flag.

### this is Secondary_Splash

# --- PaleMoon --------------------------------------------------------------------
box_splash -bg lightblue -close never -text "\
.                ${lcC3Calias}
.            Clearing PaleMoon Cache 
.
.
..
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash


	### PaleMoon *** CACHE ***
	lcFileSrcBase="/root/.cache/moonchild productions"
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### Light Cache ####################
	### Light *** CACHE ***
	###            /root/.cache/light/light/light.default/cache2/entries

	lcFileSrcBaseX="/root/.cache/light/light/light.default/cache2/entries"
	lcFileName="(106)  Light: Cache cache2/entries"
	lcFileSrc="${lcFileSrcBaseX}"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"



	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ####################
	### PaleMoon *** CACHE ***
	###            /root/.cache/moonchild productions/pale moon/palemoon.default

	lcFileSrcBaseX="/root/.cache/moonchild?productions/pale?moon/palemoon.default"
	lcFileName="(106)  PaleMoon: Cache palemoon.default"
	lcFileSrc="${lcFileSrcBaseX}"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"



	#~ lcFileSrcBase="/root/.cache/moonchild?productions/pale?moon/palemoon.default"
	lcFileName="(106)  PaleMoon: Cache palemoon.default"
	lcFileSrc="${lcFileSrcBase}/palemoon.default/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"



	### PaleMoon Cache ####################
	### /root/.cache/moonchild productions/pale moon/palemoon.default
	lcFileName="(107)  PaleMoon: Cache Thumbnails"
	lcFileSrc="${lcFileSrcBase}/thumbnails/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.cache/light/light/Lite-profile-default/cache2/entries
	lcFileName="(108)  PaleMoon: Cache Entries"
	lcFileSrc="${lcFileSrcBase}/cache2/entries/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.cache/light/light/Lite-profile-default/cache2/doomed
	lcFileName="(109)  PaleMoon: Cache Doomed"
	lcFileSrc="${lcFileSrcBase}/cache2/doomed/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

fi ### if [ "0" = "0" ] ; then

#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
### PaleMoon *** SQL *** working 
#lcFileSrcBase="/root/.moonchild?productions/pale?moon/palemoon.default/"
#~ lcFileSrcBase="/root/.moonchild productions/pale moon/palemoon.default"
# /initrd/mnt/dev_save/pup_UpupBB+26-hdx/upupbbsave+26-slg-a/root/.moonchild productions/pale moon/palemoon.default/places.sqlite                    

if [ "0" = "1" ] ; then   #  test flag.

	lcFileSrcBase="/root/.moonchild?productions/pale?moon/palemoon.default/"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.moonchild productions/pale moon/palemoon.default/places.sqlite
	lcFileName="(110)  PaleMoon: places.sqlite"
	lcFileSrc="/initrd/mnt/dev_save/pup_UpupBB+26-hdx/upupbbsave+26-slg-a/root/.moonchild productions/pale moon/palemoon.default/places.sqlite"
	# lcFileSrc="${lcFileSrcBase}places.sqlite"
	# lcFileSrc="/root/.moonchild productions/pale moon/palemoon.default/places.sqlite"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
	# rm -fr ${lcFileSrc}
	# rm -fr "/initrd/mnt/dev_save/pup_UpupBB+26-hdx/upupbbsave+26-slg-a/root/.moonchild productions/pale moon/palemoon.default/places.sqlite"
	rm -fr "/initrd/mnt/dev_save/pup_UpupBB+26-hdx/upupbbsave+26-slg-a/root/.moonchild productions/pale moon/palemoon.default/places.sqlite"
	# rm -fr "/root/.moonchild productions/pale moon/palemoon.default/places.sqlite"
	# C3C_Run_It  "${lcFileSrc}"
	#read
	#exit 0
fi ### if [ "0" = "0" ] ; then



if [ "0" = "1" ] ; then	### test flag. copy extra for development

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.moonchild productions/pale moon/palemoon.default/cookies.sqlite
	lcFileName="(111)  PaleMoon: cookies.sqlite"
	lcFileSrc="${lcFileSrcBase}cookies.sqlite"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.moonchild productions/pale moon/palemoon.default/content-prefs.sqlite
	lcFileName="(112)  PaleMoon: content-prefs.sqlite"
	lcFileSrc="${lcFileSrcBase}content-prefs.sqlite"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.moonchild productions/pale moon/palemoon.default/cert8.db
	lcFileName="(113)  PaleMoon: cert8.db"
	lcFileSrc="${lcFileSrcBase}cert8.db"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

fi ### if [ "0" = "0" ] ; then

kill $GTKPID0





#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### SeaMonkey Cache ################

if [ "0" = "1" ] ; then		### test flag

### this is Secondary_Splash

# --- SeaMonkey --------------------------------------------------------------------
box_splash -bg lightblue -close never -text "\
.                ${lcC3Calias}
.            Clearing SeaMonkey Cache 
.
.
..
........................................................read.." & ### line 9, pos 57
#read
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash

	### SeaMonkey *** CACHE ***
	lcFileSrcBase="/root/.cache/mozilla/seamonkey"
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### SeaMonkey Cache ####################
	### /root/.cache/mozilla/seamonkey/a3k3zid6.default/thumbnails
	#~ lcFileName="(107)  SeaMonkey:      "
	#~ lcFileSrc="${lcFileSrcBase}/       /*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		#~ # rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.cache/light/light/Lite-profile-default/cache2/entries
	lcFileName="(108)  SeaMonkey: Cache Entries"
	lcFileSrc="${lcFileSrcBase}/cache2/entries/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### PaleMoon Cache ##################
	### /root/.cache/light/light/Lite-profile-default/cache2/doomed
	lcFileName="(109)  SeaMonkey: Cache Doomed"
	lcFileSrc="${lcFileSrcBase}/cache2/doomed/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	read	### Not Running This for SeaMonkey 

fi ### if [ "0" = "0" ] ; then

kill $GTKPID0






#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### U-Light Cache ################
#############################

if [ "0" = "0" ] ; then   #  test flag.

### this is Secondary_Splash
#-----------------------------------------------------------------------

# --- U-Light --------------------------------------------------------------------
box_splash -bg  lightgreen -close never -text "\
.                ${lcC3Calias}
.            Clearing U-Light Cache 
.
.
.
.
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### Light Cache ####################
	lcFileSrcBase="/root/.cache/light/light/Light.default/"

	### /root/.cache/light/light/Lite-profile-default/thumbnails
	lcFileName="(07)  Light: Cache Thumbnails"
	lcFileSrc="${lcFileSrcBase}/thumbnails/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### Light Cache ##################
	### /root/.cache/light/light/Lite-profile-default/cache2/entries
	lcFileName="(08a)  Light: Cache Entries"
	lcFileSrc="${lcFileSrcBase}/cache2/entries/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### Light Cache ##################
	### /root/.cache/light/light/Lite-profile-default/cache2/doomed
	lcFileName="(08a)  Light: Cache Doomed"
	lcFileSrc="${lcFileSrcBase}/cache2/doomed/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

fi ### if [ "0" = "0" ] ; then

kill $GTKPID0






#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### FireFox Cache ################

if [ "0" = "0" ] ; then   #  test flag.

### this is Secondary_Splash

# --- FireFox --------------------------------------------------------------------
box_splash -bg lightblue -close never -text "\
.                ${lcC3Calias}
.            Clearing FireFox Cache 
.
.
..
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash

	### FF 60 re-writes entire subdir OK. 
	### OK to clear all
	lcFileName="(09a)  FireFox: .cache"
	lcFileSrc="/root/.cache/mozilla/firefox/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		#~ rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

kill $GTKPID0


### FireFox Usr Lib  is  LINKED  ###########
### switrch to PaleMoon Japanese FireFox 

### FireFox Usr Lib ReQuires SFS-ReLoad #####
#~ lcFileName="(09b)  FireFox Usr Lib Entries"
#~ lcFileSrc="/usr/lib/firefox"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

#~ lcFireFoxCache="slj0rcj0.default-release-1"

#~ lcFileName="(09a)  FireFox .cache"
#~ lcFileSrc="/root/.cache/mozilla/firefox/$lcFireFoxCache/thumbnails"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

#~ lcFileName="(09b)  FireFox .entries"
#~ lcFileSrc="/root/.cache/mozilla/firefox/$lcFireFoxCache/cache2/entries"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

#~ lcFileName="(09c)  FireFox .doomed"
#~ lcFileSrc="/root/.cache/mozilla/firefox/$lcFireFoxCache/cache2/doomed"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

#~ lcFileName="(09a)  FireFox .cache"
#~ lcFileSrc="/root/.cache/mozilla/firefox/FireFox-Profile.default/thumbnails"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

#~ lcFileName="(09b)  FireFox .entries"
#~ lcFileSrc="/root/.cache/mozilla/firefox/FireFox-Profile.default/cache2/entries"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

#~ lcFileName="(09c)  FireFox .doomed"
#~ lcFileSrc="/root/.cache/mozilla/firefox/FireFox-Profile.default/cache2/doomed"
#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

fi ### if [ "0" = "0" ] ; then






#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### Iron Default Cache ################

if [ "0" = "0" ] ; then   #  test flag.

### this is Secondary_Splash

# --- IRON --------------------------------------------------------------------
box_splash -bg lightgreen -close never -text "\
.                ${lcC3Calias}
.            Clearing IRON Cache 
.
.
.
.
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	lcFileName="(11)  IRON cache Default Cache "
	lcFileSrc="/root/.cache/iron/Default/Cache"
	echo "===> execute: $lcRmFolder : rm -fr  $lcFileSrc"
		#~ rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	lcFileName="(12)  IRON cache Media Cache"
	### Special for filename with internal " " .
	lcFileSrc="/root/.cache/iron/Default/Media?Cache"   ### original subdir name
	echo "===> execute: ===: rm -fr  ${lcFileSrc}"
		#~ rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#~ kill $GTKPID0

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	### IRON RAM Config #################
	################################
	###--- Clear IRON config -----------------------------------------------
	### These clear 16 MB of RAM /root/config/iron/ files.
	### These are rebuilt on each run of IRON
	###	### 103 down to 29 MB = 74MB 
	### /usr/share/.config/iron	### if removing IRON
	###	/usr/share/.config/iron/Default
	###	/usr/share/.config/iron/pnacl
	###	/usr/share/iron 

	### ### /root/iron moved / linked from /My_/usr-share/iron

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(13)  IRON: config iron default 
	#~ lcFileSrc="/root/.config/iron/Default/*"
	#~ echo "===> execute: $lcRmFolder : rm -fr  $lcFileSrc/*"
	#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(14)  IRON: default Local Storage"
	#~ lcFileSrc="/root/.config/iron/Default/Local?Storage/*"
	#~ echo "===> execute: $lcRmFolder : rm -fr  $lcFileSrc/*"
		#~ # rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#*** ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(15)  IRON: root config iron Pnacl"
	#~ lcFileSrc="/root/.config/iron/pnacl/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		#~ # rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#*** ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(16)  Iron: root config iron EVWhitelist"
	#~ lcFileSrc="/root/.config/iron/EVWhitelist/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		# #~ rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(17)  Iron: root config iron ShaderCache"
	#~ lcFileSrc="/root/.config/iron/ShaderCache/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(18)  Iron: root config iron Service Worker"
	#~ lcFileSrc="/root/.config/iron/Default/Service?Worker/*" 
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
			#~ # rm -fr ${lcFileSrc}
	#~ C3C_Run_It "$lcFileName" "$lcFileSrc"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(19)  Iron: root config iron Service Storage"
	#~ lcFileSrc="/root/.config/iron/Default/Service?Storage/*" 
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(20)  Iron: root config iron Session Storage"
	#~ lcFileSrc="/root/.config/iron/Default/Session?Storage/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(21)  Iron: root config iron GPUCache"
	#~ lcFileSrc="/root/.config/iron/Default/GPUCache/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		# rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#~ lcFileName="(22)  Iron: root config iron IndexedDB"
	#~ lcFileSrc="/root/.config/iron/Default/IndexedDB/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		#~ # rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"




	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# gae working
	#~ lcFileName="(23)  Iron: root config iron IndexedDB"
	#~ lcFileSrc="/usr/share/.config/iron/Default/*"
	#~ echo "===> execute: ===: rm -fr  $lcFileSrc"
		#~ rm -fr ${lcFileSrc}
	#~ C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
# gae working
	lcFileName="(24)  Iron: root config iron IndexedDB"
	lcFileSrc="/usr/share/.config/iron/pnacl/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

fi	### if [ "0" = "0" ] ; then

kill $GTKPID0





#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### Chromium Default Cache ############
###--- Clear Chromium config -----------------------------------------------
### These clear 34 MB of RAM  files.
### These are rebuilt on each run of Chromium
##############################

if [ "0" = "1" ] ; then		###  test flag.   Not Using CHROMIUM

### this is any Secondary_Splash

# --- Chromium --------------------------------------------------------------------
box_splash -bg lightgreen -close never -text "\
.                ${lcC3Calias}
.            Clearing Chromium Cache
.
.
.
.
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	lcFileName="(30)   Chromium: /root/spot/.config/chromium/Safe Browsing"
	lcFileSrc="/root/spot/.config/chromium/Safe Browsing"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
	#~ echo ":${lcFileName}:${lcFileSrc}:"
		#~ rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

	#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	lcFileName="(31)   Chromium: /home/spot/.cache/chromium/Default/Cache/*"
	lcFileSrc="/home/spot/.cache/chromium/Default/Cache/*"
	echo "===> execute: ===: rm -fr  $lcFileSrc"
		#~ rm -fr ${lcFileSrc}
	C3C_Run_It  "${lcFileSrc}"

fi	### if [ "0" = "0" ] ; then

kill $GTKPID0





#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
### pMusic Cache ########################
###--- Clear pMusic config -----------------------------------------------
### These clear 632MB of .au files.
### These are rebuilt on each run of pMusic

### this is the Secondary_Splash

# --- pMusic --------------------------------------------------------------------
box_splash -bg lightgreen -close never -text "\
.                ${lcC3Calias}
.            Clearing pMusic Cache
.
.
.
.
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
lcFileName="(40)  /root/.pmusic/tmp/pmusic.au/*"
lcFileSrc="/root/.pmusic/tmp/pmusic.au/*"
echo "===> execute: ===: rm -fr  $lcFileSrc"
	#~ rm -fr ${lcFileSrc}
C3C_Run_It  "${lcFileSrc}"

kill $GTKPID0






#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



### this is the Secondary_Splash	### ALWAYS clear ###

### lcMsgStr="    $lcC3Cname  ${gxVerDts}    "  
### assigned before first Clearing function, above. 
# --- LockFiles --------------------------------------------------------------------
box_splash -bg lightgreen -close never -text "\
.                ${lcC3Calias}
.            Clearing Cache/LockFiles
.
.
.
.
.........................................................." & ### line 9, pos 57
# -----------------------------------------------------------------------
	RETVAL=$?  &&  GTKPID0=$!  &&  $lcSleep0
    ### kill $GTKPID0 after "done" splash


############### fixit : MGN_cleanup   /tmp/MGN_lockfile.lck

	#~ echo "===> clear Lock-Files ===>"
	#~ MGN_lockfile="/tmp/MGN_lockfile.lck"
    #~ rm -f "${MGN_lockfile}"
	#~ MGN_Apply_Status="/tmp/MGN_Apply_Status.flg"
	#~ rm -f "${MGN_Apply_Status}" ### release "Done" flag. 

     ### remove flags left residually. 
     ### each prg should touch/remove its own flags. 
     
    /bin/echo " " > /dev/console
    lcMsgStr=">>> C3C fixit" && . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"  "1"  "2"

	lcMsgStr="/tmp/CTB_*"  &&  . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"   "1"  "2"
		rm -f "${lcMsgStr}"  ### this is CTB _lockfile flag
              
	#~ lcMsgStr="/tmp/CTB_lockfile.lck"  &&  . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"   "yel"  "2"
		#~ rm -f "${lcMsgStr}"  ### this is CTB _lockfile flag
              
	#~ lcMsgStr="/tmp/CTB_BackUp_Status"  &&  . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"   "yel"  "2"
		#~ rm -f "${lcMsgStr}"  ### this is CTB_BackUp_Status
        
	lcMsgStr="/tmp/MGN_*" && . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"   "1"  "2"
		rm -f "${lcMsgStr}"  ### this is MGN _lockfile flag

	#~ lcMsgStr="/tmp/MGN_lockfile.lck" && . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"   "yel"  "2"
		#~ rm -f "${lcMsgStr}"  ### this is MGN _lockfile flag

	#~ lcMsgStr="/tmp/MGN_Apply_Status.flg"  &&  . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:" "grn" "2"
		#~ rm -f "${lcMsgStr}" ### MGN  Apply flag

    lcMsgStr="<<< fixit" && . /etc/rc.d/rc.zStr2Msg ":${lcMsgStr}:"  "1"  "2"

 
#~ read ### working fixit

 

#-----------------------------------------------------------------------

    kill $GTKPID0

    kill $GTKPID

#-----------------------------------------------------------------------



#~ fi ### if [ "0" = "0" ] ; then


########################################################################
########################################################################
########################################################################
### Bannering
### simple roll through several colored splashes of "DONE' CLEAN-UP

# --- DONE --------------------------------------------------------------
lcMsgStr="--- DONE ---"
# -----------------------------------------------------------------------
box_splash -fg cyan -bg red -close never -text "   ${lcMsgStr} " &
# -----------------------------------------------------------------------
        GTKPID1=$!  &&  sleep .5
# -----------------------------------------------------------------------
box_splash -fg yellow -bg green -close never -text "   ${lcMsgStr} " &
# -----------------------------------------------------------------------
        GTKPID2=$!  &&  sleep .5
# -----------------------------------------------------------------------
box_splash -fg white -bg blue -close never -text "   ${lcMsgStr} " &
# -----------------------------------------------------------------------
        GTKPID3=$!  &&  sleep .5
# -----------------------------------------------------------------------
        kill $GTKPID3
        sleep .5
        kill $GTKPID2
        sleep .5
        kill $GTKPID1
        sleep .5
# -----------------------------------------------------------------------

    kill $GTKPIDNOW  ### Main Screen

############################################################################
### box_splash -fg yellow -bg blue -close never -text "   ${lcMsgStr} " &
############################################################################

	sleep .5
	echo 
	echo "BK ==============================================="  
	lcSaveFileNameMount="`cat /sys/fs/aufs/si_*/br0 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameMount = ${lcSaveFileNameMount}"
	lcSaveFileNameBaseSrc="`cat /sys/fs/aufs/si_*/br1 | head -1 | cut -f1 -d'='`"
	echo "SaveFileNameBaseSrc = ${lcSaveFileNameBaseSrc}"
	echo "BK ==============================================="  

### Do Not RESTART script auto ###
### MGN will handle "ReStart"

### END ###
#########################################################################


#~ /root/.cache/light/light/light.default/cache2/entries
