#!/bin/bash
#
# rc.z_PBKP-dev.sh
#
# from: 
# pupsave-backup 1.3.1
# Hot Backup
# ? compress or full-size
# ? gzip or xz 
# ! if after finish, then leaves splash on screen 

#=======================================================================
# this is the Near-Original with standardized formatting and reduced options. 
#=======================================================================
# begin dev on QUIT
# begin dev on BACKUP
# begin dev on case-n-hack mainGUI
#
########################################
export gcSysDevDob="221123-0604"
export gcSysDevDob="221124-1725"
### beging PBKP #########################
export gcSysDevDob="221125-0844"
########################################

export gcSysID="+"
export gcZeroRun="${0}" 
export gcZeroRun1="rc.z_PBKP-dev.sh" 
export gcZeroRun2="/MY_/usr-share/My_Dev_/Edit_PBKP/rc.z_PBKP-dev.sh" 
export gcZeroRun3="/root/my-Applicatons/rc.z_PHB-dev.sh" 
export gcZeroRunX="${0}"
# "${0}" why not this ? 
########################################

#set -x

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PHB_ReStart() {
    n=0
echo "(ReStart) :${0}:${gcZeroRunX}:" 
read
. "${gcZeroRunX}" 
.  ${gcZeroRunX} 
#~ . /root/my-applications/rc.z_PHB-RMA.sh
} # end: PHB_ReStart
export -f PHB_ReStart


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function Show_SplashIt() {   # NOT Active
# called: Show_SplashIt "text" "fg" "bg" "timeout"
/usr/lib/gtkdialog/box_splash -text "${1}" -fg "${2}" -bg "${3}"  -timeout "${4}"  
 	GtkPid_SplashIt=$! 
    kill ${GtkPid_SplashIt} > /null
} # end: fx(Show_SplashIt)
export -f Show_SplashIt

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function show_splash() {   # NOT Active
	/usr/lib/gtkdialog/box_splash -close never -text "$@" &
	pidx=$!
} # end: fx(show_splash)
export -f show_splash

#~ <b>Run from /root/my-applictions/filename
#~ <b>Edit in Geany
#~ <b>Execute in 'Terminal' 

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PBKP_Help_Box() {
	echo "$ERRORMSG
<b>${gcZeroRun3}</b>
<b>:Pupsave Backup:</b> for frugal Puppy installations 
makes a backup copy of the live pupsave file/folder.
: pfix=ram

<b>1)</b> For best results, shut down all applications 
and servers before backing up. 

<b>2)</b> The date and time is automatically appended 
to the backup file name.

<b>3)</b> Pupsave Backup backs up system configuration 
as it exists in the pupsave. <span foreground='"'red'"'>
It will not backup data stored outside the pupsave.</span>

To restore a backup, rename the file by UExtract

You can force the init script to not ignore pupsaves 
created by this script by adding a boot parameter
: pfix=psavebkp

You must be running a frugal install with a pupsave 
otherwise PB will not run." > /tmp/box_help
	/usr/lib/gtkdialog/box_help "Pupsave Backup Help"
}
export -f PBKP_Help_Box

#------------------------------------------------------------------------
gcFlag_PSHB_Lock="/tmp/flag_PSHB_lock "
if [ -f ${gcFlag_PSHB_Lock} ];then
    n=0
	#~ /usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Pupsave Backup is already running."
	#~ exit 1
fi
touch ${gcFlag_PSHB_Lock}


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_Splash_Wait() {
# Begin Splash TarOpt
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/usr/lib/gtkdialog/box_splash -fg yellow -bg darkred -close never \
-text " 
  ${1} 
                          " &
	export GTKPIDRUNNING=$!
		sleep 1  
        # kill ${GTKPIDRUNNING}
} # end: PBKP_Splash_TarOpt


#---------------------------------
function PBKP_cleanup() {
    n=0
	rm -rf ${gcFlag_PSHB_Lock}
	busybox ps | grep 'PBKP_PUPSAVE_HOT_BKP' | grep -v grep | awk '{print $1}' | \
	#
    while read pid ; do kill $pid ; done
    #
	# returns to             echo "(ft14) exit 0"  
} # end: fx(PBKP_cleanup)
export -f PBKP_cleanup
trap PBKP_cleanup SIGHUP SIGINT SIGTERM

#--- main ---------------------------------------------------------------------
# Verify frugal type installation.
. /etc/rc.d/PUPSTATE
export PUPMODE
case $PUPMODE in
	12|13) ok=1 ;;
	*) ERRORMSG="Hot Backup can only be used if there is an active pupsave..." ;;
esac


#--- main ---------------------------------------------------------------------
if [ "$ERRORMSG" ] ; then
	cleanup
	echo "$ERRORMSG"
	ERRORMSG="<b><span foreground='"'red'"'>${ERRORMSG}</span></b>
"
	[ $DISPLAY ] && PBKP_Help_Box
	cleanup
	exit 1
fi

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function ERROR_RESTART() {
	#~ /usr/lib/gtkdialog/box_ok "Pupsave Backup" error "$@"
	cleanup
	pupsave-backup &
} # end: fx(ERROR_RESTART)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_MBrequired() { # $PBKP_PUPSAVE_PATH
	a=$(du -c -m -s "$1") #-c = --total, -m = --block-size=1m, -s = --summarize
	read -r aa bb <<< "$a"
	echo -n "MB required: $aa  [might need even more]"
} # end: fx(PBKP_MBrequired)

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_MBavailable() { # $PBKP_BACKUP_PATH $PBKP_PUPSAVE_PATH

	bkp="${1}"
	case "$bkp" in
		"/mnt/home"*|"/initrd/mnt/dev_save"*) drv="dev_save" ;;
		"/mnt/"*) drv="`echo "$bkp" | cut -f 3 -d '/'`";;
		*) ERROR_RESTART "You can only back up a pupsave to a device mounted on /mnt ..." ; return 1 ;;
	esac

    #~ Show_SplashIt "(mb1) begin 'MBavailable'" "black" "green" "3" 
    #~ Show_SplashIt "(mb1)" "black" "green" "3" 
    # gae, cannot call Show_SplashIt at this point, GUI will loop on timer. 

    echo "======= (mb1) =======" > /dev/console

	a="`df -k | grep "$drv" | awk '{ print $4 }'`"
	if [ "$a" = "" ] ; then
		a=0
	else
		a=$((a/1024)) #mb
	fi
	[ "$drv" = "dev_save" ] && drv="/initrd/mnt/dev_save"
	lbldrv="/mnt/$drv"
	[ "$drv" = "/initrd/mnt/dev_save" ] && lbldrv=$drv
	#-
	fs=$(grep "${drv} " /proc/mounts | cut -f 3 -d ' ')
	if [ "$fs" = "" ] ; then
		ERROR_RESTART "$drv: STORAGE DEVICE NOT MOUNTED... You can only back up a pupsave to a device mounted on /mnt"
		return 1
	fi
	if [ "$SAVEFOLDER" ] ; then
		case $fs in ext[2-4]) ok=1 ;;
			*) ERROR_RESTART "$drv has a invalid filesystem: $fs ... You can only back up savefolders to a ext2/ext3/ext4 partition..." ; return 1 ;;
		esac
	fi
	aa="$(du -c -m -s "$2")" #-c = --total, -m = --block-size=1m, -s = --summarize # error flag on Zero-length file 
	read -r b ccc <<< "$aa"
	#-
	echo -n "MB available on ${lbldrv}: $a"
	if [ $((a-b)) -le 100 ]; then # not enough space
		/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "NOT ENOUGH FREE DISK SPACE on $drv..."
		return 1
	fi

} # end: fx(PBKP_MBavailable)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_Bkpfilename() { # $PBKP_PUPSAVE_PATH
	echo -n "Backup file name: ${PBKP_PUPSAVE_NAME}.BKP-`date +%Y.%m.%d_%H%M.%S`"
} # end: fx(PBKP_Bkpfilename)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_validate_BACKUP_location() { # $PBKP_BACKUP_PATH
	if [ "${1}" != "" ]; then 
		IFS="/" read -r a direntry level2 level3 level4 <<< "${1}"
		#                /mnt     /home  /psubidir                /mnt/sda2/etc
		if [ "$direntry" = "mnt" ] && [ "$level2" != "" ] ; then
			echo -n "${1}"
		elif [ "$direntry"/"$level2" = "initrd/mnt" ] && [ "$level3" != "" ] ; then
			echo -n "${1}"
		fi
    else
		echo -n "$PBKP_LOCDEFAULT"
	fi
} # end: fx(PBKP_validate_BACKUP_location)
 

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function compression_dialog() {
    n=0

            TAROPT="-z"
            TAREXT='tar.gz'
            TAROPT="-c -z --checkpoint=1000" 

#~ /usr/lib/gtkdialog/box_yesno "Pupsave Backup-Compress" "Do you want to compress the backup ${destfile} ?

#~ May take a bit longer but save some space."
	#~ if [ $? -eq 0 ] ; then # yes
		#~ /usr/lib/gtkdialog/box_yesno --yes-label "gzip" --no-label "xz" --yes-icon "gtk-execute" --no-icon "gtk-execute" \
		#~ "Pupsave Backup-Compress" "Select compression type: 'gzip' or 'xz'"
		#~ if [ $? -eq 0 ] ; then
			#~ TAROPT="-z"
			#~ TAREXT='tar.gz'
		#~ else
			#~ TAROPT="-J"
			#~ TAREXT='tar.xz'
		#~ fi
	#~ fi
} # end: fx(compression_dialog)


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function PBKP_Backup() { #$PBKP_PUPSAVE_PATH $PBKP_BACKUP_PATH
    lcBackupColor="yellow"
    echo "(B1) running fx(Backup)"

	destfile=".${2}"/"`expr "${1}" | awk -F / '{print $NF}'`".PBKP-`date +%Y.%m.%d_%H%M.%S`

	if [ $PUPMODE -eq 13 ] ; then #flash

        PBKP_Splash_Wait "nice -19 snapmergepuppy"
        echo "(B2) Begin Mode = 13  : nice -19  SMP to save${type}"
        #;;;;;;;;;;;;;;;;;;;;;;;;;
        nice -19 snapmergepuppy
        #;;;;;;;;;;;;;;;;;;;;;;;;;
        echo "(B2) End Mode = 13    : nice -19  SMP to save${type}"
	    kill ${GTKPIDRUNNING}

	else
			return 1 # error if not Mode 13 Frugal. 
    fi

    echo "(B3) move XLOADED > & sync  ==="
	mv /root/.XLOADED /etc/xloadedx
	sync
	sleep 0.5

	CWDIR=$PWD

	if [ "$SAVEFOLDER" ] ; then   # DIRECTORY

        echo "(TO) $SAVEFOLDER (?) is saveDIRECTORY"
# working gae    value in SAVEFOLDER
read

		compression_dialog #set TAROPT TAREXT

		[ "$TAROPT" ] && destfile=${destfile}.${TAREXT}

		if [ "$TAROPT" ] ; then
			echo ; echo "tar ${TAROPT} -f ${destfile##*/} ${1##*/}/" #debug
            echo "" ; echo "(TO) Begin TarOpt :${TAROPT}:FILE.DIRECTORY:" ; echo "=== Begin Creating ${destfile##*/}" ; echo "==============" 
            

			cd ${1%/*} # dirname $PBKP_PUPSAVE_PATH
			# basename destfile / basename $PBKP_PUPSAVE_PATH

            PBKP_Splash_Wait "TarOpt  Creating ${destfile##*/}"

            #~ TAROPT="-z"
            #~ TAREXT='tar.gz'
            #~ TAROPT="-c -z --checkpoint=1000" 
            destfile=${destfile}.${TAREXT}
 
            #===========================================================
			tar ${TAROPT} -f ${destfile##*/} ${1##*/}/
            #===========================================================

			RETVAL=$?
            echo "" ; echo "(TO) end TarOpt :${TAROPT}: FILE.DIRECTORY:" ; echo "=============="
 
		    kill ${GTKPIDRUNNING}
            # End Splash TarOpt
			cd "$CWDIR"
			sync
     
		else

        	mkdir -p ${destfile}
			if which rsync ; then
				rsync -aX ${1}/ ${destfile}/
				RETVAL=$?
			else
				find "${1}" -mindepth 1 -maxdepth 1 | while read i ; do
					cp -a --remove-destination ${i} ${destfile}/
					RETVAL=$?
					sync
				done
			fi
			sync

		fi
	    
    else # save "file.4FS", so run coniptions e2fsck on file.4FS

        echo "(B5) else save file.4FS"
        echo "(TO) ${SAVEFOLDER} (?) is saveFILE.4FS"
# working gae    value in SAVEFOLDER
read

		compression_dialog #set TAROPT TAREXT

        destfile=${destfile}.${TAREXT}

        echo "(B6) copy ${1}'XLOADED' to ${destfile} for e2fsck "
		cp -f -v "${1}" "${destfile}" 2> /dev/null
		RETVAL=$? # not used 
		sync

        echo "(B7) e2fsck -y ${destfile} ======="
		e2fsck -y "${destfile}" 2> /dev/null
                     #~ -p                   Automatic repair (no questions)
                     #~ -n                   Make no changes to the filesystem
                        #~ -y                   Assume "yes" to all questions
                     #~ -c                   Check for bad blocks and add them to the badblock list
                     #~ -f                   Force checking even if filesystem is marked clean
                     #~ -v                   Be verbose
                     #~ -b superblock        Use alternative superblock
                     #~ -B blocksize         Force blocksize when looking for superblock
                     #~ -j external_journal  Set location of the external journal
                     #~ -l bad_blocks_file   Add to badblocks list
                     #~ -L bad_blocks_file   Set badblocks list
                     #~ -z undo_file         Create an undo file

		if [ "$TAROPT" ] ; then
			echo ; echo "tar ${TAROPT} -f ${destfile##*/} ${1##*/}/" #debug
            echo "" ; echo "(TO) begin TarOpt :${TAROPT}:File.4FS:" ; echo "=== Begin Creating ${destfile##*/}" ; echo "=============="
            
			cd ${1%/*} # dirname $PBKP_PUPSAVE_PATH

            PBKP_Splash_Wait "TarOpt  Creating ${destfile##*/}"

            #~ TAROPT="-z"
            #~ TAREXT='tar.gz'
            #~ TAROPT="-c -z --checkpoint=1000" 

			prevdfile=${destfile}
			destfile=${destfile}.${TAREXT}


            #===========================================================
			tar ${TAROPT} -f ${destfile##*/} ${prevdfile##*/} #basename $destfile
            #===========================================================

			RETVAL=$?
			rm -f $prevdfile

		    kill ${GTKPIDRUNNING}
            # End Splash TarOpt
            echo "" ; echo "(TO) end TarOpt :${TAROPT}: FOLDER:" ; echo "=============="

		fi
	fi
    
    echo "(B8) move '/etc/xloadedx' back into to orig subdir"
	mv /etc/xloadedx /root/.XLOADED
	sync

	if [ $RETVAL -eq 0 ] ; then

        PBKP_Splash_Wait "(B9) Save${type} Backup Completed:
        ---DONE---"
        sleep 5
        kill ${GTKPIDRUNNING}
        #~ /usr/lib/gtkdialog/box_ok "Pupsave Backup" complete "(B9) Save${type} Backup Completed:
        #~ ---DONE---
        #~ ${destfile}"
        return 0
	else
		rm -rf $destfile
		/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Error(s) creating $destfile"
		return 1
	fi
} # end: fx(PBKP_Backup)
#======================================================================================


##################################### Execution #######################################
#####################################   main()  #######################################


#Find and verify path of currently mounted save file.
SF="`echo $PUPSAVE | cut -f 3 -d ","`" # /savefilename or /xxx/savefilename

lcMsgStr="(M)--- Main(${gcZeroRun}) --- (${SF})"
echo "(M)--- Main( ${gcZeroRun} ) --- (${SF})"  #  2> /dev/null

if [ ! "$SF" ] ; then
	/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "Currently using a full partition..."
	cleanup
	exit
fi

#SF=${SF#/}
if [ ! -e "/mnt/home${SF}" ]; then
	/usr/lib/gtkdialog/box_ok "Pupsave Backup" error "'/mnt/home${SF}' does not exist!"
	cleanup
	exit 1

elif [ -d "/mnt/home${SF}" ]; then  # saveDirectory

    echo "(M) SF = saveDIRECTOIRY" # 
    export SaveFolderType="Directory"
	export SAVEFOLDER=1
	export REFRESH_INTERVAL=1000 #1 seconds
	export type=folder

else # saveFolder

    echo "(M) SF = saveFOLDER" # > /dev/console
    export SaveFolderType="Folder"
	export SAVEFOLDER=0
	export REFRESH_INTERVAL=1000 #1 seconds
	export type=file
fi

# Export variables
export PBKP_PUPSAVE_PATH="/mnt/home${SF}"
export PBKP_PUPSAVE_NAME="${SF##*/}" #${SF##*/} = basename $SF
export PBKP_LOCDEFAULT="/mnt/home${PSUBDIR}"
export PBKP_BACKUP_PATH=$(PBKP_validate_BACKUP_location)

case "$PBKP_PUPSAVE_NAME" in *".BKP-"*)   # test for dupe filename 
	/usr/lib/gtkdialog/box_ok "Pupsave Backup" warning "'${PBKP_PUPSAVE_NAME}' seems to be a file produced by this script. It's not advised to use it, the file name might become too large..."
esac
# Exported functions
export -f compression_dialog ERROR_RESTART PBKP_MBrequired PBKP_MBavailable PBKP_Bkpfilename PBKP_Backup PBKP_validate_BACKUP_location

# For fileselect dialog default directory
cd /mnt

echo "(G) begin GUI"  # > /dev/console
   
# Some escapement is necessary when this sed is used to allow comments in gui.
# MainGUI Main GUI 

export lcGuiTitle="Pupsave_HotBackup for Frugal Pups : '${SaveFolderType}'  '${gcSysID}' :"
export PBKP_PUPSAVE_HOT_BKP='
<window title="'${lcGuiTitle}'" icon-name="gtk-convert" default_width="650">
   <vbox>
      <frame>
         <text editable="false" use-markup="true" xalign="0.001">
            <label>"<span color='"'blue'"'>Pupsave '${type}' to backup</span>"</label>
         </text>
         <hbox>
            <entry editable="false">
               <variable>PBKP_PUPSAVE_PATH</variable>
               <sensitive>"false"</sensitive>
               <input>echo -n "'\$PBKP_PUPSAVE_PATH'"</input>
            </entry>
         </hbox>
         <text editable="false" use-markup="true" xalign="0.001">
            <label>"<span color='"'blue'"'>Save backup to /mnt/??</span>"</label>
         </text>
         <hbox>
            <entry editable="false" accept="directory">
               <variable>PBKP_BACKUP_PATH</variable>
               <input>PBKP_validate_BACKUP_location "'\$PBKP_BACKUP_PATH'"</input>
            </entry>
            <button>
               <input file stock="gtk-open"></input>
               <action type="fileselect">PBKP_BACKUP_PATH</action>
               <action>refresh:TEXT2</action>
            </button>
         </hbox>
      </frame>
      <frame Information>
         <text height-request="" xalign="0">
            <variable>TEXT1</variable>
            <input>PBKP_MBrequired "'\$PBKP_PUPSAVE_PATH'"</input>
         </text>
         <text height-request="20" xalign="0">
            <variable>TEXT2</variable>
            <input>PBKP_MBavailable "'\$PBKP_BACKUP_PATH'" "'\$PBKP_PUPSAVE_PATH'"</input>
         </text>
         <text height-request="20" xalign="0">
            <variable>BKPFILE</variable>
            <input>PBKP_Bkpfilename "'\$PBKP_PUPSAVE_PATH'"</input>
         </text>
         <timer milliseconds="true" interval="'${REFRESH_INTERVAL}'" visible="false"> 
           <action>refresh:TEXT1</action>
           <action>refresh:TEXT2</action>
           <action>refresh:BKPFILE</action>
           <action>refresh:PBKP_BACKUP_PATH</action>
         </timer>
      </frame>
      <hbox>
         <button help><action>PBKP_Help_Box &</action></button>
         <button>
            <input file icon="gtk-save"></input>
            <label>Backup</label>
            <action>EXIT:BACKUP</action>
            <action>PBKP_Backup "'\$PBKP_PUPSAVE_PATH'" "'\$PBKP_BACKUP_PATH'" &</action>
         </button>
         <button use-stock="true" label="gtk-quit" has-focus="true">
            <action>EXIT:QUIT</action>
         </button>
      </hbox>
   </vbox>
</window>
'
eval "`gtkdialog --center -p PBKP_PUPSAVE_HOT_BKP`"

         #~ <button use-stock="true" label="BACKIT" has-focus="true">
            #~ <action>EXIT:BACKIT</action>
         #~ </button>



#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ "$EXIT" = "BACKUP" ] ; then  # Gui First Call 
 
    echo "(ft11) Gui ${EXIT} = BACKUP ::gcZeroRun=${gcZeroRun}:" > /dev/console

	if PBKP_MBavailable "$PBKP_BACKUP_PATH" ; then
        echo "(ft12) MKBavailable : RETVAL=:${RETVAL}:gcZeroRun=${gcZeroRun}:"

        # Calls Main Backup 
		if PBKP_Backup "$PBKP_PUPSAVE_PATH" "$PBKP_BACKUP_PATH" ; then 
            echo "(ft13) PBKP_Backup: RETVAL={$RETVAL}: gcZeroRun=${gcZeroRun}:" 
			cleanup
            echo "(ft14) exit 0 : if PBKP_Backup is OK" 
            read
#~ . "${gcZeroRun}" 
			cleanup
            PHB_ReStart
			exit 0 #success
		fi
        echo "(ft15) : if PBKP_Backup is NOT"
        echo "(ft15X) exit 0 : if PBKP_Backup is NOT"
        read
        #~ . "${gcZeroRun}" 
        PHB_ReStart

	fi
	# error ? recovery is via ReStart 
    echo "(ft16) Cleanup, cd : RETVAL={$RETVAL}:gcZeroRun=${gcZeroRun}:"    
    echo ""
	cleanup
	cd -
    #~ echo "(ft17) now,     . ${gcZeroRun} . ${gcZeroRun1} . ${gcZeroRun2} "    
    echo "(ft17X . { gcZeroRun } ReStart only works when called directly from PATH location"    
    echo "${0}"

	exit 1 
    echo " last exit 1 call "
#~ read

fi # end: if [ "$EXIT" = "BACKUP" ]

        #~ # Calls Main Backup 
		#~ if PBKP_Backup "$PBKP_PUPSAVE_PATH" "$PBKP_BACKUP_PATH" ; then 
            #~ echo "(ft13) PBKP_Backup: RETVAL={$RETVAL}: gcZeroRun=${gcZeroRun}:" 
			#~ cleanup
            #~ echo "(ft14) exit 0 : if PBKP_Backup is OK" 
			#~ exit 0 #success
            #~ echo "(ft14x) after exit 0 : if PBKP_Backup is OK" 
		#~ fi
        #~ echo "(ft15) : if PBKP_Backup is NOT"
	#~ fi
	#~ # error ? recovery is via ReStart 
    #~ echo "(ft16) Cleanup, cd : RETVAL={$RETVAL}:gcZeroRun=${gcZeroRun}:"    
    #~ echo ""
	#~ cleanup
	#~ cd -
#~ echo "(ft17) now,     . ${gcZeroRun} . ${gcZeroRun1} . ${gcZeroRun2} "    
    #~ echo "(ft17X . ReStart only works when called directly from PATH location"    
    #~ echo "${0}"

#~ . "${gcZeroRun}" 

#~ exit 1 
#~ echo " last exit 1 call "
#~ fi # end: if [ "$EXIT" = "BACKUP" ]

#~ echo "(ft31 . { after  if [ "$EXIT" = "BACKUP" ]"    

#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#~ if [ "$EXIT" = "BACKIT" ] ; then  # Gui First Call 
    #~ n=0
    #~ echo "(ft21) Gui ${EXIT} = BACKIT :gcZeroRun=${gcZeroRun}:" 
    #~ echo ""
	#~ cleanup
	#~ cd -
#~ fi # end: if [ "$EXIT" = "BACKIT" ]

#;;; FALL-THRU ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
if [ "$EXIT" = "QUIT" ] ; then  # Gui First Call 
    n=0
    echo "(ft22) Gui ${EXIT} = QUIT :gcZeroRun=${gcZeroRun}:" 
    echo ""
	cleanup
	cd -
fi # end: if [ "$EXIT" = "QUIT" ]

    echo "(ft32 . { after  if [ "$EXIT" = "QUIT" ]"    


# Catch-All: Else $EXIT="FallThru" 
echo "(ft21) Catch-All: calling cleanup "
cleanup
echo "(ft22) After Catch-All === END === "  

### END ###
