#(: ======================================================================
#(: fx(Sbr_Str2DevTrm)   #: ACTIVE   # 230114-0800  # MGR.sh
#(: called by: 
#(: param: 
#(: purpose: 
#(: calls: 
#(: method: 
#(: sends: 
#(: rationale: 
#(: note :   
# ## 
# ## Str2DevTrm displays to "/dev/console"  as used by rc.sysinit and rc.shutdown 
# ##
# ## version for Geany BASH LxTerminal ( "Str2Trm" used by MGR.sh is embedded in MGR.sh )
# ##
    # ## called by Main ()
    # ## purpose: Standard Message-2-Terminal routine 
    # ##    designed for use from Geany Execute Terminal 
	# ##    does not display into /dev/console 
	# ##		unless ReDirect lcDevConsole=" > /dev/console" is enabled. 
    # ## param: "char string" "# color" "# margin"
    # ## purpose : generate system date/time constants.
    # ## rationale : One Time Manual Entry   for Geany "terminal" use.
    # ## note :
    # ##		bash can're-type' under some circumstances. 
# ##
# ## if using Geany "BASH terminal" for tracing, 
# ## then must use Sbr_Str2DevTrm() 
# ## which is done in MGR.sh, E3R.sh, S2F.sh, C3C.sh, CTB.sh, GTK.sh, et al .  
# ##
    # ## usage:
    # ##    Sbr_Str2DevTrm "string" "color" "margin"
    # ##    Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    # ##    Sbr_Str2DevTrm "$lcMsgStr" "2" 15
    # ##    Sbr_Str2DevTrm "$lcMsgStr"  3  10
	# ##
    # ##  Shell script variables are not "typesafe,	
    # ##	BASH will 'type convert'  char vs number
    # ## example:
    # ##    lcMsgStr="xxx" && Sbr_Str2DevTrm "$lcMsgStr" "2" "3"
    # ##    lcMsgStr="xxx" && Sbr_Str2DevTrm "$lcMsgStr"  2    3
	# ##
    # ## returns: action
	# ##
# ## alternative tests : param zero check and substitution:
# ## [ -z "${1}" ] && lcParStr="message"	# ## string
# ## [ -z "${2}" ] && lcParClr="5"  # ## color :  1,2,3,4,5   for  red,grn,yel,blu,pur
# ## [ -z "${3}" ] && lcParMrg="3"  # ## margin : 1,2,3,4,5  where mrg=5,10,15,20,25,30
# 




#(! ####################################################################
function Sbr_Str2DevTrm() {   #: ACTIVE
# ## capture all params
lcS2TStr=${1}   # ## STRING message 
lcS2TClr=${2}   # ## COLOR name or number
lcS2TMrg=${3}   # ## MARGIN number 1,5,10 ... 2,3,4,5,etc
# ## 
lcS2Topt=${4}	# ## "C"onsole "T"erminal
# 
lcDevConsole=""	# ## default to "T"erminal 
# 
# ## Sbr_Str2DevTrm	##########################################
# ##   Control ReDirect to "Console" or "Terminal" 
# ##   Normal default to "T"erminial 
# 
# ## ReDirect 
case "${lcS2Topt}" in
   "C") lcDevConsole=" > /dev/console" ;; 
   "T") lcDevConsole="" ;; 
    *)  lcDevConsole="" ;;	#: default Geany "T"erminal mode
esac
# 
# ## Sbr_Str2DevTrm	##########################################
# ## if exist, then trap margin from param#3  as "number"|"char"   
# ## default left-margin=10 for Sbr_Str2DevTrm
# ## if ${lcDevConsole} ;; used for margin, then error = "ambigious redirect" 
# ## if margin, then use it.
# ## Margin: 
case "${lcS2TMrg}" in
   0|"0") /bin/echo -n -e "\\033[0G"    >/dev/console ;; 
    *) /bin/echo -n -e "\\033[${lcS2TMrg}G"    >/dev/console ;;
esac
# ## 
# ## Sbr_Str2DevTrm	##########################################
# ## trap color from param#2  "name"|"number"   ### default is "3" 
#(:
#(: Color Pattern for "most" BASH versions: 
#(: color trap  from param#2  "name"|"number"   ## default is "3" 
#(: Color: 1    2    3    4    5    6    7    8     9     10
#(: Color: red, grn, yel, blu, pur, cyn, wht, wblu, wgrn, wgry
#(:
#(: Color Trap from user defined:
case "${lcS2TClr}" in
		#(:  numbers only version 
		""|"0")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;;
        # :	 "1"|"red")      /bin/echo -n -e "\\033[1;31m"   ${lcDevConsole} ;;
        # :	 "2"|"green")      /bin/echo -n -e "\\033[1;32m"   ${lcDevConsole} ;;
        # :	 "3"|"yellow")      /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;;
		 *)  /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; 
esac



# ## Color: red, grn, yel, blu, pur, cyn, wht, wblu, wgrn, wgry
# ## if color, then use it. 
#(:  numbers only version 
case "${lcS2TClr}" in
    ""|"0") /bin/echo -n -e "\\033[1;33m"   ${lcDevConsole} ;; #: default to yellow
                #(:  colors and/or numbers version 
                #~ red|"1") /bin/echo -n -e "\\033[1;31m"    >/dev/console ;;
                #~ grn|"2") /bin/echo -n -e "\\033[1;32m"    >/dev/console ;;
                #~ yel|"3") /bin/echo -n -e "\\033[1;33m"    >/dev/console ;; 
                #~ blu|"4") /bin/echo -n -e "\\033[1;34m"    >/dev/console ;;
                #~ pur|"5") /bin/echo -n -e "\\033[1;35m"    >/dev/console ;;
                #~ cyn|"6") /bin/echo -n -e "\\033[1;36m"    >/dev/console ;;
                #~ wht|"7") /bin/echo -n -e "\\033[1;37m"    >/dev/console ;;
                #~ wblu|"8") /bin/echo -n -e "\\033[4;7;30m"    >/dev/console ;; # ## blu   
                #~ wgrn|"9") /bin/echo -n -e "\\033[3;7;30m"    >/dev/console ;; # ## grn
                #~ wgry|"10") /bin/echo -n -e "\\033[5;7;30m"    >/dev/console ;; # ## gry
    *)      /bin/echo -n -e "\\033[1;3${lcS2TClr}m"   ${lcDevConsole} ;; #: inject specific color nbr
esac
# ##
            # working gae Sbr_Str2DevTrm
            # ## Sbr_Str2DevTrm	###########################################
            #~ case "${lcS2TStr}" in
                #~ "=00") lcS2TStr="== test 00" ;;
                #~ "=10") lcS2TStr="== test 10" ;;
                #~ "") lcS2TStr="== test 20 ==========" ;;
                #~ "=30") lcS2TStr="== test 30 ====================" ;;
                #~ "=40") lcS2TStr="== test 40 ==============================" ;;
                #~ "=45") lcS2TStr="== test 45 ==============================" ;;
                #~ "=50") lcS2TStr="== test 50 ==============================" ;;
                #~ *)  lcS2TStr="{lcS2TStr}" ;;
            #~ esac
# ##
# ## Sbr_Str2DevTrm	###########################################
# ##   ${lcDevConsole}
	/bin/echo -n "${lcS2TStr}"  ${lcDevConsole} 
	/bin/echo -e "\\033[0;m"  ${lcDevConsole} 
	return  0
# ##
} #
# end: fx(Sbr_Str2DevTrm)
#:######################################################################
#:######################################################################
#:######################################################################



#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(:
#(: Sys_Str2DevTrm : 
#(: note: designed for use from Geany Execute LXTerminal as "local" output. 
#(:       does not display into /dev/console 
#(: 			unless lcDevConsole=" > /dev/console" 
#(:       terminal = /usr/bin/xterm -e bash -c -e "/bin/sh %c"
#(:
lcDevConsole=""  
#(: lcDevConsole = ""  is local default to GEANY "T"erminal Only Display
#(: IF " > /dev/console" = lcDevConsole   
#(:      THEN std out display is "Terminal"     ( CTB terminal runs in the light ). 
#(: IF "" 
#(:      THEN std out display is to "Console"   ( CTB terminal will run in the dark ).
#(:
#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#(: called by: all messages directed to /dev/console or Geany Terminal 
#(: called by: rc.sysinit and rc.shutdown 
#(: param : "string" "color" "margin"
#(: purpose: Str2DevTrm is Standard "Message-2-Display" routine 
#(:     polymorphic design for use from Geany Execute LxTerminal 
#(:     does not display into /dev/console 
#(: 	controlled via :  lcDevConsole=" > /dev/console" 
#(: calls: /bin/echo
#(: method:  polymorphic active "String to Display" 
#(: 	terminal = /usr/bin/xterm -e bash -c -e "/bin/sh %c"
#(: sends: 
#(: rationale : for Geany "terminal" use.
#(:             copied into CTB for encapsulation 
#(: usage:
#(:     Sys_Str2DevTrm "string" "color" "margin"
#(: 	like this:
#(:     lcMsgStr="ABCDEFG"
#(:     Sys_Str2DevTrm "$lcMsgStr" "2" "3"
#(:     Sys_Str2DevTrm "$lcMsgStr"  2   3
#(:
#(: ###  Shell script variables are not "typesafe,	
#(: note: BASH will 'type convert'  char vs number 
#(: 	example:
#(:     lcMsgStr="xxx" && Sys_Str2DevTrm "$lcMsgStr" "2" "3"
#(:     lcMsgStr="xxx" && Sys_Str2DevTrm "$lcMsgStr"  2   3
#(: 
#(:  Str2DevTrm displays to "/Dev/Console" or "Terminal" . 
#(:  this version is for "Geany" "BASH" "LxTerminal"  
#(: 		( "Str2DevTrm" used by MGN.sh is embedded in MGN.sh , also)
#(: 
#(:  if using Geany "BASH terminal" for tracing, 
#(:  then must use fx(Sys_Str2DevTrm) set for "terminal" display. 
#(:  same process is done in 
#(:		MGN.sh, E3R.sh, S2F.sh, C3C.sh, CTB.sh, CTU.sh, etc.  
#(: 
#(: 
#(:  note: todo: dev param zero check and substitution:
#(:  [ -z "${1}" ] && lcParStr="message"	for string
#(:  [ -z "${2}" ] && lcParClr="5"	
#(:			for color : 1,2,3,4,5   or  red,grn,yel,blu,pur
#(:  [ -z "${3}" ] && lcParMrg="3"	
#(:			for  margin : 1,2,3,4,5 where mrg=5,10,15,20,25,30
#(:
#(:;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


